     ' This program serves three purposes. First, it shows how the ProBas
     ' routines can be used to give your software a highly polished and
     ' professional look.  Secondly, the source code provides real-life
     ' examples of how to use the routines.  Finally, the program acts as
     ' a tutorial on using the ProBas routines. The manual provides short
     ' examples of each routine.  Hopefully this program will provide
     ' added depth by examining some of the examples in more detail.
     '
     DEFINT A-Z
     REM $STATIC
     DIM SCR1(2000), SCR2(2000), SCR3(2000), SCR4(2000)
     DIM DAY$(7), VPOS(45)
     DECLARE FUNCTION Strip2$ (CPUS$)

     ' This program uses the CHAIN/COMMON statements to
     ' CHAIN to a number of "overlay" files for certain
     ' routines. All of the common definitions have been
     ' placed in the file COMDEF.BAS. We use the $INCLUDE
     ' metacommand to bring them in...

     REM $INCLUDE: 'COMDEF.BAS'

     DEF FNRAN (X) = ABS(INT(RND * X + 1))

     RANDOMIZE TIMER
     PAGE = 0
     LOCATE 23, 1, 0                                             ' locate and turn off the cursor

     BLACK = 0: BLUE = 1: GREEN = 2: CYAN = 3: RED = 4: MAG = 5  ' to enhance program readability...
     BROWN = 6: GREY = 7: LGREY = 8: LBLUE = 9: LGREEN = 10      ' we will define the standard colors...
     LCYAN = 11: LRED = 12: LMAG = 13: YELLOW = 14: WHITE = 15   ' using more descriptive variable names
     CALL CALCATTR(MAG, BLACK, TIMATTR)                          ' set the color for the on-screen clock

     A$ = "M": CALL SSRCH(A$, COMMAND$, NOMEM)                   ' check command line option for little memory
     A$ = "B": CALL SSRCH(A$, COMMAND$, MONO)                    ' check command line option for mono
     A$ = "H": CALL SSRCH(A$, COMMAND$, HIBACK)                  ' check command line option for blink

     '------------------ how to check the installed equipment ---------------

CheckTheSystem:

     ' This series of ProBas routines will check the computer
     ' and provide detailed information about the equipment
     ' installed:
     '
     ' 1  The type of processor (8088, 80186, 80286, 80386)
     ' 2  The processor speed in Mhz.
     ' 3  How much base memory is installed in kilobytes
     ' 4  Number of parallel printer ports installed
     ' 5  Number of serial ports installed
     ' 6  Number of game ports installed
     ' 7  The computer type (PC, XT, AT, Compaq, etc)
     ' 8  How much AT extended memory is installed in kilobytes
     ' 9  How much total L/I/M expanded (EMS) memory is installed
     ' 10 How much EMS memory is free and available for use
     ' 11 The type of monitor being used (color or monochrome)
     ' 12 If there is an EGA adapter running in EGA mode installed
     ' 13 If a mouse is installed, and if so, how many buttons it has
     ' 14 Version of DOS

     CALL PROCESSOR(CPUTYPE)                                     ' check the processor
     CALL CPUSPEED(CPUTYPE, MHZ)                                 ' check speed in Mhz
     CALL EQUIPMENT(MEMORY, PARALLEL, SERIAL, GAME)              ' check on available equipment
     CALL PCTYPE(COMPTYPE)                                       ' check the type of computer
        IF COMPTYPE = 252 THEN CALL GETEXTM(EXTMEMORY)           ' get amount of AT extended memory
     CALL GETCRT(COLORDISPLAY)                                   ' check if color or monochrome
     CALL GETVIDMODE(VMODE, VWIDTH, VPAGE)                       ' check video mode
     MONO = ((VMODE = 7) OR MONO)                                ' if mono then set a flag cause...
        IF MONO THEN BLUE = 0: RED = 0                           ' ...blue and red react differently on monochrome
     CALL GETEGA(EGA, EMEMSIZE)                                  ' check if running an ega board
     CALL GETVGA(VGA)                                            ' check if running a vga board
        IF COLORDISPLAY AND NOT Restart THEN                     ' if a CGA monitor, ask if they need snow suppression
           GOSUB AskAboutSnow
        END IF
        IF EGA OR VGA THEN                                       ' if ega or vga then...
           SCRMODE = -1                                          ' ... set fast screen mode
           IF NOT HIBACK THEN CALL BLINK(0)                      ' disable blink for high intensity backgrounds
       END IF
     CALL MMCHECK(MBUT)                                          ' returns 0 if no mouse or the number of mouse buttons
     MOUSE = (MBUT <> 0)                                         ' if mouse then set to -1 so we can use boolean NOT
     CALL GETDOSV(MAJ, MIN)                                      ' get dos version
     DOS$ = MID$(STR$(MAJ), 2) + "." + MID$(STR$(MIN), 2)        ' make it a string
     DRV$ = " ": CALL GETDRV(DRV$)                               ' get the current drive
     SUB$ = SPACE$(64)                                           ' set aside space for directory
     CALL GETSUB1("", SUB$, L, ECODE)                            ' get the current directory...
     CALL DRVSPACEL(DRV$, FREESPACE&)                            ' check the free space...
     CALL DISKSTAT(DRV$, FREE.CLUST, TOTAL.CLUST, BYTES.SEC, SECS.CLUST)' this routine can be used...
     CLUSTER.SIZE# = CDBL(BYTES.SEC) * CDBL(SECS.CLUST)          ' in place of DRVSPACE if more...
     FREE.DISK.SPACE# = CDBL(FREE.CLUST) * CLUSTER.SIZE#         ' detailed information is need.
     TOTAL.DISK.SPACE# = CDBL(TOTAL.CLUST) * CLUSTER.SIZE#

        IF Restart THEN GOTO Restart                             ' if returning from a CHAIN, set things up again...

     '--------------------- how to use the window manager -------------------

TheFirstScreen:

     ' This routine is the most simple application of the
     ' ProBas window manager routine.  We will show some of
     ' the more advanced features and capabilities a little
     ' later in the demo.
     '
     ' For our opening screen, we are going to draw a simple
     ' box with a double line frame and a window label.  We
     ' start by defining the top left corner's row/column and
     ' the bottom right row/column.  The window manager will
     ' automatically add 1 row and 1 column to each for the
     ' frame, even if you specify no visible frame.  To print
     ' a window with a top left corner at row 1, column 1, you
     ' must specify the location as row 2, column 2 so that
     ' the window manager can draw the frame starting at
     ' row 1, column 1.  Here is how you would set the size
     ' and location of a box filling the entire screen:
     '
     ' ULR=2      upper left row       (value between 2 and 24)
     ' ULC=2      upper left column    (value between 2 and 79)
     ' LRR=23     lower right row      (must be >ULR and < 25)
     ' LRC=79     lower right column   (must be >ULC and < 79)
     '
     ' The window manager allows five types of frames.  Set the
     ' variable FRAME for the frame desired:
     '   0 - no frame at all
     '   1 - single line frame
     '   2 - double line frame
     '   3 - single horizontal, double vertical
     '   4 - single vertical, double horizontal
     '
     ' We then set the foreground and background colors.
     ' The frame will be in the foreground color, and the
     ' rest of the window will be in the background color.
     '
     ' You may give the window a title or label by specifying
     ' a string to print in LABEL$.  The length of the string
     ' must be shorter than the width of the top row of the
     ' box. If it is longer, the WindowManager module will
     ' ignore it.
     '
     ' Most window routines print the label in the foreground
     ' color, just like the frame.  The WindowManager routine
     ' allows you to print the label in any color. Set the
     ' variable LABEL to the desired color. If no label is
     ' desired, set LABEL=-1 or LABEL$="". The WindowManager
     ' routine will not attempt to print a window label if:
     '   1 LABEL$=""
     '   2 LABEL=-1
     '   3 The length of LABEL$ is to long to fit the window
     '
     ' Exploding windows are flashy.  If you want your
     ' window to explode or grow, set the variable GROW=-1
     ' Exploding windows look best when they are rectangular
     ' in shape.
     '
     ' Shadowing a window provides a 3D effect, making it seem
     ' as if the window floats above the screen, casting a
     ' shadow.  The ProBas WindowManager routine not only
     ' allows shadowed windows, but allows selection of any of
     ' a wide range of color combinations or shades for the
     ' shadow.  You can even have an exploding window cast a
     ' shadow as it grows.  We will show full examples of
     ' shadowed windows later on.
     '
     ' The variable PAGE is used to specify the screen page to
     ' which to write (color and enhanced graphics monitors only).
     ' This lets you modify one screen page while displaying another.
     '
     ' For ease of programming, you need to set only the variables
     ' that are actually needed.  If you do not want to have a
     ' label, you need not set LABEL and LABEL$.  If you don't
     ' want an exploding window, leave GROW at 0.  For no shadow,
     ' leave SHADOW at 0.  The WindowManager routine will clear
     ' the LABEL$, GROW, and SHADOW variables after drawing each
     ' window.  All other variables are unchanged. We do this
     ' so that the routine will default to a standard window
     ' unless you specifically set one of these values prior to
     ' each call.  It makes debugging a lot easier.
     '
     ' We are now ready to  begin.  We set PAGE for page 1, and
     ' since what we are drawing will not be seen on the screen,
     ' we set the SCRMODE (snow suppression) to non-zero which
     ' disables snow suppression and makes the routines faster.
     ' We set the variables and call WindowManager.

     PAGE = 1                                                    ' write to page 1
     ULR = 2: ULC = 2: LRR = 24: LRC = 79: FRAME = 2             ' set size and position of box
     FORE = YELLOW: BACK = BLUE: LABEL = WHITE                   ' set colors
     LABEL$ = "ProBas Demonstration"                             ' text of label
     CALL WindowManager(ULR, ULC, LRR, LRC, FRAME, FORE, BACK, GROW, SHADOW, LABEL, LABEL$, PAGE, SCRMODE)

     '-------------------- draw large letters on the screen -----------------

     ' this section illustrates the use of the XQPRINT function
     ' to write directly to the screen.  This is far faster than
     ' the basic PRINT statement.  To avoid unnecessary typing, I
     ' like to put the CALL to XQPRINT into a subroutine down at
     ' the bottom of the program.  Then all I have to do is set
     ' the color using the CALCATTR routine, set the x/y position,
     ' and put the string to print in the variable A$.  Here's
     ' what the subroutine at label Xq looks like:
     '
     '    Xq:  CALL XQPRINT(A$,X,Y,ATTR,PAGE,SCRMODE)
     '         RETURN
     '
     ' This subroutine will print the text in A$ at row X,
     ' column Y, with the foreground/background color set by
     ' CALCATTR and stored in the variable ATTR to the screen page
     ' specified by the variable PAGE.  The snow suppression is
     ' controlled by SCRMODE.
     '
     ' We should take a moment to discuss snow suppression.  It
     ' is explained in detail in the manual but let's summarize.
     ' The direct write routines will NOT use snow suppression if:
     '
     '    A monochrome monitor is used
     '    The variable SCRMODE is set to non-zero
     '
     ' We now set the colors and draw the large letters to
     ' the screen:

     CALL CALCATTR(LMAG, BLACK, ATTR)                            ' set the fore/back colors
     B1$ = STRING$(4, 176)                                       ' draw an H
     B2$ = STRING$(3, 176)
     A$ = B1$
        FOR X = 3 TO 5
           Y = 13: GOSUB Xq: Y = 22: GOSUB Xq
        NEXT X
     X = 6: Y = 13: A$ = STRING$(13, 176): GOSUB Xq
     A$ = B1$
        FOR X = 7 TO 9
           Y = 13: GOSUB Xq: Y = 22: GOSUB Xq
        NEXT X
     CALL CALCATTR(WHITE, BLUE, ATTR)                            ' draw a "C"
     Y = 30
     X = 3: A$ = B1$ + B2$ + STRING$(3, 176): GOSUB Xq
     X = 4: A$ = B2$ + "    " + STRING$(3, 176): GOSUB Xq
     A$ = B2$
        FOR X = 5 TO 7
           GOSUB Xq
        NEXT X
     X = 8: A$ = B2$ + "    " + STRING$(3, 176): GOSUB Xq
     X = 9: A$ = B1$ + B2$ + STRING$(3, 176): GOSUB Xq
     CALL CALCATTR(BLACK, MAG, ATTR)                             ' gimme an "S"
     X = 3: Y = 44: A$ = B1$ + B2$ + STRING$(3, 176): GOSUB Xq
     X = 4: A$ = B2$: GOSUB Xq
     Y = 51: A$ = STRING$(3, 176): GOSUB Xq
     X = 5: Y = 44: A$ = B2$: GOSUB Xq
     X = 6: A$ = B1$ + B2$ + STRING$(3, 176): GOSUB Xq
     X = 7: Y = 51: A$ = STRING$(3, 176): GOSUB Xq
     X = 8: Y = 44: A$ = B2$: GOSUB Xq
     Y = 51: A$ = STRING$(3, 176): GOSUB Xq
     X = 9: Y = 44: A$ = B1$ + B2$ + STRING$(3, 176): GOSUB Xq
     CALL CALCATTR(YELLOW, WHITE, ATTR)                          ' gimme an "I"
     X = 3: Y = 57: A$ = B1$ + B2$ + B1$: GOSUB Xq
     Y = 61: A$ = B2$
        FOR X = 4 TO 8
           GOSUB Xq
        NEXT X
     X = 9: Y = 57: A$ = B1$ + B2$ + B1$: GOSUB Xq
     CALL CALCATTR(WHITE, BLUE, ATTR)                            ' fill in company name
     X = 10
     Y = 16: A$ = "Hammerly": GOSUB Xq
     Y = 31: A$ = "Computer": GOSUB Xq
     Y = 45: A$ = "Services": GOSUB Xq
     Y = 61: A$ = "Inc": GOSUB Xq

     CALL CALCATTR(LCYAN, BLUE, ATTR)
     X = 12: Y = 36
     A$ = "Presents": GOSUB Xq

     CALL CALCATTR(WHITE, LMAG, ATTR)                            ' set the fore/back colors
     B1$ = STRING$(4, 176)                                       ' draw a "P"
     B2$ = STRING$(3, 176)
     A$ = B1$
     Y = 6
     X = 14: A$ = STRING$(13, 176): GOSUB Xq
     A$ = B2$
        FOR X = 15 TO 17
          Y = 6: GOSUB Xq
          Y = 17: GOSUB Xq
        NEXT X
     X = 18: Y = 6: A$ = STRING$(13, 176): GOSUB Xq
     A$ = B2$
        FOR X = 19 TO 23
           GOSUB Xq
        NEXT X

     Y = 20                                                      'draw an "r"
     A$ = B2$
        FOR X = 19 TO 23
           GOSUB Xq
        NEXT X
     X = 19: Y = 24: A$ = B1$: GOSUB Xq
     X = 20: Y = 23: A$ = CHR$(176): GOSUB Xq

     Y = 29                                                      ' draw an "o"
     X = 19: A$ = STRING$(10, 176): GOSUB Xq
     X = 20: A$ = B2$
        FOR X = 20 TO 22
           Y = 29: GOSUB Xq
           Y = 36: GOSUB Xq
        NEXT X
     X = 23: Y = 29: A$ = STRING$(10, 176): GOSUB Xq

     X = 14: Y = 40: A$ = STRING$(13, 176): GOSUB Xq             ' draw a "B"
     Y = 41: A$ = B2$
        FOR X = 15 TO 17
           Y = 41: GOSUB Xq
           Y = 51: GOSUB Xq
        NEXT X
     X = 18: Y = 41: A$ = STRING$(12, 176): GOSUB Xq
     A$ = B2$
        FOR X = 19 TO 23
           Y = 41: GOSUB Xq
           Y = 51: GOSUB Xq
        NEXT X
     X = 23: Y = 40: A$ = STRING$(13, 176): GOSUB Xq

     X = 19: Y = 56: A$ = STRING$(9, 176): GOSUB Xq              ' draw an "a"
     Y = 62: A$ = B2$
        FOR X = 20 TO 23
           GOSUB Xq
        NEXT X
     Y = 55
        FOR X = 21 TO 23
           GOSUB Xq
        NEXT X
     Y = 58
     X = 21: A$ = STRING$(4, 176): GOSUB Xq
     X = 23: GOSUB Xq


     Y = 67: A$ = STRING$(10, 176)                               ' draw an "s"
        FOR X = 19 TO 23 STEP 2
           GOSUB Xq
        NEXT X
     X = 22: Y = 74: A$ = STRING$(3, 176): GOSUB Xq
     X = 20: Y = 67: GOSUB Xq

     '---------------------------- screen snapshots -------------------------
     '
     ' Now we will use one of the ProBas screen save routines
     ' to take a "snapshot" of the screen and store it in an
     ' array.  ProBas has a number of different routines to
     ' do this:
     '
     '   1  SCRSAVE    - saves the entire screen to a 2,000
     '                   element STATIC array (Pre-QB4 only).
     '   2  DSCRSAVE   - saves the entire screen to a 2,000
     '                   element STATIC or DYNAMIC array.
     '   3  GETSCREEN  - saves any portion of a screen to a
     '                   STATIC array (Pre-QB4).
     '   4  DGETSCREEN - same as GETSCREEN but allows you to
     '                   save the snapshot in either a
     '                   STATIC or a DYNAMIC array.
     '
     ' Any of these four routines could be used to take a
     ' snapshot of the entire screen.  The DSCRSAVE routine
     ' is easiest to use since you do not have to specify the
     ' size of the screen, or calculate the size of the screen
     ' as GETSCREEN and DGETSCREEN require, or the memory
     ' locations and offsets of the array for DGETSCREEN.
     '
     ' To really speed up the display, we have set PAGE=1
     ' and are displaying PAGE=0 so that all of the writing
     ' has been to the page that the user isn't seeing.
     ' We could use the basic SCREEN statement to change
     ' the current display page, or we could take a snapshot
     ' of the invisible page and restore it to the visible
     ' page.  That would make PAGE 0 and PAGE 1 identical.
     ' This is the same as the PCOPY command in the later
     ' versions of QB, but is faster.

     DSEG = VARSEG(SCR1(1)): DOFS = VARPTR(SCR1(1))
     CALL DSCRSAVE(DSEG, DOFS, PAGE, SCRMODE)                    ' take a snapshot of page 1
     PAGE = 0                                                    ' set the page to 0
     CALL DSCRREST(DSEG, DOFS, PAGE, SCRMODE)                    ' restore the snapshot to page 0

     ' This will work even on monochrome monitors that do
     ' not have screen memory since the ProBas will detect
     ' that an MDA is in use and ignore the PAGE.  With a
     ' monochrome monitor, the display will just print to
     ' the active page, which is the only page available.
     ' An even neater way to do what we just did is to use
     ' DWindowManager, DGETSCREEN, and DPUTSCREEN to draw
     ' the screen in a DYNAMIC array and then restore
     ' from array memory rather than display memory.  We'll
     ' show you how to do that later on.
     '
     ' Once the title page is displayed, let's wait for
     ' two seconds and then continue.  The DELAY routine
     ' will do that for us, regardless of the speed at
     ' which the computer is running.

     SECONDS = 2: CALL DELAY(SECONDS)                            ' wait for 2 full seconds

     ' We now draw a window for text...

     ULR = 6: ULC = 4: LRR = 21: LRC = 77: FRAME = 2
     FORE = WHITE: BACK = MAG: GROW = -1
     CALL WindowManager(ULR, ULC, LRR, LRC, FRAME, FORE, BACK, GROW, SHADOW, LABEL, LABEL$, PAGE, SCRMODE)

     ' One way to display text in a window is to put the text
     ' in a DATA statement and READ it in.  This stores the
     ' data outside the string area and helps eliminate the
     ' "string space corrupt" errors that occur when you run
     ' out of string space

     CALL CALCATTR(LCYAN, MAG, ATTR)                             ' set the fore/back for text
     RESTORE Intro1Data                                          ' restore the data statements
     Y = 5                                                       ' set the column position
        FOR X = 7 TO 19                                          ' loop from row 6 to 18
           READ A$                                               ' read a line of text
           GOSUB Xq                                              ' display a line of text
        NEXT X                                                   ' loop until done

     CALL CALCATTR(YELLOW, MAG, ATTR)                            ' set the color to 14,5
     X = 21: A$ = "Press ESC to exit or any other key to continue"' set the row and the text
     Y = 40 - LEN(A$) \ 2: GOSUB Xq                              ' center it (integer divide!) and print
     GOSUB SaveScreen2                                           ' take a snapshot and store in the SCR2 array

     CALL CLRKBD                                                 ' clear keyboard buffer of any waiting keystrokes
     CALL GETKEY3(MOUSE, CMD, CMD1, LFT, MID, RGT)               ' check for keypress or mouse click
        IF CMD = 27 THEN CALL CALCATTR(GREY, BLACK, ATTR): CALL DISSOLVE(ATTR): END
        IF CMD1 = 59 THEN GOTO VirtualScreen                     ' jump directly to the menu

     ' Draw another window and display more text...

     ULR = 6: ULC = 4: LRR = 21: LRC = 77: FRAME = 2
     FORE = LCYAN: BACK = RED: GROW = -1
     CALL WindowManager(ULR, ULC, LRR, LRC, FRAME, FORE, BACK, GROW, SHADOW, LABEL, LABEL$, PAGE, SCRMODE)
     CALL CALCATTR(WHITE, RED, ATTR)
     RESTORE Intro2Data
     Y = 5
        FOR X = 7 TO 19
           READ A$
           GOSUB Xq
        NEXT X
     GOSUB SaveScreen3                                           ' store snapshot in SCR3 array

     '---------------------------- mini slide show --------------------------
     '
     ' Here is one way to rapidly cycle through a set of
     ' screens.  In the demo we called this a "slide show".
     ' We are using the DSCRREST routine in a GOSUB to restore
     ' the entire screen.  You could speed things up even more
     ' by using the DPUTSCREEN routine and restoring just the
     ' desired portion of the screen.
     '
     ' By the way, DSCRSAVE, DSCRREST, DGETSCREEN, and DPUTSCREEN
     ' handle screens in a compatible format.

     CALL CLRKBD                                                 ' clear the keyboard buffer
     CALL GETKEY3(MOUSE, CMD, CMD1, LFT, MID, RGT)               ' check for keypress or mouse click
     GOSUB RestoreScreen                                         ' restore screen1
     CALL CLRKBD                                                 ' clear the keyboard buffer
     CALL GETKEY3(MOUSE, CMD, CMD1, LFT, MID, RGT)               ' check for keypress or mouse click
     GOSUB RestoreScreen2                                        ' restore screen2
     CALL CLRKBD                                                 ' clear the keyboard buffer
     CALL GETKEY3(MOUSE, CMD, CMD1, LFT, MID, RGT)               ' check for keypress or mouse click
     GOSUB RestoreScreen3                                        ' restore screen2
     CALL CLRKBD                                                 ' clear the keyboard buffer
     CALL GETKEY3(MOUSE, CMD, CMD1, LFT, MID, RGT)               ' check for keypress or mouse click

     ' Here is a window with a black shadow, giving a 3D
     ' effect or a "floating window".  All that was
     ' required was setting the variable SHADOW to either -1
     ' for a solid black shadow, or, as we do here, to -2 for
     ' a true shadow that recolors what is underneath.  When
     ' snow suppression is in effect, exploding windows may
     ' move too fast at times.  This depends on the processor,
     ' or co-processor, the version of the compiler, and what
     ' type of math library is being used.  With earlier
     ' versions of QB, slowing down exploding windows was a
     ' must, they just grew too fast.  Unfortunately, later
     ' versions of QB or BASCOM 6.0 with the IEEE math emulation
     ' are much slower unless you are compiling for a math
     ' co-processor.
     '
     ' Although we REM it out for BC6.0, We'll show you how to
     ' force a slowly exploding window by saving the screen mode
     ' and forcing it slow, but only on faster machines.
     ' Earlier on we use the PROCESSOR and CPUSPEED routines to
     ' check out the equipment we're currently running on.

     SS = SCRMODE                                                ' save the current screen access mode
        IF CPUTYPE > 2 THEN                                      ' if running an 80286 or 80386...
'           SCRMODE = 0                                           ' ... make things go slower...
        END IF
           IF MHZ > 8 THEN                                       ' if running faster than 8mhz....
'           SCRMODE = 0                                           ' ... make things go slower...
        END IF

     ' now that the speed is set, let's do the window...

     ULR = 4: ULC = 30: LRR = 17: LRC = 70: FRAME = 4
        IF MONO THEN FORE = RED ELSE FORE = WHITE
     BACK = GREY: LABEL = RED
     LABEL$ = "Windows!": GROW = -1: SHADOW = -2
     CALL WindowManager(ULR, ULC, LRR, LRC, FRAME, FORE, BACK, GROW, SHADOW, LABEL, LABEL$, PAGE, SCRMODE)
     SCRMODE = SS: SS = 0                                        ' reset scrmode variable
     CALL CALCATTR(BLUE, GREY, ATTR)                             ' set colors
     RESTORE Window1Data                                         ' restore the window text
     Y = 31                                                      ' set the column
        FOR X = 4 TO 8                                           ' loop thru...
           READ A$: GOSUB Xq                                     ' ...reading and writing....
        NEXT                                                     ' until done
     CALL CALCATTR(RED, GREY, ATTR)                              ' change colors
        FOR X = 9 TO 14                                          ' loop some more
           READ A$: GOSUB Xq                                     ' ...reading and writing....
        NEXT                                                     ' until done
     GOSUB SaveScreen2                                           ' save the screen

     ' Throughout the design of this demo, I have paid
     ' particular attention to presenting each ProBas
     ' routine in a logical progression.  However, this is the
     ' one exception.  The routine at "WonderWindows" draws
     ' 300 windows and peels them back off using the techniques
     ' and routines that are better and more easily explained
     ' in following sections. I promise that this is the
     ' only time I'll skip around and do this to you.
     '
     ' If the demo "locks" at this point or you get an out
     ' of memory error, you can bypass this routine (which
     ' requires a huge chunk of memory) by adding an M to the
     ' command line (i.e. A>DEMO M) as outlined in the DEMO.DOC
     ' file.  If you are compiling this in the environment,
     ' go to the RUN menu and put an M in the Command$.

     IF NOMEM THEN
        X = 16: CALL CALCATTR(BLUE, GREY, ATTR)                     ' set colors
        A$ = SPACE$(6) + "Press any key to continue": GOSUB Xq      ' print the last line of info window
        CALL CLRKBD                                                 ' clear the keyboard buffer
        CALL GETKEY3(MOUSE, CMD, CMD1, LFT, MID, RGT)               ' check for keypress or mouse click
        GOTO VirtualScreen                                          ' draw the main screen
     ELSE
        GOSUB WonderWindows
     END IF

     '----------------------------- virtual screens -------------------------

VirtualScreen:

     ' Before we get into designing the main menu, we are going
     ' to demonstrate yet another screen technique and a
     ' variation on the writing to an invisible screen page
     ' trick we used earlier.  This time we are going to use
     ' one of the more powerful features of QuickBASIC, the
     ' DYNAMIC array.
     '
     ' As you probably know, BASIC's variables are normally
     ' limited to the one 64k data segment.  Run out of data
     ' area and you're out of luck - unless the program can
     ' be chopped into smaller pieces and you use CHAIN.
     ' That's all well and good unless you are dealing with
     ' a chunk of a data base or data file that is bigger
     ' than 64K.
     '
     ' DYNAMIC arrays can be used to extend data storage.
     ' Using these redimensionable arrays, you can utilize
     ' all of the computer's available memory.  Later on we
     ' will show you how you can use ProBAS and DYNAMIC
     ' arrays to read in large amounts of data at high speeds,
     ' sort the data in this area, and some other very nice
     ' things.  For now we will show you how you can use
     ' a DYNAMIC array as one or more "virtual screens".
     '
     ' Drawing complex screens takes time, especially if you
     ' have to use snow suppression. To get that "professional"
     ' look, you don't want the user to see you build the
     ' screen -- you want it to snap on, fully drawn, in an
     ' eyeblink.  The basic SCREEN or the ProBas PAGE equate
     ' can be used to draw the complex screen on one page
     ' while the user is looking at another.  The "gotcha"
     ' to this is that you can't use that trick on monochrome
     ' monitors (and some clones with non-standard CGA like
     ' the Leading Edge PC), as they have only one page of
     ' screen memory!
     '
     ' By the way, the ProBas routines will ignore a PAGE
     ' other than 0 if a monochrome monitor is installed.
     ' Also, since snow is a by-product of color, the
     ' various screen routines will automatically shift to
     ' the fast mode if using a monochrome monitor.  You
     ' can override this with the SCRMODE variable.
     '
     ' ProBas gives you variations of the WindowManager,
     ' XQPRINT, GETSCREEN and PUTSCREEN routines that will
     ' allow you to "draw" the screen, in exactly the same
     ' manner, to either a STATIC or a DYNAMIC array.
     ' Instead of using XQPRINT and varying the PAGE, you
     ' use DXQPRINT and specify a STATIC or DYNAMIC array.
     '
     '     standard screen             virtual screen
     '   --------------------------------------------
     '     XQPRINT                     DXQPRINT
     '     GETSCREEN                   DGETSCREEN
     '     PUTSCREEN                   DPUTSCREEN
     '     WindowManager               DWindowManager
     '     CLS                         DCLEAR

     ' Let's demonstrate this by drawing a rather complex
     ' screen to a DYNAMIC virtual screen array.  First we
     ' calculate the size the array needs to be  - remember,
     ' we can work with an entire screen, or just a portion
     ' of it.  Here we'll specify an entire screen. The size
     ' the array needs to be is returned in ELEMENTS. (we
     ' already know that a full screen is 2000 elements, but
     ' we want to show how it's done)...

     ULR = 1: ULC = 1: LRR = 25: LRC = 80                        ' set the screen boundary
     CALL CALCSIZE(ULR, ULC, LRR, LRC, ELEMENTS)                 ' calculate the size to DIM

     REDIM DSCR1(ELEMENTS)                                       ' dim the array as dynamic

     ' now we need to set up variables that will tell the
     ' various ProBas routines which array to use, its
     ' memory location, and the offset within the array.

     DSEG = VARSEG(DSCR1(1))                                     ' get the segment
     DOFS = VARPTR(DSCR1(1))                                     ' get the offset

     ' If you are using a Pre-QB4 version of the compiler,
     ' which not have the VARSEG command, you must use the
     ' ProBas DYNPTR routine instead.  Here's how it would
     ' be done:
     '
     '   V!=VARPT(SCR1(1))
     '   CALL DYNPTR(V!,DSEG,DOFS)
     '
     ' By the way, NEVER attempt to use DYNPTR with QB4x versions
     ' of the compiler!
     '
     ' Now that we have the array ready, let's write to it.
     ' Since this screen will not be a full window, we
     ' need to to set the colors and prepare our virtual
     ' screen. This next set of routines is the functional
     ' equivalent of the BASIC statements:
     '    COLOR 5,0 : CLS

     FORE = MAG: BACK = BLACK                                    ' set the fore/back colors
     CALL CALCATTR(FORE, BACK, ATTR)                             ' calculate the attribute
     CALL DCLEAR(DSEG, DOFS, ATTR)                               ' clear the virtual screen

     ' While we're at it let's set some other colors...

     CALL CALCATTR(BLUE, GREY, ATTR1)                           ' colors of top line
     CALL CALCATTR(YELLOW, RED, ATTR2)                           ' colors of middle line

     ' These next routines are borrowed from HCSI's
     ' office automation system.  It draws a frame
     ' around the screen in magenta and fills in the
     ' top line and window headers with data.

     H1$ = SPACE$(78)
     A$ = "ProBas Demonstration Program" + SPACE$(26) + "Version 4.0 04/29/90"
     LS = (78 - LEN(A$)) \ 2
     H2$ = LEFT$(SPACE$(LS) + A$ + SPACE$(LS + 1), 78)
     A$ = "Main Menu"
     LS = (39 - LEN(A$)) \ 2
     H3$ = LEFT$(SPACE$(LS) + A$ + SPACE$(LS + 1), 39)
     TOP$ = CHR$(201) + STRING$(78, 205) + CHR$(187)
     L2$ = CHR$(186) + SPACE$(78) + CHR$(186)
     L3$ = CHR$(199) + STRING$(39, 196) + CHR$(194) + STRING$(38, 196) + CHR$(182)
     L5$ = CHR$(199) + STRING$(39, 196) + CHR$(197) + STRING$(38, 196) + CHR$(182)
     MIDL$ = CHR$(186) + SPACE$(39) + CHR$(179) + SPACE$(38) + CHR$(186)
     BOT$ = CHR$(200) + STRING$(39, 205) + CHR$(207) + STRING$(38, 205) + CHR$(188)
     Y = 1: YY = 2
     X = 1: A$ = TOP$: GOSUB DXq
     X = 2: A$ = L2$: GOSUB DXq
     CALL DXQPRINT(DSEG, DOFS, H1$, X, YY, ATTR1)
     CALL DXQPRINT(DSEG, DOFS, H2$, X, YY, ATTR1)
     X = 3: A$ = L3$: GOSUB DXq
     X = 4: A$ = MIDL$: GOSUB DXq
     CALL DXQPRINT(DSEG, DOFS, H3$, X, YY, ATTR2)
     X = 5: A$ = L5$: GOSUB DXq
     A$ = MIDL$
        FOR X = 6 TO 21
           GOSUB DXq
        NEXT X
     X = 22: A$ = BOT$: GOSUB DXq
     A$ = "": H1$ = "": H2$ = "": H3$ = "": TOP$ = ""            ' clear the garbage variables
     L2$ = "": L3$ = "": L5$ = "": MIDL$ = "": BOT$ = ""         ' clear the garbage variables

     ' this is another routine borrowed from our EMDACS Shell
     ' program.

     CALL CALCATTR(MAG, BLACK, ATTR): Y = 43
     X = 6: A$ = CHR$(218) + STRING$(34, 196) + CHR$(191): GOSUB DXq
     A$ = CHR$(179): Z = 78
        FOR X = 9 TO 20
           GOSUB DXq
           CALL DXQPRINT(DSEG, DOFS, A$, X, Z, ATTR)
        NEXT X
     X = 8: A$ = CHR$(195) + STRING$(34, 196) + CHR$(180): GOSUB DXq
     X = 7: A$ = CHR$(179) + SPACE$(34) + CHR$(179): GOSUB DXq
     CALL CALCATTR(BLUE, GREY, ATTR)
     Y = 44: A$ = " Su   Mo   Tu   We   Th   Fr   Sa ": GOSUB DXq
     CALL CALCATTR(BLUE, BLUE, ATTR)
     A$ = SPACE$(34)
        FOR X = 9 TO 20
          GOSUB DXq
        NEXT X
     CALL CALCATTR(MAG, BLACK, ATTR): Y = 43
     X = 21: A$ = CHR$(192) + STRING$(34, 196) + CHR$(217): GOSUB DXq
     RESTORE Cd
        FOR J = 1 TO 6
           READ VPOS(J)
        NEXT J
Cd:  DATA 48,53,58,63,68,73
     CALL CALCATTR(MAG, BLUE, ATTR)
     A$ = CHR$(179)
        FOR I = 9 TO 20
           FOR J = 1 TO 6
              CALL DXQPRINT(DSEG, DOFS, A$, I, VPOS(J), ATTR)
           NEXT J
        NEXT I
     A$ = "": T$ = "": B$ = STRING$(4, 196)
        FOR X = 1 TO 6
           T$ = T$ + B$ + CHR$(194)
           A$ = A$ + B$ + CHR$(197)
        NEXT X
     XLINE$ = A$ + B$: TLINE$ = T$ + B$
     CALL CALCATTR(MAG, BLUE, ATTR): Y = 44
     X = 9: A$ = TLINE$: GOSUB DXq
        FOR I = 10 TO 20 STEP 2
           CALL DXQPRINT(DSEG, DOFS, FLINE$, I, Y, ATTR)
           X = I + 1
           IF X < 21 THEN CALL DXQPRINT(DSEG, DOFS, XLINE$, X, Y, ATTR)
        NEXT I

     ' We've just drawn a calendar template to the virtual
     ' screen, complete with all of the little boxes.  We
     ' now fill in the days of the month:

     CALL DCalendar(DSCR1(), PAGE, SCRMODE)                               ' put numbers in the little boxes

     ' We now have text graphics on the screen, with
     ' a calendar for the current month on our virtual
     ' screen.  Next, let's fill in a menu of choices.
     ' What we will do here is to write the text of the
     ' menu choices to the virtual screen and let the ProBas
     ' routines handle highlighting the choices.  Before we
     ' perform the write, we will also set up the parms and
     ' variables we will need for the multi-window,
     ' multi-menu environment...

     '---------------------------- the main menu ----------------------------

MainMenu:
     OFFSET(1) = 4                                               ' offset for left window
     OFFSET(2) = 43                                              ' offset for right window
     COLACTIVE = 1                                               ' set the active window to 1
     ROW = 1: ROWSAVE = 1                                        ' set initial row
     LCOL(1) = OFFSET(COLACTIVE)                                 ' left side of highlight  Left window
     RCOL(1) = OFFSET(COLACTIVE) + 35                            ' right side of highlight Left window
     LCOL(2) = OFFSET(2)                                         ' left side of highlight  Right window
     RCOL(2) = OFFSET(2) + 35                                    ' right side of highlight Right window
     CALL CALCATTR(CYAN, BLACK, MAINATTR)                        ' set main color combination
     CALL CALCATTR(RED, GREY, HIATTR)                            ' set highlight color combination
     ATTR = HIATTR                                               ' highlight the first choice
     Y = OFFSET(COLACTIVE)                                       ' set initial Y position
     DSEG = VARSEG(DSCR1(1))                                     ' get the segment
     DOFS = VARPTR(DSCR1(1))                                     ' get the offset
     X = 7: A$ = " F1   Your Computer Configuration  ": GOSUB DXq' write it
     ATTR = MAINATTR                                             ' set the main color
     X = 8: A$ = " F2   Screen Handling Routines": GOSUB DXq     ' write the rest of the choices
     X = 9: A$ = " F3   File Management Routines": GOSUB DXq
     X = 10: A$ = " F4   String Manipulation Routines": GOSUB DXq
     X = 11: A$ = " F5   Memory Management Routines": GOSUB DXq
     X = 12: A$ = " F6   Input and Mouse Routines": GOSUB DXq
     X = 13: A$ = " F7   Advanced Progamming Routines": GOSUB DXq
     X = 14: A$ = " F8   The ProBas Window Manager": GOSUB DXq
     X = 15: A$ = " F9   Ordering Information": GOSUB DXq
     X = 16: A$ = " F10  Exit ProBas Demonstration": GOSUB DXq
     ROW(1) = 10                                                 ' number of menu choices
     ACTIVEMENU(COLACTIVE) = 1                                   ' set the active menu to 1
     FORE = GREY: BACK = BLACK
     CALL CALCATTR(GREY, BLACK, ATTR)
     Y = 3
     X = 23: A$ = "To select, press the desired function key or use the arrow keys or a mouse": GOSUB DXq
     X = 24: A$ = "to position the highlight over a choice and press Enter or  click the left": GOSUB DXq
     X = 25: A$ = "mouse button. ": GOSUB DXq
     A = WHITE + 16: CALL CALCATTR(A, BACK, ATTR)
     Y = 17: A$ = "Press any key to begin:": GOSUB DXq
     Y = 1: CALL CALCATTR(FORE, BACK, ATTR)

     ' --- the screen is now fully drawn!

     ' By the way, we used a nice programming trick here.
     ' The last screen the user saw was the one about
     ' how fast the window manager works.  As soon as the
     ' screen was displayed, before waiting for any user
     ' input, we began drawing the next screen to memory.
     ' Long before the user is finished reading even the
     ' first line of text on the visible screen, this
     ' screen will have been written to a virtual screen
     ' and be ready for display.  We don't check for a
     ' keypress until we are ready to display the finished
     ' replacement screen.  When the user does get around
     ' to pressing a key, they will see a fully drawn
     ' screen appear instantly, without the slightest
     ' hesitation!

     CALL CLRKBD                                                 ' clear the kyb buffer in case they're pressing a key...
     CALL GETKEY3(MOUSE, CMD, CMD1, LFT, MID, RGT)               ' check for keypress or mouse click
     ULR = 1: ULC = 1: LRR = 25: LRC = 80                        ' set the screen area to full screen...
        IF EGA OR VGA THEN CALL BLINK(1)                         ' re-enable blinking characters
     CALL DPUTSCREEN(DSEG, DOFS, ULR, ULC, LRR, LRC, PAGE, SCRMODE) ' move virtual screen to the active screen
     CALL GETKEY3(MOUSE, CMD, CMD1, LFT, MID, RGT)               ' check for keypress or mouse click

     ' Here's an example of using the CLREOL routine to
     ' clean off lines 23 thru 25 -- which currently contain
     ' the initial menu help info

        FOR X = 23 TO 25
           LOCATE X, 1, 0
           CALL CLREOL
        NEXT X

     ' Since we'll use this again, we put it in a
     ' subroutine down at label "ClearCommand"

     DAT$ = LEFT$(DATE$, 2) + "/" + MID$(DATE$, 4, 2) + "/" + RIGHT$(DATE$, 2)' today's date
     X = 24: Y = 72: CALL XQPRINT(DAT$, X, Y, TIMATTR, PAGE, SCRMODE)' put the date on the screen

        IF NOT MOUSE THEN GOTO MainCom

     ' Here's an example of setting the area of the screen
     ' the mouse can enter.  There are two ProBas routines
     ' that can be used to do this:  MMSETRANGE and
     ' SETMOUSERANGE.  The MMSETRANGE routine is "generic"
     ' and can be used in either text or the graphics modes.
     ' To use MMSETRANGE, you must use a formula for
     ' calculating the row and column offsets.  The formula
     ' varies depending on the screen mode that you are using
     ' (text, 40 column graphics, 80 column graphics, etc.).
     ' The SETMOUSERANGE is designed for use with text only,
     ' and performs the calculations for you.  In short,
     ' although you can use MMSETRANGE in text mode, using
     ' SETMOUSERANGE is easier.  Similarly, the generic
     ' MMSETLOC routine can be replaced with SETMOUSELOC
     ' (text mode only) and MMGETLOC can be replaced with
     ' GETMOUSELOC.  The only reason we have two routines
     ' that accomplish the same task is to make your
     ' life easier.

SetTheMouse:
     MTROW = 7                                                  ' mouse top row
     MTCOL = 1                                                  ' mouse top col
     MBROW = 17                                                 ' mouse bottom row
     MBCOL = 78                                                 ' mouse bottom col
     MROW = MTROW: MCOL = MTCOL                                 ' This is where the mouse is now
     SROW = MROW: SCOL = MCOL                                   ' Save this position....
     CALL SETMOUSELOC(MTROW, MTCOL)                             ' position the mouse
     CALL SETMOUSERANGE(MTROW, MTCOL, MBROW, MBCOL)             ' set the mouse range

     '--------------------------- main command dispatch ---------------------
     '
     ' This section is the main I/O area for user input.
     ' When using both a mouse and arrow keys, you have
     ' to make sure that they don't fight.  This section
     ' will wait for input, checking the mouse and
     ' updating the display time as it waits.  If a valid
     ' command is seen, or the mouse is moved, the
     ' appropriate action is taken.  All it amounts to
     ' is a sophisticated variation on the old
     '     WHILE INKEY$="" : WEND
     ' theme that takes the mouse into consideration.
     '
     ' You might want to refer to this later on as it is a
     ' very good example of using the many of the ProBas
     ' routines, especially the mouse routines, in a real-
     ' life situation.

MainCom:
     DO                                                          '
        CALL CHECKKEY3(MOUSE, CMD, CMD1, LFT, MID, RGT)          ' check for keypress or mouse click
        GOSUB Clock                                              ' display the time in the lower right hand corner
        IF MOUSE THEN GOSUB MOUSE                                ' check to see if the mouse has been moved
     LOOP UNTIL CMD OR CMD1 OR LFT OR MID OR RGT                 ' if a keypress or mouse click then exit the loop
        IF CMD1 = 72 THEN GOSUB UpArrow: GOTO MainCom            ' up arrow
        IF CMD1 = 80 THEN GOSUB DownArrow: GOTO MainCom          ' down arrow
        IF LFT THEN CMD1 = ROW + 58                              ' left button = enter key
        IF CMD = 13 THEN CMD1 = ROW + 58                         ' set row/fkey conversion
        IF CMD1 = 59 THEN GOTO Configuration                     ' F1 hardware configuration
        IF CMD1 = 60 THEN GOTO ScreenHandler                     ' F2 ScreenHandling
        IF CMD1 = 61 THEN GOTO FileManagement                    ' F3 File Management
        IF CMD1 = 62 THEN GOTO StringManipulate                  ' F4 String Manipulation
        IF CMD1 = 63 THEN GOTO MemoryManagement                  ' F5 Memory Management
        IF CMD1 = 64 THEN GOTO MouseRoutines                     ' F6 Input & Mouse Routines
        IF CMD1 = 65 THEN GOTO AdvancedRoutines                  ' F7 Advanced Routines
        IF CMD1 = 66 THEN GOTO WindowDemo                        ' F8 ProBas Window zManager
        IF CMD1 = 67 THEN GOTO OrderInfo                         ' F9 Ordering Information
        IF CMD1 = 68 THEN GOTO Quit                              ' F10 Quit
        IF CMD = 81 THEN GOTO Quit                               ' Q   Quit
     GOTO MainCom

     ' Now some people might use the CASE statement here,
     ' and avoid the GOSUB or GOTO like the plauge.
     ' Personally I think this makes the code much easier
     ' to read, and since GOSUB and GOTO are the fastest
     ' executing statements in all BASICdom, this method
     ' is just as fast, if not a tad faster.  I use the
     ' SELECT CASE statement when there are not so many
     ' menu choices.

     ' This section deals with the mouse to see where
     ' the little rodent is...

MOUSE:
     CALL GETMOUSELOC(MROW, MCOL)
       IF MROW = SROW AND MCOL = SCOL THEN RETURN                ' the mouse hasn't been moved
       IF MROW < SROW THEN GOSUB UpArrow: GOTO MM2               ' the mouse ran up
       IF MROW > SROW THEN GOSUB DownArrow                       ' the mouse ran down
MM2: RETURN                                                      ' (hickory dickory dock?)

UpArrow:
        IF ROW = 1 THEN RETURN                                   ' we are at the top
     ROW = ROW - 1                                               ' decrement the row
     LCOL = LCOL(COLACTIVE)                                      ' get the left...
     RCOL = RCOL(COLACTIVE)                                      ' and right columns
     GOSUB ReColorMenuHighlight                                  ' and set the highlight
     MROW = ROW + 6: MCOL = LCOL                                 ' reset the mouse location pointers
     CALL SETMOUSELOC(MROW, MCOL)                                ' move the mouse
     SROW = MROW: SCOL = MCOL                                    ' save the loc so we can tell when it moves again
     RETURN

DownArrow:
        IF ROW = ROW(COLACTIVE) THEN RETURN                      ' the highlight hasn't been moved
     ROW = ROW + 1                                               ' increment the row
     LCOL = LCOL(COLACTIVE)                                      ' left col
     RCOL = RCOL(COLACTIVE)                                      ' right col
     GOSUB ReColorMenuHighlight                                  ' set the highlight
     MROW = ROW + 6: MCOL = LCOL                                 ' set the mouse pointer
     CALL SETMOUSELOC(MROW, MCOL)                                ' move the mouse
     SROW = MROW: SCOL = MCOL                                    ' save the loc for later comparison
     RETURN

ReColorMenuHighlight:
     R1 = ROWSAVE + 6                                            ' offset between the logical and physical rows
     R2 = ROW + 6                                                ' R1 is the old highlight, R2 is the new
     CALL RECOLORAREA(R1, LCOL, R1, RCOL, MAINATTR, PAGE, SCRMODE)' turn the old highlight off
     CALL RECOLORAREA(R2, LCOL, R2, RCOL, HIATTR, PAGE, SCRMODE) ' turn the new highlight on
     ROWSAVE = ROW                                               ' save the row so we can tell when it changes
     HIGHLIGHT = ROW                                             ' the highlighted row
     RETURN

     '-------------------- display hardware configuration -------------------

Configuration:

     ' In this situation, we have three choices on how to
     ' save/restore the calendar in the right window.  The
     ' easiest way is to use the DSCRSAVE/DSCRREST routines on
     ' the entire screen, or use the virtual screen trick.
     ' Another way is save and later restore just the area
     ' of the right window that will be overwritten.  Since
     ' we've used the DSCRSAVE/FSCRREST routines a number of
     ' times in the window demo section, (GOSUB SaveScreen
     ' and GOSUB RestoreScreen) let's see how to save and
     ' restore a partial screen with DGETSCREEN/DPUTSCREEN.
     ' We start by specifying the area of the screen and the
     ' array to use.  We'll use the array SCR2().

     SULR = 4: SULC = OFFSET(2) - 1                              ' upper left corner
     SLRR = 21: SLRC = 79                                        ' lower right corner
     DSEG = VARSEG(SCR2(1))                                      ' get the segment of the array
     DOFS = VARPTR(SCR2(1))                                      ' get the offset of the array
     CALL DGETSCREEN(DSEG, DOFS, SULR, SULC, SLRR, SLRC, PAGE, SCRMODE)' take the snapshot
     CALL GETLIMM(TOTPAGES, FREEPAGES)                           ' get amount of L/I/M expanded memory
     TOTALEMS = TOTPAGES * 16                                    ' total number of Kbytes existing
     FREEEMS = FREEPAGES * 16                                    ' number of Kbytes currently available

     ' At the beginning of the program, we checked a number of
     ' hardware parameters such as monitor type, memory, etc.
     ' We put it there so that while we checked the few
     ' equipment parameters we needed, the rest of the ProBas
     ' routines could explained at the same time.  The info
     ' is already in memory, so all we have to do is display it.

     CALL CALCATTR(YELLOW, RED, ATTR)                           ' set the color to use
     Y = OFFSET(2): A$ = "Hardware Configuration"               ' center and draw the title line...
     LS = (38 - LEN(A$)) \ 2                                    ' above the right window that we...
     A$ = LEFT$(SPACE$(LS) + A$ + SPACE$(LS + 1), 39)           ' have already drawn
     X = 4: A$ = LEFT$(A$, 37): GOSUB Xq                        ' write it.

     ULR = 7: ULC = Y: LRR = 20: LRC = 78: FRAME = 5            ' set the window position to the area of the calendar
     FORE = GREY: BACK = RED                                    ' call the window manager to put a...
     GOSUB WindowManager                                        ' window with no frame in the area...
     CALL CALCATTR(FORE, BACK, ATTR)                            ' set the color and...
     X = 6: A$ = "Computer, CPU, Speed :": GOSUB Xq             ' do the text
     X = 7: A$ = "Current DOS Version  :": GOSUB Xq
     X = 8: A$ = "Total Base Memory    :": GOSUB Xq
     X = 9: A$ = "Total Extended Memory:": GOSUB Xq
     X = 10: A$ = "Total Expanded Memory:": GOSUB Xq
     X = 11: A$ = "Free  Expanded Memory:": GOSUB Xq
     X = 12: A$ = "Current Monitor type :": GOSUB Xq
     X = 13: A$ = "Video Mode-Width-Page:": GOSUB Xq
     X = 14: A$ = "No. of Parallel Ports:": GOSUB Xq
     X = 15: A$ = "No. of Serial Ports  :": GOSUB Xq
     X = 16: A$ = "No. of Game Ports    :": GOSUB Xq
     X = 17: A$ = "Current Drive\Path is:": GOSUB Xq
     X = 18: A$ = "Free Disk space on  " + DRV$ + ":": GOSUB Xq
     X = 19: A$ = "Total size of drive " + DRV$ + ":": GOSUB Xq
     X = 20: A$ = "No. of Clusters/Bytes:": GOSUB Xq
        IF MOUSE THEN A$ = "No. of Mouse buttons :" ELSE A$ = "No Mouse is installed."
     X = 21: GOSUB Xq

     HARDWARE$ = ""                                              ' type of computer
     SELECT CASE COMPTYPE
        CASE 255:     HARDWARE$ = "PC or XT"
        CASE 254, 251: HARDWARE$ = "XT or Port."
        CASE 253:     HARDWARE$ = "PCjr"
        CASE 252:     HARDWARE$ = "PC/AT"
        CASE 250:     HARDWARE$ = "PC Conv."
        CASE 154, 45: HARDWARE$ = "Compaq I"
        CASE ELSE:    HARDWARE$ = "Unknown"
     END SELECT
     SELECT CASE CPUTYPE
        CASE 1: A$ = ",8008"
        CASE 2: A$ = ",80186"
        CASE 3: A$ = ",80286"
        CASE 4: A$ = ",80386"
        CASE ELSE: A$ = ""
     END SELECT
     HARDWARE$ = HARDWARE$ + A$ + "," + MID$(STR$(MHZ), 2)
     Y = Y + 23                                                  ' set the column
     CALL CALCATTR(WHITE, RED, ATTR)                             ' set the color
     X = 6: A$ = HARDWARE$: GOSUB Xq                             ' display the type of computer
     X = 7: A$ = DOS$: GOSUB Xq
     X = 8: A$ = MID$(STR$(MEMORY), 2): GOSUB Xq                 ' amount of base memory
     X = 9: A$ = MID$(STR$(EXTMEMORY), 2): GOSUB Xq              ' amount of AT extended memory
     X = 10: A$ = MID$(STR$(TOTALEMS), 2): GOSUB Xq              ' the total amount of EMS memory
     X = 11: A$ = MID$(STR$(FREEEMS), 2): GOSUB Xq               ' the amount of free EMS memory
        IF MONO THEN A$ = "Monochrome"
        IF NOT MONO THEN A$ = "Color"
        IF EGA = 1 THEN A$ = "EGA color" + STR$(EMEMSIZE) + "k"
        IF EGA = 2 THEN A$ = "EGA mono " + STR$(EMEMSIZE) + "k"
        IF VGA THEN A$ = "VGA Adapter"
     X = 12: GOSUB Xq                                            ' type of monitor display
     VMODE$ = MID$(STR$(VMODE), 2)
     A$ = MID$(STR$(VWIDTH), 2): VMODE$ = VMODE$ + " - " + A$
     A$ = MID$(STR$(VPAGE), 2): VMODE$ = VMODE$ + " - " + A$
     X = 13: A$ = VMODE$: GOSUB Xq
     X = 14: A$ = MID$(STR$(PARALLEL), 2): GOSUB Xq              ' number of parallel ports
     X = 15: A$ = MID$(STR$(SERIAL), 2): GOSUB Xq                ' number of serial ports
     X = 16: A$ = MID$(STR$(GAME), 2): GOSUB Xq                  ' number of game ports
     X = 17: A$ = DRV$ + ":" + Strip2$(SUB$): GOSUB Xq           ' current drive and directory path
     X = 18: A$ = MID$(STR$(FREESPACE&), 2): GOSUB Xq            ' amount of free diskspace
     X = 19: A$ = MID$(STR$(TOTAL.DISK.SPACE#), 2): GOSUB Xq     ' total disk space
     A$ = MID$(STR$(TOTAL.CLUST) + "/", 2)                       ' number of clusters and...
     B$ = A$: A$ = MID$(STR$(BYTES.SEC), 2)                      ' bytes per cluster
     A$ = B$ + A$: X = 20: GOSUB Xq
        IF MOUSE THEN X = 21: A$ = MID$(STR$(MBUT), 2): GOSUB Xq ' is there a mouse installed?
     GOSUB KeyClick                                              ' check for keypress or mouse click

     ' we are now going to restore the partial screen and
     ' return to the menu.

     DSEG = VARSEG(SCR2(1)): DOFS = VARPTR(SCR2(1))              ' get segment and offset again
     CALL DPUTSCREEN(DSEG, DOFS, SULR, SULC, SLRR, SLRC, PAGE, SCRMODE)' restore snapshot
     GOTO MainCom                                                ' all done!

     '------------------------- F2 Screen Handler ---------------------------

ScreenHandler:

     ' Here is an example of the ProBas EXIST routine
     ' to make certain that a file exists.  Using
     ' EXIST involves far less overhead than BASIC's
     ' ON ERROR GOTO error trapping, and is less
     ' cumbersome.

     FIL$ = "DEMO1.EXE"                                          ' the file name

CheckAndChain:
     CALL EXIST(FIL$, FOUND)                                     ' make the call
        IF NOT FOUND THEN GOTO NoFileFound                       ' found is returned 0 if found, non-zero if not
     Restart = -1                                                ' it must be there, so set the restart flag
     CHAIN FIL$

NoFileFound:
     GOSUB ClearCommand                                          ' clear lines 23-25 and set the cursor pos and color
     PRINT "Error!  The file "; FIL$; " is missing.  Press any key:"; ' print the error message. (no need for XQPRINT speed here!)
     GOSUB KeyClick                                              ' check for keypress or mouse click
     LOCATE 23, 1, 0: CALL CLREOL                                ' clear the error message
     GOTO MainCom                                                ' go back to the main command dispatcher

     '------------------------- F3 File Management --------------------------

FileManagement:
     FIL$ = "DEMO2.EXE"                                          ' the file name
     GOTO CheckAndChain

     '----------------------- F4 String Manipulation ------------------------

StringManipulate:
     FIL$ = "DEMO3.EXE"                                          ' the file name
     GOTO CheckAndChain

     '------------------------ F5 Memory Management -------------------------

MemoryManagement:
     FIL$ = "DEMO4.EXE"                                          ' the file name
     GOTO CheckAndChain

     '------------------------ F6 Input & Mouse Routines ---------------------

MouseRoutines:
     FIL$ = "DEMO5.EXE"                                          ' the file name
     GOTO CheckAndChain

     '-------------------------- F7 Advanced Routines -----------------------

AdvancedRoutines:
     FIL$ = "DEMO6.EXE"                                          ' the file name
     GOTO CheckAndChain

     '---------------------- F8 The ProBas Window Manager -------------------

WindowDemo:
     FIL$ = "DEMO7.EXE"                                          ' the file name
     GOTO CheckAndChain

     '-------------------------- F9 Ordering Information --------------------

OrderInfo:
     GOSUB SaveScreen                                            ' save the current screen
        IF MONO THEN GOTO Order2
     TMP$ = "ORDER.BLD"
     CALL EXIST(TMP$, FOUND)
        IF NOT FOUND THEN GOTO Order2
     SCREEN 1
     CALL GLOAD(TMP$)
     CALL GETKEY3(MOUSE, CMD, CMD1, LFT, MID, RGT)
     SCREEN 0, 1, 0, 0: WIDTH 80
     CALL DELAY18TH(7)

Order2:
     ULR = 2: ULC = 2: LRR = 24: LRC = 79: FRAME = 2
     FORE = YELLOW: BACK = BLUE
     GOSUB WindowManager
     CALL CALCATTR(YELLOW, BLUE, ATTR)
     A$ = "[" + SPACE$(13) + "]"
     X = 25: Y = 40 - LEN(A$) \ 2: GOSUB Xq
     CALL CALCATTR(LRED, BLUE, ATTR)
     A$ = "Press any key"
     Y = 40 - LEN(A$) \ 2: GOSUB Xq

     ' this section illustrates the use of the ProBas
     ' BIGPRINT routine to draw large letters to the
     ' screen.  We begin by specifying the character
     ' that BIGPRINT will use to draw the letters.
     ' This can be any valid ASCII character, except
     ' of course, non-printing characters like the null.
     ' Here we are using the lightly shaded box of
     ' CHR$(176).

     FORMCH$ = CHR$(176)

     ' We'll set the forground color to blink so that it
     ' gives the impression that the letters are blinking
     ' not on and off, but rather between two colors.
     ' We'll use a high intensity CYAN (LCYAN+16) for the
     ' forground and magenta for the background...

     CALL CALCATTR(LCYAN + 16, 5, ATTR)

     ' Then all that's left is specifying the string to
     ' print and the location to begin.  We'll skip
     ' using variables and just enter the row and column
     ' location as literals within the call to BIGPRINT...

     A$ = "Order"
     CALL BIGPRINT(A$, FORMCH$, 2, 6, ATTR)

     ' We repeat the process for the second word since
     ' we want it in another color.  BIGPRINT will print
     ' multi-word strings, it just happens that we want
     ' just two words in different colors.

     A$ = "Info"
     CALL CALCATTR(28, 4, ATTR)
     CALL BIGPRINT(A$, FORMCH$, 2, 46, ATTR)

     ' The rest of this section uses CALCATTR and XQPRINT
     ' to write the ordering information to the screen...

     CALL CALCATTR(GREY, BLUE, ATTR)
     A$ = "(We used the BIGPRINT and CALCATTR routines for the big text here)"
     X = 10: Y = 7: GOSUB Xq
     CALL CALCATTR(LCYAN, BLUE, ATTR)
     A$ = "For credit card and COD:"
     X = 12: Y = 28: GOSUB Xq
     CALL CALCATTR(WHITE, BLUE, ATTR)
     A$ = "Call (800) 343-7484"
     X = 13: Y = 31: GOSUB Xq
     CALL CALCATTR(GREY, BLUE, ATTR)
     A$ = "or"
     X = 15: Y = 39: GOSUB Xq
     CALL CALCATTR(LCYAN, BLUE, ATTR)
     A$ = "Send check or money order to:"
     X = 17: Y = 26: GOSUB Xq
     CALL CALCATTR(WHITE, BLUE, ATTR)
     A$ = "Hammerly Computer Services, Inc."
     X = 19: Y = 24: GOSUB Xq
     A$ = "414 Main Street"
     X = 20: Y = 32: GOSUB Xq
     A$ = "Laurel, MD.  20707"
     X = 21: Y = 31: GOSUB Xq
     CALL CALCATTR(LCYAN, BLUE, ATTR)
     A$ = "ProBas is $159.00 Plus shipping. Add $7.50 in the U.S. and $10.00 in Canada"
     X = 23: Y = 4: GOSUB Xq
     A$ = "For overseas sales call (301) 953-2191.  Our FAX number is (301) 725-8147."
     X = 24: Y = 4: GOSUB Xq

     CALL GETKEY3(MOUSE, CMD, CMD1, LFT, MID, RGT)
     GOSUB RestoreScreen
     GOTO MainCom

     '-------------------------- F10 Exit the Progran -----------------------

Quit:
     CALL CALCATTR(GREY, BLACK, ATTR)
     CALL FADEOUT(ATTR)
     CALL BLINK(1)
     END

     '----------------------------- wonder windows --------------------------

     ' This routine is used to create the 300 windows in the opening
     ' of the demonstration. It uses two Large Numeric Arrays (LNA)
     ' of 60,000 bytes each.  Thus when this routine is run, an additional
     ' 120k or so of memory is gobbled up.  This may cause the program
     ' to run out of memory on some machines.  That's why we added the
     ' M command line option (as explained in the READ.ME file) to bypass
     ' this routine.  Rather than break it up for narration, we'll let
     ' you study this one on your own -- it uses some cute tricks!

WonderWindows:
     GOSUB SaveScreen3
     TYPE RANDWINDTYPE
        XULR AS INTEGER
        XULC AS INTEGER
        XLRR AS INTEGER
        XLRC AS INTEGER
        XFRAME AS INTEGER
        XFORE AS INTEGER
        XBACK AS INTEGER
        XLABEL AS INTEGER
        XZATTR AS INTEGER
     END TYPE
     REM $DYNAMIC
     DIM SNAP(30000), SNAP1(30000)
     DIM WIND(300) AS RANDWINDTYPE
     X$ = " ProBas WindowManager ProBas WindowManager"
     BACKRANGE = 8: IF EGA OR VGA THEN BACKRANGE = 16
        FOR I = 1 TO 300
           WIND(I).XULR = FNRAN(15) + 1
           WIND(I).XULC = FNRAN(55) + 1
           T = WIND(I).XULR + FNRAN(15): IF T > 24 THEN T = 24
           WIND(I).XLRR = T
           T = WIND(I).XULC + FNRAN(35): IF T > 79 THEN T = 79
           WIND(I).XLRC = T
           WIND(I).XFRAME = FNRAN(4)
           WIND(I).XFORE = FNRAN(16) - 1
              DO
                 WIND(I).XBACK = FNRAN(BACKRANGE) - 1
              LOOP WHILE WIND(I).XBACK = WIND(I).XFORE
              DO
                 WIND(I).XLABEL = FNRAN(16) - 1
              LOOP WHILE WIND(I).XLABEL = WIND(I).XBACK
           CALL CALCATTR(FNRAN(16) - 1, WIND(I).XBACK, WIND(I).XZATTR)
        NEXT I
     ' now that we have the ....
     '

     X = 16: CALL CALCATTR(BLUE, GREY, ATTR)                     ' set colors
     A$ = SPACE$(6) + "Press any key to continue": GOSUB Xq      ' print the last line of info window
     CALL CLRKBD                                                 ' clear the keyboard buffer
     CALL GETKEY3(MOUSE, CMD, CMD1, LFT, MID, RGT)               ' check for keypress or mouse click

     COUNT = 0
        FOR I = 1 TO 300
           ULR = WIND(I).XULR: ULC = WIND(I).XULC
           LRR = WIND(I).XLRR: LRC = WIND(I).XLRC
           FRAME = WIND(I).XFRAME
           FORE = WIND(I).XFORE: BACK = WIND(I).XBACK
           LABEL = WIND(I).XLABEL
           LABEL$ = MID$(STR$(I), 2)
           CALL WindowManager(ULR, ULC, LRR, LRC, FRAME, FORE, BACK, GROW, SHADOW, LABEL, LABEL$, PAGE, SCRMODE)
           ATTR = WIND(I).XZATTR
           Y = ULC: A$ = LEFT$(X$, LRC - ULC + 1)
              FOR X = ULR TO LRR
                 GOSUB Xq
              NEXT X
           IF COUNT = 10 THEN
              DSEG = VARSEG(SNAP(PTR))
              DOFS = VARPTR(SNAP(PTR))
              CALL DSCRSAVE(DSEG, DOFS, PAGE, SCRMODE)
           ELSEIF COUNT = 20 THEN
              DSEG = VARSEG(SNAP1(PTR))
              DOFS = VARPTR(SNAP1(PTR))
              CALL DSCRSAVE(DSEG, DOFS, PAGE, SCRMODE)
              PTR = PTR + 2000
              COUNT = 0
           END IF
           COUNT = COUNT + 1
        NEXT I
     CALL CLRKBD                                                 ' clear the keyboard buffer
     CALL GETKEY3(MOUSE, CMD, CMD1, LFT, MID, RGT)               ' check for keypress or mouse click
     PTR = PTR - 2000
        WHILE PTR >= 0
           DSEG = VARSEG(SNAP1(PTR))
           DOFS = VARPTR(SNAP1(PTR))
           CALL DSCRREST(DSEG, DOFS, PAGE, SCRMODE)
           CALL DELAY18TH(1)
           DSEG = VARSEG(SNAP(PTR))
           DOFS = VARPTR(SNAP(PTR))
           CALL DSCRREST(DSEG, DOFS, PAGE, SCRMODE)
           CALL DELAY18TH(1)
           PTR = PTR - 2000
        WEND
     ERASE SNAP, SNAP1, WIND
     GOSUB RestoreScreen3
     ULR = 4: ULC = 30: LRR = 17: LRC = 70: FRAME = 4
        IF MONO THEN FORE = RED ELSE FORE = WHITE
     BACK = GREY: LABEL = RED: LABEL$ = "Windows!"
     CALL WindowManager(ULR, ULC, LRR, LRC, FRAME, FORE, BACK, GROW, SHADOW, LABEL, LABEL$, PAGE, SCRMODE)
     CALL CALCATTR(BLUE, GREY, ATTR)
     RESTORE Window2Data: Y = 31
        FOR X = 4 TO 16
           READ A$
           GOSUB Xq
        NEXT X
     CALL CALCATTR(RED, GREY, ATTR)
     READ A$: GOSUB Xq
     RETURN

     '------------------------------ data statements ------------------------

     ' In a program such as this, with huge amounts of text, we could
     ' store the text in a data file and read it in as needed, or we
     ' could use data statements such as below.  If we tried to store
     ' these as regular string variables, we would very quickly use
     ' up the 64K of string space allowed and get an out of memory error.
     ' DATA statements, on the other hand, do not use the string area
     ' for storage, so we have plenty of room to work in.

Intro1Data:
     DATA "ProBas is a programming library that contains over 365 assembly language"
     DATA "and BASIC routines  that not only  enable you to dramatically  enhance a"
     DATA "program's looks and performance,  but also to accomplish  tasks that are"
     DATA "impossible using BASIC alone."
     DATA ""
     DATA "You may link ProBas routines with your programs without paying a royalty"
     DATA "or including HCSI's copyright notice, even if the program is going to be"
     DATA "commercially distributed. With ProBas, you can do all of the things this"
     DATA "demo does and much more."
     DATA ""
     DATA "ProBas comes with a two-volume manual that includes a detailed technical"
     DATA "reference manual, and an in-depth tutorial that contains examples, tips,"
     DATA "advanced programming techniques, timesavers and time-saving 'tricks'."

Intro2Data:
     DATA "ProBas includes over eighty high-speed routines that really make screens"
     DATA "fly. Many of these allow you to bypass the slow PRINT statement, with or"
     DATA "without snow suppression.  Others use DOS print commands so that you can"
     DATA "use ANSI.SYS and you can even have low-resolution graphics in text mode."
     DATA ""
     DATA "ProBas has a number of routines that will allow you to take a 'snapshot'"
     DATA "of any part of a screen and then restore it, either to the same location"
     DATA "or to a different part of the screen.   The routines are lightning fast,"
     DATA "especially without the snow suppression."
     DATA ""
     DATA "To demonstrate this amazing speed, we will display a 'slide show' of the"
     DATA "three screens you have seen so far.  Please press a key to cycle through"
     DATA "the three screens, pressing a key each time to move to the next."

Window1Data:
     DATA "The WindowManager  routine provides you"
     DATA "advanced window capabilities  that give"
     DATA "you complete  control over your windows"
     DATA "and what you display in them including:"
     DATA ""
     DATA "  1  size, shape and position"
     DATA "  2  four types of frames or no frame"
     DATA "  3  window title in any color"
     DATA "  4  instant display     (snap on)"
     DATA "  5  exploding windows   (grow)"
     DATA "  6  shadows of any color or hue"
     DATA "  7  exploding/shadowed windows"

Window2Data:
     DATA "In case you missed it,  we drew exactly"
     DATA "300 windows,  complete with text inside"
     DATA "each window, and  then peeled them back"
     DATA "off in the same order!"
     DATA ""
     DATA "We did this to show you that the ProBas"
     DATA "WindowManager is more  than a glorified"
     DATA "box drawing utility and that the ProBas"
     DATA "screen routines are very powerful."
     DATA ""
     DATA "You can see more  about WindowManager a"
     DATA "little later in the demonstration.
     DATA ""
     DATA "      Press any key to continue"

     '--------------------------- misc gosub routines -----------------------

Restart:
     OFFSET(1) = 4                                               ' offset for left window
     OFFSET(2) = 43                                              ' offset for right window
     COLACTIVE = 1                                               ' set the active window to 1
     LCOL(1) = OFFSET(COLACTIVE)                                 ' left side of highlight  Left window
     RCOL(1) = OFFSET(COLACTIVE) + 35                            ' right side of highlight Left window
     LCOL(2) = OFFSET(2)                                         ' left side of highlight  Right window
     RCOL(2) = OFFSET(2) + 35                                    ' right side of highlight Right window
     CALL CALCATTR(CYAN, BLACK, MAINATTR)                        ' set main color combination
     CALL CALCATTR(RED, GREY, HIATTR)                            ' set highlight color combination
     CALL CALCATTR(GREY, BLACK, ATTR)                            ' the standard colors
     GOTO SetTheMouse                                            ' we now rejoin the program already in progress...

AskAboutSnow:
        IF EGA OR VGA THEN SCRMODE = -1: RETURN
     COLOR 7, 0
     PRINT "Do you need snow suppression (y/n): ";
     CALL GETKEY3(MOUSE, CMD, CMD1, LFT, MID, RGT)
     CMD$ = CHR$(CMD): CALL UPCASE(CMD$)
        IF CMD$ = "N" THEN SCRMODE = -1
     RETURN

     '------------------------ standard subroutines -------------------------

SaveScreen:
     XSEG = VARSEG(SCR1(1))
     XOFS = VARPTR(SCR1(1))
     CALL DSCRSAVE(XSEG, XOFS, PAGE, SCRMODE)
     RETURN

RestoreScreen:
     XSEG = VARSEG(SCR1(1))
     XOFS = VARPTR(SCR1(1))
     CALL DSCRREST(XSEG, XOFS, PAGE, SCRMODE)
     RETURN

SaveScreen2:
     XSEG = VARSEG(SCR2(1))
     XOFS = VARPTR(SCR2(1))
     CALL DSCRSAVE(XSEG, XOFS, PAGE, SCRMODE)
     RETURN

RestoreScreen2:
     XSEG = VARSEG(SCR2(1))
     XOFS = VARPTR(SCR2(1))
     CALL DSCRREST(XSEG, XOFS, PAGE, SCRMODE)
     RETURN

SaveScreen3:
     XSEG = VARSEG(SCR3(1))
     XOFS = VARPTR(SCR3(1))
     CALL DSCRSAVE(XSEG, XOFS, PAGE, SCRMODE)
     RETURN

RestoreScreen3:
     XSEG = VARSEG(SCR3(1))
     XOFS = VARPTR(SCR3(1))
     CALL DSCRREST(XSEG, XOFS, PAGE, SCRMODE)
     RETURN

Xq:  CALL XQPRINT(A$, X, Y, ATTR, PAGE, SCRMODE)
     RETURN

DXq: CALL DXQPRINT(DSEG, DOFS, A$, X, Y, ATTR)
     RETURN

WindowManager:
     CALL WindowManager(ULR, ULC, LRR, LRC, FRAME, FORE, BACK, GROW, SHADOW, LABEL, LABEL$, PAGE, SCRMODE)
     RETURN

ClearCommand:
     COLOR 7, 0                                                  ' set BASIC's color
     X = 23: Y = 1                                               ' set the x/y position
        FOR X = 25 TO 23 STEP -1                                 ' loop from 25 to 23
           LOCATE X, Y, 0                                        ' position the cursor
           CALL CLREOL                                           ' make the call
        NEXT X                                                   ' loop.  When this routine is done,
     RETURN                                                      ' the cursor is at 23,1 - where we want it

KeyClick:
        DO                                                       ' loop
           GOSUB Clock                                           ' update time display
           CALL CHECKKEY3(MOUSE, CMD, CMD1, LFT, MID, RGT)       ' check for a keypress or mouse click
        LOOP UNTIL CMD OR CMD1 OR LFT OR MID OR RGT              ' exit when we get one
     RETURN

Clock:
     CALL XQPRINT(TIME$, 25, 72, TIMATTR, PAGE, SCRMODE)         ' update the time every loop
     RETURN                                                      ' tick tock.

