     DEFINT A-Z
     rem $STATIC
     DIM SCR1(2000),SCR2(2000),SCR3(2000),SCR4(2000),SCR5(2000)

     rem $INCLUDE: 'COMDEF.BAS'

     DEF FNRAN(X)=INT(RND*X+1)
     RANDOMIZE TIMER
     PAGE=0
     LOCATE 23,1,0                                               ' locate and turn off the cursor
     CALL CALCATTR(MAG,BLACK,TIMATTR)                            ' set the color for the on-screen clock

     '---------------------------- screen handling --------------------------

ScreenHandling:

     ' This routine demonstrates one way to create pull-down
     ' menus.  It is not the only way, or the easiest, or the
     ' perhaps even the best -- it does however allow us to
     ' show you some techniques, step-by-step, that make the
     ' menus appear fully-drawn, instantly.

     ' The major areas we will address here are practical
     ' applications of virtual screens, using the routine
     ' RECOLORAREA for menu highlighting, and the mouse
     ' routines.  We begin this section by taking a snapshot
     ' of the current screen (so we can restore it when we
     ' return to the main menu) and setting up some dynamic
     ' arrays...

     GOSUB SaveScreen
     rem $DYNAMIC
     REDIM MENU$(8),LMPOS(8),RMPOS(8)
     REDIM DSEG(7),DOFS(7)
     REDIM ULR(7),ULC(7),LRR(7),LRC(7)
     REDIM CHOICES(7),ELM(7)

     ' MENU$()     The text of each menu's title
     ' LMPOS()     The left margin of the menu choice
     ' RMPOS()     The right margin of the menu choice
     ' DSEG()      Store the data segment for each menu
     ' DOFS()      Store the offset for each menu
     ' ULR()       Upper Left Row for each menu
     ' ULC()       Upper Left Column for each menu
     ' LRR()       Lower Right Row for each menu
     ' LRC()       Lower Right Column for each menu
     ' CHOICES()   The number of choices on each menu
     ' ELM(7)      The size to REDIM each menu array to

     ' We now READ the bar menu choices, and their
     ' positions from the DATA statement at label
     ' "BarMenuData" which is placed with the other
     ' DATA statements, near the end of the file,
     ' out of way.  We have set the positions
     ' (LMPOS and RMPOS) to one character left and
     ' right of the actual text for each choice so
     ' that we can have our highlight positions set
     ' up automatically (i.e. " Menu ").

     RESTORE BarMenuData                                         ' restore the data
        FOR I=1 TO 8                                             ' read for 8 choices
           READ MENU$(I)                                         ' menu choice text
           READ LMPOS(I),RMPOS(I)                                ' left col and right col
        NEXT I                                                   ' loop
     MAXMENU=8                                                   ' number of menu choices on bar

     ' we decide a color and print the background for
     ' the menu bar.  For this screen we are putting the
     ' bar on row 2 and starting at column two. Who says
     ' that pull-down menus HAVE to be on row 1 anyway?
     ' Besides, if we wanted to get totally bizarre, we
     ' could just as easily put the bar on line 25 and
     ' have pull-UP menus! (or a vertical bar and
     ' pull-OVER menus for that matter -- get the
     ' drift?).

     CALL CALCATTR(LCYAN,MAG,HMATTR)                             ' the color of the bar
        IF MONO THEN CALL CALCATTR(GREY,BLACK,HMATTR)            ' default doesn't look good in mono so change them
     ATTR=HMATTR                                                 ' so that it looks good regardless of the monitor
     X=2 : Y=2 : A$=SPACE$(78) : GOSUB Xq                        ' clear the bar row, but not the frame...
     BAR.ROW=2                                                   ' remember the row the bar menu is on

     ' Read in the text, the positions, and display the
     ' bar menu.

        FOR I=1 TO 8
           Y=LMPOS(I)+1
           A$=MENU$(I) : GOSUB Xq
        NEXT I

     ' The subroutine at ReColorHighlight is used to
     ' change the colors of the highlight back and forth
     ' between the normal colors, and the highlight
     ' colors.  It uses the ProBas routine RECOLORAREA
     ' to set the highlight.  All we need to do is tell
     ' it the old position (the currently highlighted
     ' choice) and the new position (the choice we want
     ' to highlight.  Here we are using the subroutine
     ' to set the highlight to the first choice.  Since
     ' the subroutine needs both an old and a new
     ' location, we'll specify both to be the same.

     OROW=BAR.ROW : NROW=OROW                                    ' the row the menu bar is on
     OLPOS=LMPOS(1) : ORPOS=RMPOS(1)                             ' the position of the old highlight
     NLPOS=LMPOS(1) : NRPOS=RMPOS(1)                             ' the position of the new highlight
     GOSUB ReColorHighlight                                      ' set the highlight
     BARPOS=1 : BARPOSAVE=1                                      ' save the pos of highlight
     MENU=0                                                      ' no pull-down menu yet selected

     ' The horizontal menu has now been drawn and the
     ' first choice is highlighted.  Before we stop and
     ' get the user's input, we are going to draw the
     ' seven pull-down menus to the virtual screens.
     ' Since we are dealing directly with memory, and
     ' the ProBas routines are so fast, the seven menus
     ' are drawn in a fraction of a second - the user
     ' literally will not have finished reading the first
     ' word on the screen before we have finished.  The
     ' advantage to doing it this way is that once we have
     ' draw the menus, all we need to do is specify the
     ' menu's number and the menu, including the text of
     ' the choices, is displayed instantly, without the
     ' user seeing us drawing the window and filling in
     ' the text. We are doing it that way here for two
     ' reasons:  to make the demo fast and snappy as
     ' possible (to show off ProBas of course!), and to
     ' show you some techniques using virtual screens.

     ' In a normal situation, we would put the code to
     ' draw all seven menus in a tight FOR/NEXT loop.
     ' We'll sacrifice tight, harder to read code for
     ' less efficient, but easier to narrate code.  We'll
     ' do the first two menus alone, and put the remaining
     ' five in a loop at the bottom of the file.  The
     ' next block of code reads a data statement to
     ' determine the number of menu choices on each pull-
     ' down menu so that we have the data for both the
     ' stand-alone examples and the loop for menus 3-7.

     RESTORE LastRowData
        FOR I=1 TO 7
           READ CHOICES(I)
        NEXT I

     ' We have already seen the technique for using
     ' full-sized virtual screens in the section on
     ' drawing a complex screen.  Working with a partial
     ' virtual screen is just little trickier.  The
     ' catch is not saving to (DGETSCREEN) or restoring
     ' (DPUTSCREEN), but writing to, using DXQPRINT.
     ' Unless we want to mess with four more offsets
     ' (and who wants to do that) the easiest way to
     ' write a partial virtual screen is:
     '
     '  1  DIM a "scratch" screen array to 2000 so that
     '     we are dealing with a full-sized screen.
     '     This makes it unnecessary to keep track of
     '     four more offsets.
     '  2  Calculate the size of the menu using the
     '     CALCSIZE routine and DIM an array to the size
     '     needed to store just the pull-down menu.
     '  3  Draw the pull-down menu to the scratch screen
     '  4  Move the finished pull-down menu from the
     '     scratch array to the virtual screen array.
     '  5  Repeat the process until all seven menus are
     '     drawn.
     '  6  De-allocate the scratch array since we don't
     '     need it any more.
     '
     ' As you will see, it's really not as complicated as
     ' it sounds and only adds one step-- moving from
     ' the scratch array where the full screen was drawn
     ' to the partial virtual screen array that will be
     ' used from then on.  As a matter of fact, it takes
     ' far fewer lines of code to do it as it does to
     ' explain it -- by a over a power of 10!

     ' We begin by setting up the scratch array to 4000
     ' bytes (2000 integer elements):

     REDIM SCRATCH(2000)
     DSEG=VARSEG(SCRATCH(1))
     DOFS=VARPTR(SCRATCH(1))

     ' We now set the screen colors and call DCLEAR to
     ' do a 'CLS' of the virtual screen.

     CALL CALCATTR(LCYAN,BLACK,ATTR)                             ' calculate the color attribute
     CALL DCLEAR(DSEG,DOFS,ATTR)                                 ' clear the virtual screen (CLS)

     ' We specify the location of the pull-down menu
     ' We are going to use the DWindowManager routine
     ' to draw the menu window to the virtual screen.

     '---- menu 1

     ULR=4 : ULC=2 : LRR=22 : LRC=15                             ' the window coordinates
     LABEL$="List 1"                                             ' the label of the window

     ' Since we are going to draw seven menu windows,
     ' and the call to DWindowManager does have a lot
     ' of arguments, we just put the call into a sub-
     ' routine to ease our typing chore. When we return
     ' from the subroutine, we save the position of the
     ' window into an array.

     GOSUB PullDownWindow                                        ' draw the window
     ULR(1)=ULR : ULC(1)=ULC : LRR(1)=LRR : LRC(1)=LRC           ' save the location in an array
     Y=ULC                                                       ' set the column position for text

     ' We are going to READ the menu choices from the
     ' DATA statements beginning at label 'Menu1Data'.
     ' We just read in the string, and immediately write
     ' it to the scratch screen, without storing anything.
     ' The screen will be our storage area!

     RESTORE Menu1Data
        FOR X=ULR TO ULR+CHOICES(1)-1                            ' remember the data in CHOICES array was set earlier
           READ A$                                               ' read the data
           GOSUB DXq                                             ' write the data
        NEXT X                                                   ' loop till done

     ' our scratch screen now contains the first menu,
     ' complete with the text of the menu choices.
     ' All we have to do now is to move just the menu
     ' from the full-screen scratch array to the partial
     ' virtual screen that will contains the menu.
     ' The CALCSIZE routine will tell us the size to
     ' dimension the array.  We use the same variables
     ' we used for the call to DWindowManger, allowing
     ' one row and column around the edges for the frame.

     TROW=ULR-1 : TCOL=ULC-1 : BROW=LRR+1 : BCOL=LRC+1           ' allow for the frame
     CALL CALCSIZE(TROW,TCOL,BROW,BCOL,ELEMENTS)                 ' calculate the size to DIM the array

     ' By the way, this virtual screen will only take
     ' up 304 bytes of memory.  As a matter of fact,
     ' since this is the largest of the menus, all
     ' seven virtual screens use about 1928 bytes of
     ' memory, which is actually less than storing
     ' one full-sized screen!

     ' Now that we have the size, let's dimension the
     ' virtual screen array....

     REDIM MENU1(ELEMENTS)
     VSEG=VARSEG(MENU1(1))
     VOFS=VARPTR(MENU1(1))

     ' and just to be on the safe side, we'll get the
     ' segment and offset of the scratch array again,
     ' since it may well have moved due to the redim
     ' statement above....

     DSEG=VARSEG(SCRATCH(1))
     DOFS=VARPTR(SCRATCH(1))

     ' ... and copy the menu from the scratch screen to
     ' its own virtual screen...

     CALL VGETSCREEN(DSEG,DOFS,TROW,TCOL,BROW,BCOL,VSEG,VOFS)

     ' The array MENU1() now contains the snapshot of the
     ' menu.

     ' The DSEG and DOFS variables are the location of the
     ' scratch array.  The VSEG and VOFS are the location
     ' of the 304 byte virtual screen array that holds the
     ' pull-down menu.

     ' When it comes time to display the menu, we'll get the
     ' segment and offset of MENU(1) and then  all we have to
     ' do is use the DGETSCREEN routine, using these values:
     ' DSEG(1),DOFS(1),ULR(1)-1,ULC(1)-1,LRR(1)+1,LRC(1)+1
     ' Remember, we have to allow one row/column all around
     ' for the frame.  Since we use the ULC(1) and LRC(1)
     ' values quite often for highlight positioning, we
     ' manually set the offset (-1/+1) when we call DGETSCREEN.

     ' With the narrative, it's taken some 250 lines (of comments,
     ' not code!) to  draw the first menu when it really should
     ' have taken about 15.  We'll repeat the process, sans the
     ' narrative, for menu 2.  This shows just how easy
     ' it really is to use a virtual screen:

     '--- menu 2

     ULR=4 : ULC=10 : LRR=22 : LRC=23                            ' window position
     LABEL$="List 2"                                             ' window label (title)
     GOSUB PullDownWindow                                        ' draw the window
     ULR(2)=ULR : ULC(2)=ULC : LRR(2)=LRR : LRC(2)=LRC           ' save position in an array
     Y=ULC                                                       ' set the column for text
     RESTORE Menu2Data                                           ' restore the data
        FOR X=ULR TO ULR+CHOICES(2)-1                            ' display from row 7
           READ A$ : GOSUB DXq                                   ' read and write menu choice text
        NEXT X                                                   ' loop til done
     TROW=ULR-1 : TCOL=ULC-1 : BROW=LRR+1 : BCOL=LRC+1           ' allow for the frame
     CALL CALCSIZE(TROW,TCOL,BROW,BCOL,ELEMENTS)                 ' calculate the size to DIM the array
     REDIM MENU2(ELEMENTS)                                       ' dimension the array
     DSEG=VARSEG(SCRATCH(1)): DOFS=VARPTR(SCRATCH(1))            ' get the address of the scratch array
     VSEG=VARSEG(MENU2(1))  : VOFS=VARPTR(MENU2(1))              ' get the address of the virtual array
     CALL VGETSCREEN(DSEG,DOFS,TROW,TCOL,BROW,BCOL,VSEG,VOFS)    ' write to the virtual screen

     ' We'll do the remaining menus in a loop.  If we
     ' had set things up a little better (i.e. no narrative)
     ' we could have made it even tighter and done all
     ' seven.  (there's an example of doing just that in
     ' the file DEMO4.BAS)

     ' By the way, notice that it took 15 lines to do the
     ' Menu2 pull-down and only 23 lines to do menus 3-7.
     ' If we really wanted to, we could have done it in
     ' fewer lines, but I like easy to read code.

     RESTORE MenuPositions
        FOR I=3 TO 7                                             ' loop through menus 3-7
           READ ULR,ULC,LRR,LRC                                  ' read the menu's position
           ULR(I)=ULR : ULC(I)=ULC : LRR(I)=LRR : LRC(I)=LRC     ' store the position for each menu in arrays
           TROW=ULR-1 : TCOL=ULC-1 : BROW=LRR+1 : BCOL=LRC+1     ' allow for the frame
           CALL CALCSIZE(TROW,TCOL,BROW,BCOL,ELM(I))             ' calculate the size to DIM the array
        NEXT I
     REDIM MENU3(ELM(3)),MENU4(ELM(4)),MENU5(ELM(5))
     REDIM MENU6(ELM(6)),MENU7(ELM(7))
     DSEG(1)=VARSEG(MENU1(1)):DOFS(1)=VARPTR(MENU1(1))
     DSEG(2)=VARSEG(MENU2(1)):DOFS(2)=VARPTR(MENU2(1))
     DSEG(3)=VARSEG(MENU3(1)):DOFS(3)=VARPTR(MENU3(1))
     DSEG(4)=VARSEG(MENU4(1)):DOFS(4)=VARPTR(MENU4(1))
     DSEG(5)=VARSEG(MENU5(1)):DOFS(5)=VARPTR(MENU5(1))
     DSEG(6)=VARSEG(MENU6(1)):DOFS(6)=VARPTR(MENU6(1))
     DSEG(7)=VARSEG(MENU7(1)):DOFS(7)=VARPTR(MENU7(1))
     RESTORE Menu3Data
        FOR I=3 TO 7                                             ' loop thru the menus
           ULR=ULR(I):ULC=ULC(I):LRR=LRR(I):LRC=LRC(I)           ' get the position
           GOSUB PullDownWindow                                  ' draw the window
           Y=ULC                                                 ' set the column for the text choices
           FOR X=ULR TO ULR+CHOICES(I)-1                         ' use this to set both the row and the number of reads
              READ A$ : GOSUB DXq                                ' read and write to the virtual screen
           NEXT X                                                ' loop til done
           TROW=ULR-1 : TCOL=ULC-1 : BROW=LRR+1 : BCOL=LRC+1     ' allow for the frame
           CALL VGETSCREEN(DSEG,DOFS,TROW,TCOL,BROW,BCOL,DSEG(I),DOFS(I)) ' copy from the scratch screen to the virtual screen
        NEXT I                                                   ' get next pull-down

     ' All 7 menus have been written to 7 virtual screens
     ' and are ready for instant display whenever we want.
     ' All of this code has taken less than 1/18th second
     ' to execute (at least on my 8Mhz, 1 wait state PC-AT).
     ' Putting it all in a nice tight loop would speed it
     ' up even more.

     ' We now clear the keyboard input buffer lest the
     ' user has hit a key before we were ready for it.

     CALL CLRKBD

     ' the very last thing we do before checking for
     ' input is to set the mouse range to the bar only,
     ' and set the mouse cursor to the location of the
     ' first choice on the menu bar.  We also give them
     ' a brief help message.

        IF MOUSE THEN
           GOSUB SetBarMouse                                     ' set the mouse for the bar only
           CALL SETMOUSELOC(BAR.ROW,LMPOS(1))                    ' position at first bar menu choice
        END IF

     CALL CALCATTR(GREY,BLACK,ATTR)
     Y=2
     X=23:A$="Use the arrow keys or the mouse to move the highlight on the bar menu or any"   : GOSUB Xq
     X=24:A$="pull-down menu and press Enter  or the left  mouse button.   To exit a menu,  " : GOSUB Xq
     X=25:A$="press Esc, the right button, or move the highlight up to the bar."              : GOSUB Xq

     ' Designing a demo that doubles as a training aid
     ' is not the easiest of chores.  This demo was
     ' originally written for ProBas 1.0 with 173 routines.
     ' By now (ProBas 3.0) there are 368 routines and not
     ' enough room to fit them all on the screen. We'll
     ' re-use the scratch array and take a snapshot,  pop
     ' up a window telling the user that this is a partial
     ' list of routines, and clear the window off when
     ' they have read it....

     DSEG=VARSEG(SCRATCH(1)): DOFS=VARPTR(SCRATCH(1))            ' get the address of the scratch array
     CALL DGETSCREEN(DSEG,DOFS,1,1,25,80,PAGE,SCRMODE)
     ULR=14 : ULC=45 : LRR=20 : LRC=75 : FRAME=2
     FORE=YELLOW : BACK=RED : SHADOW=-2
     CALL WindowManager(ULR,ULC,LRR,LRC,FRAME,FORE,BACK,_
                        GROW,SHADOW,LABEL,LABEL$,PAGE,SCRMODE)   ' draw the window on the screen
     Y=ULC+1 : CALL CALCATTR(WHITE,RED,ATTR)
     X=ULR : A$="This is a list of just some" : GOSUB Xq
     X=X+1 : A$="of the many screen routines" : GOSUB Xq
     X=X+1 : A$="in ProBas. There's just not" : GOSUB Xq
     X=X+1 : A$="enough room in the menus!"   : GOSUB Xq
     X=X+2 : A$="  Press a key when ready"    : GOSUB Xq
     Y=ULC+1 : CALL CALCATTR(LCYAN,RED,ATTR)
     CALL GETKEY3(MOUSE,CMD,CMD1,LFT,MID,RGT)
     CALL DPUTSCREEN(DSEG,DOFS,1,1,25,80,PAGE,SCRMODE)

     ' This section of the code is the real heart of the program.
     ' It handles almost all user input from either the keyboard
     ' or the mouse.  This routine can replace the Basic KEY and
     ' ON KEY statements which have a tremendous amount of
     ' overhead.  Additionally, this type of routine lets us
     ' display a constant clock on the screen and access the mouse.
     ' The main trick here is to make sure that the mouse and the
     ' arrow keys don't try and fight each other.  If the arrow
     ' key moves the highlight, the mouse position must be updated
     ' so that the pointers stay in synch.  Other modules in the
     ' demo have variations on this theme, especially DEMO3.BAS
     ' and DEMO6.BAS.

     ' In a nutshell, this section loops, waiting for a keypress
     ' or mouse click.  Once each loop it updates the on-screen
     ' time display and checks to see if the mouse has been
     ' moved.  If the mouse is moved enough, the routines that
     ' move the highlight are called.  When a keypress or mouse
     ' click is detected, a standard menu-type set of IF statements
     ' handle program flow.

     ' Once the Enter key is pressed or the left mouse button is
     ' clicked, the "DisplayMenu" routine displays the proper
     ' virtual screen and an ON MENU GOTO directs flow to the
     ' proper routine (Menu1: thru Menu7:).

     ' Please be sure to look at the routines Menu1: thru Menu7:
     ' Pay particular attention to Menu4:, Menu5: and especially
     ' Menu7: -- they all have some great demos of ProBas routines
     ' you have not yet seen.

     '------------------------------ main command ---------------------------

MainCom:                                                         ' the main keyboard/mouse input routine
     CLOCKOFF=0                                                  ' set the clock display back on in case it was turned off
        DO                                                       ' wait for a keypress or a mouse click
           CALL CHECKKEY3(MOUSE,CMD,CMD1,LFT,MID,RGT)            ' check for keypress or mouse click
           IF MOUSE THEN GOSUB MoveBarMouse                      ' check to see if the mouse has been moved
           GOSUB Clock                                           ' update the time
           CLICK=(CMD OR CMD1 OR LFT OR MID OR RGT)              ' if a keypress or mouse click then exit the while/wend loop
        LOOP UNTIL CLICK                                         ' keep on truckin'
        IF MENU<>0 AND CMD1=80 THEN GOSUB MoveHiDown:GOTO MainCom   ' down arrow  - move highlight down in menu
        IF MENU<>0 AND CMD1=72 THEN GOSUB MoveHiUp  :GOTO MainCom   ' up arrow    - move highlight up in menu
        IF MENU=0 AND CMD1=77  THEN GOSUB MoveHiRight:GOTO MainCom  ' right arrow - move right one choice on bar
        IF MENU=0 AND CMD1=75  THEN GOSUB MoveHiLeft :GOTO MainCom  ' left arrow  - move left one choice on bar
        IF LFT<>0 OR CMD=13    THEN GOTO CheckChoice             ' they pressed Enter or clicked left button
        IF MENU<>0 AND RGT<>0  THEN GOSUB ResetBar :GOTO MainCom ' click right button to exit pull-down
        IF MENU<>0 AND CMD=27  THEN GOSUB ResetBar :GOTO MainCom ' they exited the pull-down menu so reset the bar menu
        IF CMD=27 THEN GOTO Quit                                 ' if ESC then end
     GOTO MainCom                                                ' keep checking for input

MoveBarMouse:
     CALL GETMOUSELOC(MROW,MCOL)                                 ' get the current mouse location
        IF MROW=SROW AND MCOL=SCOL THEN RETURN                   ' the mouse has not moved since we last checked
        IF MENU<>0 THEN GOTO MenuMouse                           ' we have a menu active so we're not on the bar
        IF MROW<>BAR.ROW THEN GOTO MenuMouse                     ' remember that NOT MENU only works if MENU=0 or =-1
BarM2:
        IF MCOL>LMPOS(BARPOS) THEN GOSUB MoveHiRight : RETURN    ' move right one bar choice
        IF MCOL<RMPOS(BARPOS) THEN GOSUB MoveHiLeft              ' move left  one bar choice
     RETURN

MenuMouse:
        IF MROW<ULR(MENU) THEN GOSUB ResetBar : RETURN           ' mouse moved out of the pull-down so back to bar menu
        IF MROW>MENPOS+3 THEN GOSUB MoveHiDown: RETURN           ' mouse moved down 1 row or more
        IF MROW<MENPOS+3 THEN GOSUB MoveHiUp                     ' mouse moved up 1 row or more
     RETURN

ResetBar:
     A=ULR(MENU)-1:B=ULC(MENU)-1:C=LRR(MENU)+1:D=LRC(MENU)+1     ' this is the area that the pull-down overwrote
     XSEG=VARSEG(SCR2(1)): XOFS=VARPTR(SCR2(1))
     CALL DPUTSCREEN(XSEG,XOFS,A,B,C,D,PAGE,SCRMODE)             ' restore just the area that was overwritten
        IF MOUSE THEN GOSUB RB2                                  ' set the mouse range for the menu bar
     MENPOS=0 : MENPOSAVE=0                                      ' clear the pull-down menu locations
     MENU=0                                                      ' set the menu flag to no menu
     RETURN
RB2: GOSUB SetBarMouse                                           ' set the mouse range for the bar
     CALL SETMOUSELOC(BAR.ROW,LMPOS(BARPOS))                     ' set the mouse location
     MROW=BAR.ROW : MCOL=LMPOS(BARPOS)                           ' reset the mouse pointers...
     SROW=MROW    : SCOL=MCOL                                    ' old and new
     RETURN

DisplayMenu:
     MENU=BARPOS
        IF MENU=8 THEN GOTO Quit                                 ' the Quit choice has no menu!
     DSEG=DSEG(MENU)                                             ' pull the data seg...
     DOFS=DOFS(MENU)                                             ' and offset from storage array
     A=ULR(MENU)-1 : B=ULC(MENU)-1                               ' set the size of the virtual screen
     C=LRR(MENU)+1 : D=LRC(MENU)+1                               ' menu to display, allowing for the window frame
     XSEG=VARSEG(SCR2(1)): XOFS=VARPTR(SCR2(1))
     CALL DGETSCREEN(XSEG,XOFS,A,B,C,D,PAGE,SCRMODE)             ' take a snapshot the area that will be overwritten
     CALL DPUTSCREEN(DSEG,DOFS,A,B,C,D,PAGE,SCRMODE)             ' move menu from virtual to active screen
     OROW=ULR(MENU)  : NROW=OROW                                 ' set the row for the highlight
     OLPOS=ULC(MENU) : ORPOS=LRC(MENU)                           ' set the save columns
     NLPOS=ULC(MENU) : NRPOS=LRC(MENU)                           ' set the left/right sides of the highlight
        IF MOUSE THEN GOSUB SetMenuMouse                         ' set the mouse range and loc for pull-down
     GOSUB ReColorHighlight                                      ' highlight first choice in pull-down
     MENPOS=1 : MENPOSAVE=1                                      ' set the highlight pos for the vertical menu to 1
     RETURN

MoveHiRight:
     CALL CALCATTR(LCYAN,MAG,HMATTR)                             ' set the colors
        IF MONO THEN CALL CALCATTR(GREY,BLACK,HMATTR)            ' default doesn't look good in mono so change colors
        IF BARPOS=8 THEN GOTO MainCom                            ' if we're at the end, return (or we could wrap by setting BARPOS to 1)
     BARPOS=BARPOS+1                                             ' increment the pointer
     OROW=BAR.ROW : NROW=OROW                                    ' set the row
     OLPOS=LMPOS(BARPOSAVE): ORPOS=RMPOS(BARPOSAVE)              ' set the old left/right columns
     NLPOS=LMPOS(BARPOS)   : NRPOS=RMPOS(BARPOS)                 ' set the new left/right columns
     GOSUB ReColorHighlight                                      ' move the highlight
     BARPOSAVE=BARPOS                                            ' update the position pointer
        IF MOUSE THEN                                            ' feed the mouse the new position info
           CALL SETMOUSELOC(BAR.ROW,LMPOS(BARPOS))
           MROW=BAR.ROW : MCOL=LMPOS(BARPOS)
           SROW=MROW : SCOL=MCOL
        END IF
     RETURN                                                      ' done

MoveHiLeft:
     CALL CALCATTR(LCYAN,MAG,HMATTR)                             ' set the color
        IF MONO THEN CALL CALCATTR(GREY,BLACK,HMATTR)            ' default doesn't look good in mono so change colors
        IF BARPOS=1 THEN GOTO MainCom                            ' if full left then we can't go any farther, return
     BARPOS=BARPOS-1                                             ' decrement the pointer
     OROW=BAR.ROW : NROW=OROW                                    ' set the row
     OLPOS=LMPOS(BARPOSAVE): ORPOS=RMPOS(BARPOSAVE)              ' set the old left/right columns
     NLPOS=LMPOS(BARPOS)   : NRPOS=RMPOS(BARPOS)                 ' set the new left/right columns
     GOSUB ReColorHighlight                                      ' move the highlight
     BARPOSAVE=BARPOS                                            ' update the position pointer
        IF MOUSE THEN                                            ' feed the mouse the new position info
           CALL SETMOUSELOC(BAR.ROW,LMPOS(BARPOS))
           MROW=BAR.ROW : MCOL=LMPOS(BARPOS)
           SROW=MROW : SCOL=MCOL
        END IF
     RETURN                                                      ' done

MoveHiDown:
        IF MENPOS=CHOICES(MENU) THEN RETURN                      ' we are at the bottom menu choice
     CALL CALCATTR(LCYAN,BLACK,HMATTR)                           ' set the menu text color
     MENPOS=MENPOS+1                                             ' increment the pointer
     OROW=MENPOSAVE+3                                            ' set the old position
     NROW=MENPOS+3                                               ' set the new position
     OLPOS=ULC(MENU) : ORPOS=LRC(MENU)                           ' set the left and right columns
     NLPOS=ULC(MENU) : NRPOS=LRC(MENU)                           ' old and new...
     GOSUB ReColorHighlight                                      ' move the highlight
     MENPOSAVE=MENPOS                                            ' reset the pointer to the current position
        IF MOUSE THEN                                            ' if a mouse then feed it the new position
           CALL SETMOUSELOC(NROW,ULC(MENU))
           MROW=BROW : MCOL=ULC(MENU)
           SROW=MROW : SCOL=MCOL
        END IF
     RETURN                                                      ' done

MoveHiUp:
        IF MENPOS=1 THEN GOTO ResetBar                           ' close the pull-down and rest the menu bar
     CALL CALCATTR(LCYAN,BLACK,HMATTR)                           ' set the color
     MENPOS=MENPOS-1                                             ' decrement the pointer
     OROW=MENPOSAVE+3                                            ' set the old position
     NROW=MENPOS+3                                               ' set the new position
     OLPOS=ULC(MENU) : ORPOS=LRC(MENU)                           ' set the old left and right columns
     NLPOS=ULC(MENU) : NRPOS=LRC(MENU)                           ' set the new left and right columns
     GOSUB ReColorHighlight                                      ' move the highlight
     MENPOSAVE=MENPOS                                            ' reset the pointer
        IF MOUSE THEN                                            ' feed that hungry mouse
           CALL SETMOUSELOC(NROW,ULC(MENU))
           MROW=BROW : MCOL=ULC(MENU)
           SROW=MROW : SCOL=MCOL
        END IF
     RETURN                                                      ' done

CheckChoice:
        IF BARPOS=8 THEN GOTO Quit                               ' the Quit bar menu choice
     ON MENU GOTO Menu1,Menu2,Menu3,Menu4,Menu5,Menu6,Menu7
     GOSUB DisplayMenu : GOTO MainCom                            ' menu = 0 and they selected a pull-down menu

     '--------------------------- pull-down menu 1 --------------------------

Menu1:
     GOSUB SaveScreen3                                           ' take a snapshot of the screen
     WROW=MENPOS+4                                               ' set the window's upper left row and
     WCOL=NRPOS+3                                                ' column relative to the highlighted pull-menu choice
     ROFF=31                                                     ' right column offset for window
     X=WROW : Y=WCOL+1                                           ' set the text position in the window we will draw
     RESTORE Menu1Descriptions                                   ' restore the menu choice descriptions
     GOSUB GetAndDisplayText                                     ' the label says it all...
     GOTO MainCom                                                ' go back for another command

     '--------------------------- pull-down menu 2 --------------------------

Menu2:
     GOSUB SaveScreen3                                           ' take a snapshot of the screen
     WROW=MENPOS+4                                               ' set the window's upper left row and
     WCOL=NRPOS+3                                                ' column relative to the highlighted pull-menu choice
     ROFF=31                                                     ' right column offset for window
     X=WROW : Y=WCOL+1                                           ' set the text position in the window we will draw
     RESTORE Menu2Descriptions                                   ' restore the menu choice descriptions
     GOSUB GetAndDisplayText                                     ' the label says it all...
     GOTO MainCom                                                ' go back for another command

     '--------------------------- pull-down menu 3 --------------------------

Menu3:
     GOSUB SaveScreen3                                           ' take a snapshot of the screen
     WROW=MENPOS+4                                               ' set the window's upper left row and
     WCOL=NRPOS+3                                                ' column relative to the highlighted pull-menu choice
     X=WROW : Y=WCOL+1                                           ' set the text position in the window we will draw
     ROFF=31                                                     ' right column offset for window
     RESTORE Menu3Descriptions                                   ' restore the menu choice descriptions
     GOSUB GetAndDisplayText                                     ' the label says it all...
     GOTO MainCom                                                ' go back for another command

     '--------------------------- pull-down menu 4 --------------------------

Menu4:
     GOSUB SaveScreen3                                           ' take a snapshot of the screen
        IF MENPOS=1 THEN GOTO Menu4.1
     WROW=MENPOS+4                                               ' set the window's upper left row and
     WCOL=NRPOS+3                                                ' column relative to the highlighted pull-menu choice
     X=WROW : Y=WCOL+1                                           ' set the text position in the window we will draw
     ROFF=31                                                     ' right column offset for window
     RESTORE Menu4Descriptions                                   ' restore the menu choice descriptions
     GOSUB GetAndDisplayText                                     ' the label says it all...
     GOTO MainCom                                                ' go back for another command

Menu4.1:

     ' In this area we are going to use the WindowManager
     ' routine to fill in a box on the screen and display
     ' some text in it.  The box we are going to fill is
     ' where the calendar is normally displayed. You have
     ' already seen all of the techniques used here.

     AA=7 : BB=43 : CC=20 : DD=78 : FRAME=5
     FORE=GREY : BACK=BLUE: GROW=-1
     CALL WindowManager(AA,BB,CC,DD,FRAME,FORE,BACK,_
                        GROW,SHADOW,LABEL,LABEL$,PAGE,SCRMODE)   ' draw the window
     GOSUB SaveScreen4                                           ' save a snapshot of the blank window
     CALL CALCATTR(GREY,BLUE,ATTR)                               ' set the color
     Y=44                                                        ' set the column to print on
     RESTORE MouseText                                           ' restore the data
        FOR X=7 TO 20                                            ' loop from row 7 to row 20
           READ A$                                               ' read the data
           GOSUB Xq                                              ' write the data
        NEXT X                                                   ' loop till done
     CALL CALCATTR(WHITE,BLUE,ATTR)                              ' use a brighter intensity
     READ A$ : GOSUB Xq                                          ' print the bottom line "Press any key."
     GOSUB KeyClick                                              ' wait for a keypress or mouse click (routine at bottom)
     GOSUB RestoreScreen4                                        ' restore the screen
     CALL CALCATTR(GREY,BLUE,ATTR)                               ' reset the text color
        FOR X=7 TO 20                                            ' loop again
           READ A$                                               ' reading...
           GOSUB Xq                                              ' and writing the second text screen
        NEXT X                                                   ' until...
     CALL CALCATTR(WHITE,BLUE,ATTR)                              ' set the high intensity color
     READ A$ : GOSUB Xq                                          ' print the bottom line "Press any key."
     GOSUB KeyClick                                              ' wait for a keypress or mouse click
     GOSUB RestoreScreen3                                        ' restore the screen with the pull-down menu
     A$="":AA=0:BB=0:CC=0:DD=0                                   ' garbage variables
     GOTO MainCom                                                ' end of routine

     '--------------------------- pull-down menu 5 --------------------------

Menu5:
     GOSUB SaveScreen3                                           ' take a snapshot of the screen
        IF MENPOS=1 THEN GOTO Menu5.1                            ' display screen text
        IF MENPOS=2 THEN GOTO Menu5.2                            ' virtual screen text
     WROW=MENPOS+4                                               ' set the window's upper left row and
     WCOL=NRPOS+3                                                ' column relative to the highlighted pull-menu choice
     ROFF=29                                                     ' right column offset for window
     X=WROW : Y=WCOL                                             ' set the text position in the window we will draw
     RESTORE Menu5Descriptions                                   ' restore the menu choice descriptions
     GOSUB GetAndDisplayText                                     ' the label says it all...
     GOTO MainCom                                                ' go back for another command

Menu5.1:

     ' In this section, we are going to demonstrate a
     ' rather nifty feature of ProBas.   As you probably
     ' know, you can use the Basic BSAVE command to store
     ' a graphics screen to a binary file and use the
     ' BLOAD command to read it in from a file.  ProBas
     ' takes this a step farther and allows you to do the
     ' same thing with text files, storing full or partial
     ' screens to a random access file.  Unlike BLOAD,
     ' these routines allow you to read the data to the
     ' screen, a virtual screen array, or even into
     ' Lotus/Intel/Microsoft expanded memory.

     ' For this section, we will use some of the ProBas file
     ' routines to read a complete screen from a random
     ' access file into an array that we can then restore
     ' to the screen using either SCRSAVE, PUTSCREEN, or
     ' DPUTSCREEN.  The choice is ours.  The Probas file
     ' routines are far faster than BASIC's.

     ' We used the program PIX1.BAS to create the screens
     ' that are stored in the data file.  You may want to
     ' look at the source to PIX1.BAS to see just how
     ' simple it is.   There is also a library routine
     ' call Scr2File that writes a screen snapshot or
     ' virtual screen to a file.

     ' We will begin by choosing an array in which to store
     ' the picture.  We can use either a STATIC or a DYNAMIC
     ' array.  In this particular instance we are going to
     ' use a STATIC array since we have been showing you a
     ' lot of DYNAMIC arrays lately.  The array SCR4 was DIMed
     ' to 4000 bytes (2000 integer elements) at the beginning
     ' of the program.

     ' Let's start by getting the data segment and offset...

     PSEG=VARSEG(SCR4(1))
     POFS=VARPTR(SCR4(1))

     ' We then specify the file that stores the screens,
     ' set the access mode to read, the lock mode to none,
     ' and open the file...

     FIL$="SCRTEXT.DAT"                                          ' file name
     READWRITE=0                                                 ' open for read. 1= write, 2=read/write
     SHARING=2                                                   ' don't let others modify it
     CALL FOPEN(FIL$,READWRITE,SHARING,HANDLE,ECODE)             ' open the file and return the file handle
        IF ECODE THEN GOTO FileNoGood                            ' we had an error!

     ' The FOPEN routine opens the file, and returns a
     ' file handle.  This is the same as the file # used
     ' by BASIC.  We use the variable HANDLE to refer to
     ' the file from now on.

     ' We specify the number of bytes we want to read in
     ' from the file in BYTES.  The variable BYTESREAD
     ' returns the exact number of bytes that were read.

     BYTES=4000                                                  ' 2000 elements = 4000 bytes
     CALL DFREAD(HANDLE,PSEG,POFS,BYTES,BYTESREAD,ECODE)         ' read the first record in the file...
        IF ECODE THEN GOTO FileNoGood                            ' we had an error!

     ' DOS and assembly are not quite as forgiving as
     ' BASIC.  You must be sure to close the file!

     CALL FCLOSE(HANDLE)                                         ' close the file!

     ' We now have a snapshot in the array SCR4().  To
     ' display the screen, we can either do a
     ' GOSUB RestoreScreen4  (SCRREST) or specify the
     ' entire screen area and use PUTSCREEN or DPUTSCREEN.

     ' Remember, although there are many instances where
     ' these routines perform the same task,  each has a
     ' reason for being and works with different types of
     ' memory.   For example:
     '
     '    SCRREST     restores an entire screen
     '    PUTSCREEN   restores full or partial STATIC array
     '    DPUTSCREEN  restores full or partial STATIC or
     '                DYNAMIC array screen
     '
     ' While it is true that DPUTSCREEN could replace
     ' PUTSCREEN entirely, it requires more variables,
     ' and we like to make your life as easy as possible.

     CLOCKOFF=-1                                                 ' flag to turn the clock display off
     GOSUB RestoreScreen4                                        ' display the picture
     GOSUB KeyClick                                              ' wait for a keypress or mouse click
     GOSUB RestoreScreen3                                        ' restore the menu screen
     BYTES=0:BYTEREAD=0:HANDLE=0:PSEG=0:POFS=0:FIL$=""           ' clear the garbage variables
     GOTO MainCom                                                ' done!

Menu5.2:

     ' This section is basically a repeat of 'Menu5.1',
     ' but this time we are going to read the second
     ' and third records in the random access file.

     PSEG=VARSEG(SCR4(1))
     POFS=VARPTR(SCR4(1))
     FIL$="SCRTEXT.DAT"                                          ' file name
     READWRITE=0                                                 ' open for read. 1=write, 2=read/write
     SHARING=2                                                   ' nobody else can change it
     CALL FOPEN(FIL$,READWRITE,SHARING,HANDLE,ECODE)             ' open the file and return the file handle
        IF ECODE THEN GOTO FileNoGood                            ' we had an error!

     ' To read the second and third records, we specify
     ' the size of the random access record in the
     ' variable RECSIZE and the record number to read
     ' in RECNUMBER...

     RECSIZE=4000                                                ' 4000-byte records
     RECNUMBER=2                                                 ' specify record 2
     BYTES=4000                                                  ' 2000 elements = 4000 bytes
     CALL FSETREC(HANDLE,RECSIZE,RECNUMBER)                      ' set the record pointer
     CALL DFREAD(HANDLE,PSEG,POFS,BYTES,BYTESREAD,ECODE)         ' read the second record
        IF ECODE THEN GOTO FileNoGood                            ' we had an error!
     CLOCKOFF=-1                                                 ' flag to turn the clock display off
     GOSUB RestoreScreen4                                        ' display the picture
     GOSUB KeyClick                                              ' wait for a keypress or mouse click
     RECNUMBER=3                                                 ' read record 3
     CALL FSETREC(HANDLE,RECSIZE,RECNUMBER)                      ' set the record pointer
     CALL DFREAD(HANDLE,PSEG,POFS,BYTES,BYTESREAD,ECODE)         ' read the third record
        IF ECODE THEN GOTO FileNoGood                            ' we had an error!
     CALL FCLOSE(HANDLE)                                         ' remember to close the file!
     GOSUB RestoreScreen4                                        ' display the picture
     GOSUB KeyClick                                              ' wait for a keypress or mouse click
     GOSUB RestoreScreen3                                        ' restore the menu screen
     BYTES=0:BYTEREAD=0:HANDLE=0:PSEG=0:POFS=0:FIL$=""           ' clear the garbage variables
     RECSIZE=0:RECNUMBER=0
     GOTO MainCom                                                ' done!

FileNoGood:
     CLOCKOFF=0                                                  ' reset the clock display to on
     GOSUB ClearCommand                                          ' clear the command line
     PRINT "Error!  Unable to open the data file.  Press any key:";
     GOSUB KeyClick                                              ' wait for a keypress or mouse click
     GOSUB RestoreScreen3                                        ' restore the menu screen
     BYTES=0:BYTEREAD=0:HANDLE=0:PSEG=0:POFS=0:FIL$=""           ' clear the garbage variables
     RECSIZE=0:RECNUMBER=0
     GOTO MainCom                                                ' done!

     '--------------------------- pull-down menu 6 --------------------------

Menu6:
     GOSUB SaveScreen3                                           ' take a snapshot of the screen
        IF MENPOS=1 THEN GOTO Menu6.1                            ' display screen text
     WROW=MENPOS+4                                               ' set the window's upper left row and
     WCOL=NLPOS-34                                               ' column relative to the highlighted pull-menu choice
     ROFF=31                                                     ' right column offset for window
     X=WROW : Y=WCOL+1                                           ' set the text position in the window we will draw
     RESTORE Menu6Descriptions                                   ' restore the menu choice descriptions
     GOSUB GetAndDisplayText                                     ' the label says it all...
     GOTO MainCom                                                ' go back for another command

Menu6.1:

     ' This routine is basically the same as the those
     ' at Menu5.1 and Menu5.2.  It reads a snapshot of
     ' a screen from a random access file.  Here it is
     ' without our verbose narrative...

     PSEG=VARSEG(SCR4(1))
     POFS=VARPTR(SCR4(1))
     FIL$="SCRTEXT.DAT"                                          ' file name
     READWRITE=0 : SHARING=2                                     ' mode and prevent change
     CALL FOPEN(FIL$,READWRITE,SHARING,HANDLE,ECODE)             ' open the file and return the file handle
        IF ECODE THEN GOTO FileNoGood                            ' we had an error!
     RECSIZE=4000 : RECNUMBER=4 : BYTES=4000                     ' specify what to read
     CALL FSETREC(HANDLE,RECSIZE,RECNUMBER)                      ' set the record pointer
     CALL DFREAD(HANDLE,PSEG,POFS,BYTES,BYTESREAD,ECODE)         ' read the second record
        IF ECODE THEN GOTO FileNoGood                            ' we had an error!
     CALL FCLOSE(HANDLE)                                         ' remember to close the file!
     CLOCKOFF=-1                                                 ' flag to turn the clock display off
     GOSUB RestoreScreen4                                        ' display the picture
     GOSUB KeyClick                                              ' wait for a keypress or mouse click
     GOSUB RestoreScreen3                                        ' restore the menu screen
     BYTES=0:BYTEREAD=0:HANDLE=0:PSEG=0:POFS=0:FIL$=""           ' clear the garbage variables
     RECSIZE=0:RECNUMBER=0
     GOTO MainCom                                                ' done!

     '--------------------------- pull-down menu 7 --------------------------

Menu7:
     GOSUB SaveScreen3                                           ' take a snapshot of the screen
        IF MENPOS=1 THEN GOTO Menu7.1                            ' display screen text
        IF MENPOS=2 THEN GOTO Menu7.2                            ' display screen text and moving window demo
        IF MENPOS=3 THEN GOTO Menu7.3                            ' display screen text and moving window demo
     WROW=MENPOS+4                                               ' set the window's upper left row and
     WCOL=NLPOS-34                                               ' column relative to the highlighted pull-menu choice
     ROFF=31                                                     ' right column offset for window
     X=WROW : Y=WCOL+1                                           ' set the text position in the window we will draw
     RESTORE Menu7Descriptions                                   ' restore the menu choice descriptions
     GOSUB GetAndDisplayText                                     ' the label says it all...
     GOTO MainCom                                                ' go back for another command

Menu7.1:

     ' Once again we are reading a screen from the file,
     ' but with a major difference on how we handle it
     ' once it's in memory.
     ' Read on MacDuff!

     PSEG=VARSEG(SCR4(1))
     POFS=VARPTR(SCR4(1))
     FIL$="SCRTEXT.DAT"                                          ' file name
     READWRITE=0 : SHARING=2                                     ' mode and prevent change
     CALL FOPEN(FIL$,READWRITE,SHARING,HANDLE,ECODE)             ' open the file and return the file handle
        IF ECODE THEN GOTO FileNoGood                            ' we had an error!
     RECSIZE=4000 : RECNUMBER=5 : BYTES=4000                     ' specify what to read
     CALL FSETREC(HANDLE,RECSIZE,RECNUMBER)                      ' set the record pointer
     CALL DFREAD(HANDLE,PSEG,POFS,BYTES,BYTESREAD,ECODE)         ' read the second record
        IF ECODE THEN GOTO FileNoGood                            ' we had an error!
     CALL FCLOSE(HANDLE)                                         ' remember to close the file!

     ' Here we want to restore a partial screen from
     ' the full screen snapshot we read into SCR4().
     ' The easiest way to handle this is to copy the
     ' partial screen to a second virtual screen and
     ' then restore to the active screen.  We will
     ' use the STATIC array SCR5()...

     P1SEG=VARSEG(SCR5(1))
     P1OFS=VARPTR(SCR5(1))

     ' we specify the area of the full screen (SCR4)
     ' to copy to SCR5 and use VGETSCREEN to do the
     ' copy.  Since SCR5 is a static array that
     ' was DIMed at the start of the program, there
     ' is no need to do a DIM or CALCSIZE.

     A=1 : B=1 : C=19 : D=40                                     ' the area in the full-sized screen
     CALL VGETSCREEN(PSEG,POFS,A,B,C,D,P1SEG,P1OFS)              ' copy the partial to the virtual

     ' Now that we have just the partial screen in the
     ' array, we can specify the area of the active display
     ' screen to restore the partial screen to and use
     ' DPUTSCREEN for the write.

     CALL DPUTSCREEN(P1SEG,P1OFS,3,2,21,41,PAGE,SCRMODE)         ' restore the partial screen
     GOSUB KeyClick                                              ' wait for a keypress or mouse click
     GOSUB RestoreScreen3                                        ' restore the menu screen
     BYTES=0:BYTEREAD=0:HANDLE=0:PSEG=0:POFS=0:FIL$=""           ' clear the garbage variables
     RECSIZE=0:RECNUMBER=0:P1SEG=0:P1OFS=0:A=0:B=0:C=0:D=0       ' clear the garbage variables
     GOTO MainCom                                                ' done!

Menu7.2:

     ' this is basically the same as Menu7.1, except
     ' we are using a different partial screen that
     ' was stored in the same random access record.
     ' We have to read it in again in case the user
     ' does not invoke each menu choice in order.

     PSEG=VARSEG(SCR4(1))
     POFS=VARPTR(SCR4(1))
     FIL$="SCRTEXT.DAT"                                          ' file name
     READWRITE=0 : SHARING=2                                     ' mode and prevent change
     CALL FOPEN(FIL$,READWRITE,SHARING,HANDLE,ECODE)             ' open the file and return the file handle
        IF ECODE THEN GOTO FileNoGood                            ' we had an error!
     RECSIZE=4000 : RECNUMBER=5 : BYTES=4000                     ' specify what to read
     CALL FSETREC(HANDLE,RECSIZE,RECNUMBER)                      ' set the record pointer
     CALL DFREAD(HANDLE,PSEG,POFS,BYTES,BYTESREAD,ECODE)         ' read the second record
        IF ECODE THEN GOTO FileNoGood                            ' we had an error!
     CALL FCLOSE(HANDLE)                                         ' remember to close the file!
     P1SEG=VARSEG(SCR5(1))
     P1OFS=VARPTR(SCR5(1))
     A=1 : B=41 : C=19 : D=80                                    ' specify the area of the full screen we want
     CALL VGETSCREEN(PSEG,POFS,A,B,C,D,P1SEG,P1OFS)              ' copy from the full screen to the partial
     CALL DPUTSCREEN(P1SEG,P1OFS,3,2,21,41,PAGE,SCRMODE)         ' restore the partial screen
     GOSUB KeyClick                                              ' wait for a keypress or mouse click
     GOSUB RestoreScreen3                                        ' restore the menu screen

     '--- moving windows

     ' This routine will demonstrate the technique for
     ' moving a window around the screen.  Here are the
     ' steps involved.
     '
     ' 1  Take a snapshot of the entire screen and store it
     '    to SCR4().
     ' 2  Draw the window on the screen with WindowManager.
     ' 3  Take a snapshot of just the window and store it
     '    to SCR5().  We are using these two arrays only
     '    because we already have the pointers PSEG and
     '    POFS (SCR4) and P1SEG and P1OFS (SCR5) in memory
     '    from reading in the screen from the data file.
     ' 4  Each time the window is moved, we:
     '      a  Draw the window to the new location on the
     '         screen from the snapwhot of it in SCR5().
     '      b  Take a snapshot of the row or column the window
     '         just vacated from SCR4() and put in in a scratch
     '         array using the VGETSCREEN routine.  This is
     '         necessary so the assembly routines can keep all
     '         the row/column offsets correct.
     '      c  Restore the recently vacated row or column as
     '         the case may be from the scratch array to the
     '         display screen.

     ' At first reading this may sound convoluted, but it's
     ' really only three steps:  Draw, Snap, and Restore.

     ' We begin by dimensioning a small virtual screen to
     ' hold the row or column the window vacates.  Since
     ' our window is 12 rows by 32 columns, we need to size
     ' it to the largest save needed, or 32 elements.  This
     ' is possible because we will only be working with one
     ' row or one column at a time.

Drag:
     REDIM SCRATCH(32)
     TSEG=VARSEG(SCRATCH(1))
     TOFS=VARPTR(SCRATCH(1))

     ' We then save the current menu choice highlight
     ' location and set the mouse range to the entire
     ' screen area...

     SAVEMROW=MROW : SAVEMCOL=MCOL : SAVEMEN=MENPOS              ' save the current highlight row
     A=1 : B=1 : C=25 : D=80                                     ' define entire screen
        IF MOUSE THEN CALL SETMOUSERANGE(A,B,C,D)                ' set mouse range

     ' While we are setting things up, let's use the
     ' DCLEAR routine to do a 'CLS' of SCR5.

     CALL DCLEAR(P1SEG,P1OFS,ATTR)                               ' cls SCR5

     ' Now we take a snapshot of the current screen and
     ' save it in SCR4.  The subroutine SaveScreen4
     ' does this for us using the SCRSAVE routine.

     GOSUB SaveScreen4                                           ' store a snapshot of the screen in SCR4

     ' We draw the window to the active display screen
     ' and save a snapshot of just the window to SCR5.
     ' Since we are dealing with a partial screen, we
     ' must use the DGETSCREEN routine rather than
     ' GETSCREEN or SCRREST.

     ULR=2 : ULC=2 : LRR=11 : LRC=31 : FRAME=2                   ' set the window location
     FORE=GREY : BACK=RED : LABEL=WHITE                          ' and colors
     LABEL$="Moving Windows"                                     ' and title
     CALL WindowManager(ULR,ULC,LRR,LRC,FRAME,FORE,BACK,_
                        GROW,SHADOW,LABEL,LABEL$,PAGE,SCRMODE)   ' draw the window on the screen
     Y=ULC+1: CALL CALCATTR(LCYAN,BACK,ATTR)                     ' set the column pos and the color for the text
     X=ULR+1: A$="You can use the routines in" : GOSUB Xq        ' display the text inside the window...
     X=X+1 : A$="ProBas to do  sophisticated" : GOSUB Xq
     X=X+1 : A$="tasks, such as moving  your" : GOSUB Xq
     X=X+1 : A$="windows with a mouse or the" : GOSUB Xq
     X=X+1 : A$="arrow keys. If you're using" : GOSUB Xq
     X=X+1 : A$="a mouse, press and hold the" : GOSUB Xq
     X=X+1 : A$="the right button."           : GOSUB Xq
     CALL CALCATTR(YELLOW,BACK,ATTR)
     X=X+2 : A$=" ESC or Left Button to end"  : GOSUB Xq

     ULR=ULR-1 : ULC=ULC-1 : LRR=LRR+1 : LRC=LRC+1               ' allow for frame
     CALL DGETSCREEN(P1SEG,P1OFS,ULR,ULC,LRR,LRC,PAGE,SCRMODE)   ' take snapshot of just the window

        IF MOUSE THEN                                            ' set the mouse cursor to the top right corner
           MROW=ULR : MCOL=ULC
           SROW=MROW : SCOL=MCOL
           CALL SETMOUSELOC(MROW,MCOL)
        END IF

     ' We now have the necessary screens in memory.  We
     ' use this routine to get user input.  It checks to
     ' see if there is a key press, button click, or mouse
     ' movement, and reacts accordingly.

        DO
           GOSUB Clock                                           ' update the display clock
              IF MOUSE THEN CALL MMBUTTON(LBUTTON,RBUTTON)       ' check if a button is being held down
           CALL CHECKKEY3(MOUSE,CMD,CMD1,LFT,MID,RGT)            ' check for keypress or mouse click
              IF RBUTTON THEN                                    ' if right button then we are moving the mouse
                 GOSUB MouseWind
              ELSEIF CMD1=72 THEN                                ' up arrow key scan code
                 GOSUB MoveWindUp
              ELSEIF CMD1=80 THEN                                ' down arrow key scan code
                 GOSUB MoveWindDown
              ELSEIF CMD1=75 THEN                                ' left arrow key scan code
                 GOSUB MoveWindLeft
              ELSEIF CMD1=77 THEN                                ' right arrow key scan code
                 GOSUB MoveWindRight
              ELSEIF LFT THEN                                    ' if left click then exit
                 CMD=27
              END IF
        LOOP UNTIL CMD=27

     ' if they hit the Esc key or click the left
     ' mouse button, control drops out of the
     ' while/wend loop.  We clean everything up
     ' and return to the main routine.

        IF MOUSE THEN                                            ' set the mouse back to just the pull-down area
           GOSUB SetMenuMouse
           MROW=SAVEMROW : SROW=MROW
           MCOL=SAVEMCOL : SCOL=MCOL
           CALL SETMOUSELOC(MROW,MCOL)
        END IF
     MENPOS=SAVEMEN : MENPOSAVE=MENPOS                           ' restore the pointer back to the #3 menu choice
     GOSUB RestoreScreen3                                        ' restore the screen
     BYTES=0:BYTESREAD=0:HANDLE=0:PSEG=0:POFS=0:FIL$=""          ' clear the garbage variables
     RECSIZE=0:RECNUMBER=0:P1SEG=0:P1OFS=0:TSEG=0:TOFS=0         ' clear the garbage variables
     GOTO MainCom                                                ' go back to the main command routine

     ' This routine checks to see if the mouse was
     ' moved.  If so, it branches to the same routines
     ' as if they pressed the arrow keys in the loop
     ' above.  (Working with a mouse AND arrow keys
     ' sometimes requires a little duplication).

MouseWind:
     CALL GETMOUSELOC(MROW,MCOL)                                 ' get the current mouse location
        IF MROW<SROW THEN                                        ' up one or more rows
           GOSUB MouseUp
        ELSEIF MROW>SROW THEN                                    ' down one or more rows
           GOSUB MouseDown
        ELSEIF MCOL<SCOL THEN                                    ' left one or more columns
           GOSUB MouseLeft
        ELSEIF MCOL>SCOL THEN                                    ' right one or more columns
           GOSUB MouseRight
        END IF
     RETURN                                                      ' mouse did not move since last check

     ' These routines set up moving the window..

MouseUp:
     GOSUB MoveWindUp                                            ' do the move
     MROW=ULR : MCOL=ULC                                         ' reset the current row/column
        IF MOUSE THEN CALL SETMOUSELOC(MROW,MCOL)                ' reset the mouse location to the window
     SROW=MROW                                                   ' set the mouse row so we can compare and see if it moves
     RETURN

MouseDown:
     GOSUB MoveWindDown                                          ' do the move
     MROW=ULR : MCOL=ULC                                         ' reset the current row/column
        IF MOUSE THEN CALL SETMOUSELOC(MROW,MCOL)                ' reset the mouse location to the window
     SROW=MROW                                                   ' set the mouse row so we can compare and see if it moves
     RETURN                                                      ' go back for more input

MouseLeft:
     GOSUB MoveWindLeft                                          ' do the move
     MROW=ULR : MCOL=ULC                                         ' reset the current row/column
        IF MOUSE THEN CALL SETMOUSELOC(MROW,MCOL)                ' reset the mouse location to the window
     SCOL=MCOL                                                   ' set the mouse row so we can compare
     RETURN

MouseRight:
     GOSUB MoveWindRight                                         ' do the move
     MROW=ULR : MCOL=ULC                                         ' reset the current row/column
        IF MOUSE THEN CALL SETMOUSELOC(MROW,MCOL)                ' reset the mouse location to the window
     SCOL=MCOL                                                   ' set the mouse row so we can compare
     RETURN

     ' These routines actually move the window and
     ' restore the vacated row or column.

MoveWindUp:
        IF ULR=1 THEN RETURN
     CALL DPUTSCREEN(P1SEG,P1OFS,ULR-1,ULC,LRR-1,LRC,PAGE,SCRMODE) ' write the window
     CALL VGETSCREEN(PSEG,POFS,LRR,ULC,LRR,LRC,TSEG,TOFS)        ' snap the cover-up row
     CALL DPUTSCREEN(TSEG,TOFS,LRR,ULC,LRR,LRC,PAGE,SCRMODE)     ' dispay the cover-up row
     ULR=ULR-1                                                   ' decrement upper row
     LRR=LRR-1                                                   ' decrement lower row
     RETURN

MoveWindDown:
        IF LRR=25 THEN RETURN
     CALL DPUTSCREEN(P1SEG,P1OFS,ULR+1,ULC,LRR+1,LRC,PAGE,SCRMODE)' write the window
     CALL VGETSCREEN(PSEG,POFS,ULR,ULC,ULR,LRC,TSEG,TOFS)        ' snap the cover-up row
     CALL DPUTSCREEN(TSEG,TOFS,ULR,ULC,ULR,LRC,PAGE,SCRMODE)     ' dispay the cover-up row
     ULR=ULR+1                                                   ' increment upper row
     LRR=LRR+1                                                   ' increment lower row
     RETURN

MoveWindLeft:
        IF ULC=1 THEN RETURN
     CALL DPUTSCREEN(P1SEG,P1OFS,ULR,ULC-1,LRR,LRC-1,PAGE,SCRMODE) ' write the window
     CALL VGETSCREEN(PSEG,POFS,ULR,LRC,LRR,LRC,TSEG,TOFS)        ' snap the cover-up column
     CALL DPUTSCREEN(TSEG,TOFS,ULR,LRC,LRR,LRC,PAGE,SCRMODE)     ' display the cover-up column
     ULC=ULC-1                                                   ' decrement the left row
     LRC=LRC-1                                                   ' decrement the right row
     RETURN

MoveWindRight:
        IF LRC=80 THEN RETURN
     CALL DPUTSCREEN(P1SEG,P1OFS,ULR,ULC+1,LRR,LRC+1,PAGE,SCRMODE) ' write the window
     CALL VGETSCREEN(PSEG,POFS,ULR,ULC,LRR,ULC,TSEG,TOFS)        ' snap the cover-up column
     CALL DPUTSCREEN(TSEG,TOFS,ULR,ULC,LRR,ULC,PAGE,SCRMODE)     ' display the cover-up column
     ULC=ULC+1                                                   ' increment left column
     LRC=LRC+1                                                   ' increment right column
     RETURN

     '-------------------------- wonder windows -----------------------------

Menu7.3:
     DIM SNAP(30000),SNAP1(30000)
     X$=" Hammerly Computer Services, Inc."
     COUNT=1
        FOR I=1 TO 300
           ULR=FNRAN(15)+1
           ULC=FNRAN(55)+1
           LRR=ULR+FNRAN(15) : IF LRR>24 THEN LRR=24
           LRC=ULC+FNRAN(35) : IF LRC>79 THEN LRC=79
           FRAME=FNRAN(4)
           FORE=FNRAN(16)-1
Ww1:       BACK=FNRAN(8)-1 : IF BACK=FORE THEN GOTO Ww1
           LABEL$=MID$(STR$(I),2)
Ww2:       LABEL=FNRAN(16)-1 : IF LABEL=BACK THEN GOTO Ww2
           CALL WindowManager(ULR,ULC,LRR,LRC,FRAME,FORE,BACK,_
                              GROW,SHADOW,LABEL,LABEL$,PAGE,SCRMODE)
           Z=FNRAN(16)-1 : CALL CALCATTR(Z,BACK,ATTR)
           Y=ULC : A$=LEFT$(X$,LRC-ULC+1)
              FOR X=ULR TO LRR
                 GOSUB Xq
              NEXT X
           IF COUNT=20 THEN
              DSEG=VARSEG(SNAP1(PTR))
              DOFS=VARPTR(SNAP1(PTR))
              CALL DGETSCREEN(DSEG,DOFS,1,1,25,80,PAGE,SCRMODE)
              PTR=PTR+2000
              COUNT=0
           END IF
           IF COUNT=10 THEN
              DSEG=VARSEG(SNAP(PTR))
              DOFS=VARPTR(SNAP(PTR))
              CALL DGETSCREEN(DSEG,DOFS,1,1,25,80,PAGE,SCRMODE)
           END IF
           COUNT=COUNT+1
        NEXT I
     PTR=PTR-2000
     CALL GETKEY3(MOUSE,CMD,CMD1,LFT,MID,RGT)
        WHILE PTR>=0
           DSEG=VARSEG(SNAP1(PTR))
           DOFS=VARPTR(SNAP1(PTR))
           CALL DSCRREST(DSEG,DOFS,PAGE,SCRMODE)
           CALL DELAY18TH(1)
           DSEG=VARSEG(SNAP(PTR))
           DOFS=VARPTR(SNAP(PTR))
           CALL DSCRREST(DSEG,DOFS,PAGE,SCRMODE)
           CALL DELAY18TH(1)
           PTR=PTR-2000
        WEND
     ERASE SNAP,SNAP1
     GOSUB RestoreScreen3
     GOTO MainCom

     '---------------- get and display menu choice descriptions -------------

GetAndDisplayText:

      ' this subroutine is called by the routines at labels
      ' Menu1 thru Menu7 to display a window with a text
      ' description of each ProBas routine in the pull-down
      ' menus.  We loop from 1 to the current menu choice,
      ' so that when we finish, A$ contains the appropriate
      ' data statement.

        FOR J=1 TO MENPOS                                        ' read through the data statements...
           READ A$                                               ' til we reach the one we want...
        NEXT J                                                   ' now we have it!
     REDIM A$(20)                                                ' set up an array for text descriptions

     ' This is an example of using the ProBas routine EXTRACT
     ' to extract a delimited portion of a string.  Refer to
     ' the data statements at label "Menu1Descriptions".  See
     ' how we are using the vertical bar character to delimit
     ' the string?  The variable SLEN returns the length of the
     ' delimited string.  We also use SLEN to tell us when we
     ' reach the end of the string.  We set SLEN=1 just to fool
     ' the while/wend loop long enough to get the first part of
     ' the string.  The variable ST returns the STarting offset
     ' in the string.  We use MID$ to pull the delimited string
     ' and put it in an array.  We then increment the pointer
     ' INDEX to keep track of how many elements we have in our
     ' array.

     ' We could have just used a formula with MID$ here, since
     ' we are extracting records of a fixed length.  EXTRACT is
     ' more useful with variable-length delimited records.
     ' This is just an example to show you how EXTRACT works!

     INDEX=0                                                     ' set/clear pointers
     DELIM$="|"                                                  ' specify the delimiter
        DO                                                       ' loop
           INDEX=INDEX+1                                         ' increment the pointer
           CALL EXTRACT(A$,DELIM$,INDEX,ST,SLEN)                 ' do the call
           A$(INDEX)=MID$(A$,ST,SLEN)                            ' load the delimited string into array
        LOOP WHILE SLEN>0                                        ' loop til done

     ' We now have INDEX lines of text stored in the
     ' A$() array.  We'll draw a small window in which
     ' to display the text. Since this will be an
     ' exploding window, let's slow it down by saving
     ' the current value of SCRMODE and forcing it to 0
     ' so that the routines use the slower snow
     ' suppression on color displays.

     SS=SCRMODE : SCRMODE=0                                      ' save the mode and force it to slow for a growing window

     ' We use the variables passed by the Menu1-Menu7
     ' routines to position the window, making sure that
     ' it stays on the screen.  We set the right column of
     ' the window to the offset in ROFF so that the windows
     ' can be different sizes from menu to menu...

     UR=WROW : UC=WCOL : LR=UR+INDEX-2 : LC=UC+ROFF              ' use different variables so we don't mess up the menu vars!
        IF LR>24 THEN UR=25-INDEX : LR=UR+INDEX-2 : X=UR         ' make sure the window stays on the screen
     F=LRED  : B=MAG   : FR=2 : GROW=-1                          ' use a growing window for giggles
     CALL WindowManager(UR,UC,LR,LC,FR,F,B,_
                        GROW,SHADOW,LABEL,LABEL$,PAGE,SCRMODE)   ' draw the window

     ' Now that the window is drawn, reset the SCRMODE
     ' variable back to its proper value, set a color,
     ' and display the text inside the window.

     SCRMODE=SS : SS=0                                           ' reset the screen mode (fast/slow)
     CALL CALCATTR(WHITE,MAG,ATTR)                               ' set the color for the text in the window
        FOR J=1 TO INDEX                                         ' loop through the array
           A$=A$(J) : GOSUB Xq                                   ' write the text
           X=X+1                                                 ' increment the row pointer for text
        NEXT J                                                   ' loop til done

     ' we'll just wait here for the user to press a key
     ' or click the mouse.  When they do, we'll clean up
     ' the garbage, restore the screen, and return to
     ' the pull-down menu that called us.

     GOSUB KeyClick                                              ' wait for a keypress or mouse click
     ERASE A$:A$="":DELIM$="":INDEX=0:ST=0:SLEN=0:J=0:L=0:R=0    ' clear all these garbage variables
     WROW=0:WCOL=0:UR=0:UC=0:LR=0:LC=0:F=0:B=0:FR=0              ' clear these too, they're disposable
     GOSUB RestoreScreen3                                        ' restore the screen snapshot
     RETURN                                                      ' we're all done here

     '----------------------------- menu choices ----------------------------

BarMenuData:
     DATA "List 1",2,9
     DATA "List 2",10,17
     DATA "List 3",18,25
     DATA "Mouse",26,32
     DATA "Snapshots",33,43
     DATA "DOS (ANSI)",44,55
     DATA "Windows",56,64
     DATA "Quit",65,70

LastRowData:
     DATA 19,19,18,12,16,13,5

Menu1Data:
     DATA BKSCROLL
     DATA BKSPACE
     DATA CALCATTR
     DATA CALCSIZE
     DATA CLREOL
     DATA DCLEAR
     DATA DELCHR
     DATA DISSOLVE
     DATA DGETSCREEN
     DATA DMPRINT
     DATA DPUTSCREEN
     DATA DWindowManager
     DATA DXQPRINT
     DATA FADEOUT
     DATA GETCRT
     DATA GETEGA
     DATA GETLINE
     DATA GETMOUSELOC
     DATA GETSCREEN

Menu2Data:
     DATA GETVIDMODE
     DATA GLOAD
     DATA GRAFREST
     DATA GRAFSAVE
     DATA INSCHR
     DATA LSCROLL
     DATA MDELCHR
     DATA MINSCHR
     DATA MMBUTTON
     DATA MMCHECK
     DATA MMCLICK
     DATA MMCURSOROFF
     DATA MMCURSORON
     DATA MMGETLOC
     DATA MMSETLOC
     DATA MMSETRANGE
     DATA MPRINT
     DATA MWINDOW
     DATA PRINTSCREEN

MenuPositions:
     DATA 4,18,21,31
     DATA 4,26,15,39
     DATA 4,33,19,47
     DATA 4,44,16,58
     DATA 4,56,8,70

Menu3Data:
     DATA PUTSCREEN
     DATA RECOLOR
     DATA RECOLORAREA
     DATA RESETPOINT
     DATA RSCROLL
     DATA Scr2File
     DATA SCROLL
     DATA SCRREST
     DATA SCRSAVE
     DATA SETMOUSELOC
     DATA SETMOUSERANGE
     DATA SETPOINT
     DATA TESTPOINT
     DATA VGETSCREEN
     DATA VPUTSCREEN
     DATA WindowManager
     DATA XMPRINT
     DATA XQPRINT

Menu4Data:
     DATA Mouse Routines
     DATA GETMOUSELOC
     DATA MMBUTTON
     DATA MMCHECK
     DATA MMCLICK
     DATA MMCURSOROFF
     DATA MMCURSORON
     DATA MMGETLOC
     DATA MMSETLOC
     DATA MMSETRANGE
     DATA SETMOUSELOC
     DATA SETMOUSERANGE

Menu5Data:
     DATA Display Screens
     DATA Virtual Screens
     DATA CALCSIZE
     DATA DCLEAR
     DATA DGETSCREEN
     DATA DPUTSCREEN
     DATA DYNPTR
     DATA GETSCREEN
     DATA GRAFREST
     DATA GRAFSAVE
     DATA PUTSCREEN
     DATA Scr2File
     DATA SCRREST
     DATA SCRSAVE
     DATA VGETSCREEN
     DATA VPUTSCREEN

Menu6Data:
     DATA DOS Output
     DATA BKSPACE
     DATA CLREOL
     DATA DELCHR
     DATA DMPRINT
     DATA GETLINE
     DATA INSCHR
     DATA MDELCHR
     DATA MINSCHR
     DATA MPRINT
     DATA MWINDOW
     DATA PRINTSCREEN
     DATA XMPRINT

Menu7Data:
     DATA About  Windows
     DATA Moving Windows
     DATA Wonder Windows
     DATA DWindowManager
     DATA WindowManager

     '------------------------------ descriptions ---------------------------

Menu1Descriptions:
     DATA "Allows you to scroll 1 or more|lines of text  backwards.  Its|complement is SCROLL."
     DATA "This routine is a  destructive|backspace.  It's more flexible|than using PRINT CHR$(29)."
     DATA "Calculates the color attribute|(foreground/background) so you|don't have to figure the color|with an awkward formula."
     DATA "Calculates the size to  DIM or|REDIM a  DYNAMIC array for use|as a virtual screen."
     DATA "Clears from the cursor to the |end of the line, fast."
     DATA "Clears a virtual screen in the|same manner that  CLS clears a|display screen."
     DATA "Deletes a  character and pulls|the rest of the characters  on|the line left."
     DATA "A cute way of  clearing a text|screen by 'dissolving' it."
     DATA "Takes a  snapshot of a full or|partial screen and store it to|an array (virtual screen)."
     DATA "Display a string using the DOS|calls for output.  This allows|you to use device drivers like|ANSI.SYS, and redirection."
     DATA "Restores a snapshot of  a full|or partial screen from virtual|screen to the display screen."
     DATA "A version of the ProBas Window|Manager for  use  with virtual|screen arrays."
     DATA "Write (PRINT) a  string  to  a|virtual screen, specifying the|string, the row/column and the|colors.  This is a  version of|XQPRINT for virtual screens."
     DATA "A cute way to clear the screen|using a fadeout."
     DATA "Returns whether the monitor is|color or monochrome."
     DATA "Returns if computer is running|EGA in monochrome or color and|the amount of video memory."
     DATA "Reads a line from  the  screen|and stores it to a string."
     DATA "Finds the  current location of|mouse cursor.  Text mode only.|The MMGETLOC routine works for|both  graphics and  text,  but|requires you to calculate  the|offsets using a formula."
     DATA "Takes a  snapshot of a full or|partial screen and  stores the|data to an array. The CALCSIZE|routine tells you the  minimum|size to DIM the array to."

Menu2Descriptions:
     DATA "Returns the current video mode|including mode, width, and the|active screen page."
     DATA "A BLOAD for compilers that  do|not have BLOAD. Reads graphics|screens from disk."
     DATA "Restores a screen  snapshot of|a graphics screen. Full screen|only.  This  is  the  graphics|version of SCRREST."
     DATA "Saves a snapshot of a graphics|screen. Full screen only. This|is the graphics screen version|of SCRSAVE.  Use the  GRAFREST|routine to restore. "
     DATA "Inserts a char at the  current|cursor position and moves  the|rest of the characters right."
     DATA "Left Scroll.   Scrolls one  or|more columns left."
     DATA "Deletes a char at the  current|cursor position and  pulls the|remaining characters left. The|MWINDOW routine  allows you to|specify the area affected."
     DATA "Inserts a char at the  current|cursor position and pushes the|remaining  characters   right.|The MWINDOW routine allows you|to specify the area affected."
     DATA "Returns which  mouse button is|currently depressed."
     DATA "Returns the number of  buttons|if a mouse is installed.  Sets|the mouse back  to its default|settings."
     DATA "Returns which button has  been|clicked since the routine last|checked."
     DATA "Turns  the mouse  cursor  off."
     DATA "Turns  the  mouse  cursor  on."
     DATA "Returns the  current  location|of the mouse cursor, which can|be 'on' or 'off'.  GETMOUSELOC|performs the same function for|text mode only and  calculates|the offsets automatically."
     DATA "Sets the location of the mouse|cursor."
     DATA "Sets  the area  of the  screen|the mouse  may enter.  Specify|the top and bottom row/column."
     DATA "An expanded but slower version|of DMPRINT that uses DOS calls|so you can access drivers like|ANSI.SYS or CTTY."
     DATA "Allows you to specify a window|on the screen for use with the|MDELCHR, MINSCHR, DMPRINT, and|MPRINT routines."
     DATA "Prints the screen to a printer|just like the Shift-PrtSc  key|combination."

Menu3Descriptions:
     DATA "Restores a snapshot  (full  or|partial screen) taken with the|GETSCREEN or SCRSAVE routines."
     DATA "Changes one set of colors on a|screen to  another without the|need to re-draw the screen."
     DATA "Changes one set of colors in a|specified area for another set|of colors.  Used for highlight|bars and menus."
     DATA "Resets point on a text screen.|The opposite of SETPOINT. This|will allow low-res graphics on|both mono and color screens."
     DATA "Right Scroll.   Scrolls one or|more columns right."
     DATA "Basic subprogram that writes a|virtual screen to a disk file.|This allows  the equivalent of|BSAVE/BLOAD  for text screens,|complete with attributes."
     DATA "The opposite of BKSCROLL, this|allows you to scroll 1 or more|lines within a specified area."
     DATA "Restores a snapshot taken with|either SCRSAVE or GETSCREEN to|the display screen.   Restores|a full screen only."
     DATA "Takes a snapshot of an  entire|screen and stores to a numeric|array."
     DATA "This is the text-only  version|of the  MMSETLOC  routine that|calculates the offsets for you|and sets the mouse location."
     DATA "This is the text-only  version|of the MMSETRANGE routine that|calculates the offsets for you|and sets the mouse range."
     DATA "Sets a point on a text  screen|for low-res (80x50) graphics."
     DATA "Tells if a point was set  with|the SETPOINT routine."
     DATA "Gets a full or partial virtual|screen and moves it to another|virtual screen. Used to create|partial screens like the pull-|down menus on this screen."
     DATA "Puts a  virtual screen  into a|full-sized screen array.  This|provides sophisticated cut and|paste capabilities. VPUTSCREEN|is the opposite of VGETSCREEN."
     DATA "An advanced window  management|routine. You have already seen|many of the routine's features|and  capabilities in  the demo|already.  Both this window and|the pull-down menu to the side|were done with WindowManager."
     DATA "Combines the XLATE and  MPRINT|functions to run  a  character|thru a translation  table then|print it using DOS calls. Will|not print the character if  it|is changed to null by XLATE."
     DATA "Prints directly to the  screen|at high-speed. You specify the|string,  x/y position,  screen|page, and color.  XQPRINT will|check if 'snow suppression' is|needed or you may control snow|suppression manually.  Most of|this demo uses XPRINT."

Menu4Descriptions:
     DATA ""
     DATA "Finds the  current location of|mouse cursor.  Text mode only.|The MMGETLOC routine works for|both  graphics and  text,  but|requires you to calculate  the|offsets using a formula."
     DATA "Returns which  mouse button is|currently depressed."
     DATA "Returns the number of  buttons|if a mouse is installed.  Sets|the mouse back  to its default|settings."
     DATA "Returns which button has  been|clicked since the routine last|checked."
     DATA "Turns  the mouse  cursor  off."
     DATA "Turns  the  mouse  cursor  on."
     DATA "Returns the  current  location|of the mouse cursor, which can|be 'on' or 'off'.  GETMOUSELOC|performs the same function for|text mode only and  calculates|the offsets automatically."
     DATA "Sets the location of the mouse|cursor."
     DATA "Sets  the area  of the  screen|the mouse  may enter.  Specify|the top and bottom row/column."
     DATA "This is the text-only  version|of the  MMSETLOC  routine that|calculates the offsets for you|and sets the mouse location."
     DATA "This is the text-only  version|of the MMSETRANGE routine that|calculates the offsets for you|and sets the mouse range."

Menu5Descriptions:
     DATA "",""
     DATA "Calculates the size to  DIM or|REDIM a  DYNAMIC array for use|as a virtual screen."
     DATA "Clears a virtual screen in the|same manner that  CLS clears a|display screen."
     DATA "Takes a  snapshot of a full or|partial screen and store it to|an array (virtual screen)."
     DATA "Restores a snapshot of  a full|or partial screen from virtual|screen to the display screen."
     DATA "Returns the  data segment  and|offset of an array.  This info|is used by the various virtual|screen routines."
     DATA "Takes a  snapshot of a full or|partial screen and  stores the|data to an array. The CALCSIZE|routine tells you the  minimum|size to DIM the array to."
     DATA "Restores a screen  snapshot of|a graphics screen. Full screen|only.  This  is  the  graphics|version of SCRREST."
     DATA "Saves a snapshot of a graphics|screen. Full screen only. This|is the graphics screen version|of SCRSAVE.  Use the  GRAFREST|routine to restore. "
     DATA "Restores a snapshot  (full  or|partial screen) taken with the|GETSCREEN or SCRSAVE routines."
     DATA "Basic subprogram that writes a|virtual screen to a disk file.|This allows  the equivalent of|BSAVE/BLOAD  for text screens,|complete with attributes."
     DATA "Restores a snapshot taken with|either SCRSAVE or GETSCREEN to|the display screen.   Restores|a full screen only."
     DATA "Takes a snapshot of an  entire|screen and stores to a numeric|array."
     DATA "Gets a full or partial virtual|screen and moves it to another|virtual screen. Used to create|partial screens like the pull-|down menus on this screen."
     DATA "Puts a  virtual screen  into a|full-sized screen array.  This|provides sophisticated cut and|paste capabilities. VPUTSCREEN|is the opposite of VGETSCREEN."

Menu6Descriptions:
     DATA ""
     DATA "This routine is a destructive |backspace.  It's more flexible|than using PRINT CHR$(29)."
     DATA "Clears from the cursor to the |end of the line, fast."
     DATA "Deletes a  character and pulls|the rest of the characters  on|the line left."
     DATA "Display a string using the DOS|calls for output.  This allows|you to use device drivers like|ANSI.SYS, and redirection."
     DATA "Reads a line from  the  screen|and stores it to a string."
     DATA "Inserts a char at the  current|cursor position and moves  the|rest of the characters right."
     DATA "Deletes a char at the  current|cursor position and  pulls the|remaining characters left. The|MWINDOW routine  allows you to|specify the area affected."
     DATA "Inserts a char at the  current|cursor position and pushes the|remaining  characters   right.|The MWINDOW routine allows you|to specify the area affected."
     DATA "An expanded but slower version|of DMPRINT that uses DOS calls|so you can access drivers like|ANSI.SYS or CTTY."
     DATA "Allows you to specify a window|on the screen for use with the|MDELCHR, MINSCHR, DMPRINT, and|MPRINT routines."
     DATA "Prints the screen to a printer|just like the Shift-PrtSc  key|combination."
     DATA "Combines the XLATE and  MPRINT|functions to run  a  character|thru a translation  table then|print it using DOS calls. Will|not print the character if  it|is changed to null by XLATE."

Menu7Descriptions:
     DATA "","",""
     DATA "A version of the ProBas Window|Manager for  use  with virtual|screen arrays."
     DATA "An advanced window  management|routine. You have already seen|many of the routine's features|and  capabilities in  the demo|already.  Both this window and|the pull-down menu to the side|were done with WindowManager."

MouseText:
     DATA "The ProBas routines provide all of"
     DATA "the tools necessary to code highly"
     DATA "sophisticated and  polished screen"
     DATA "or  input  functions  that support"
     DATA "the mouse.   You  can  design  bar"
     DATA "menus, pull down menus, and 'point"
     DATA "and click' routines.  You can even"
     DATA "use the mouse to move a window."
     DATA ""
     DATA "This demo makes  use of the ProBas"
     DATA "mouse routines. If you are using a"
     DATA "mouse,  you can use it to move the"
     DATA "highlight and click a menu choice."
     DATA ""
     DATA "         Press any key."
     DATA ""
     DATA "The routines  that begin with  the"
     DATA "letters  'MM' work with  both text"
     DATA "and graphics display modes."
     DATA ""
     DATA "The  GETMOUSELOC,  SETMOUSELOC and"
     DATA "SETMOUSERANGE  routines are  auto-"
     DATA "mated  versions of  the  MMGETLOC,"
     DATA "MMSETLOC  and  MMSETRANGE routines"
     DATA "for text  mode screens only.  They"
     DATA "automatically  calculate   offsets"
     DATA "and are easier to use."
     DATA ""
     DATA ""
     DATA "         Press any key."

     '--------------------------- misc gosub routines -----------------------

SetBarMouse:
     A=BAR.ROW : B=LMPOS(1) : C=BAR.ROW : D=LMPOS(MAXMENU)       ' use the bar row only
     CALL SETMOUSERANGE(A,B,C,D)                                 ' set the mouse range for the bar row only
     CALL SETMOUSELOC(A,B)                                       ' set the mouse location
     MROW=A : MCOL=B                                             ' set the mouse location variable
     SROW=A : SCOL=B                                             ' set the save mouse location variable
     RETURN

SetMenuMouse:
        IF MENU=0 THEN RETURN
     CALL SETMOUSERANGE(BAR.ROW,ULC(MENU),LRR(MENU),LRC(MENU))   ' set the range to that of the pull-down window
     CALL SETMOUSELOC(ULR(MENU),ULC(MENU))                       ' position the mouse at the first choice
     MROW=ULR(MENU) : MCOL=ULC(MENU)                             ' set the mouse location variable
     SROW=MROW : SCOL=MCOL                                       ' set the save mouse location variable
     MENPOS=ULR(MENU) : MENPOSAVE=MENPOS                         ' save the highlight position
     RETURN

ReColorHighlight:
     CALL CALCATTR(RED,GREY,HIATTR)                              ' the color for the bar highlight
        IF MENU THEN CALL CALCATTR(BLUE,GREY,HIATTR)             ' the color for the menu highlight. I wonder if anyone notices...
     CALL RECOLORAREA(OROW,OLPOS,OROW,ORPOS,HMATTR,PAGE,SCRMODE) ' reset the previous highlighted choice back to normal
     CALL RECOLORAREA(NROW,NLPOS,NROW,NRPOS,HIATTR,PAGE,SCRMODE) ' set the new highlighted choice
     RETURN

PullDownWindow:
     FORE=LRED  : BACK=BLACK : LABEL=WHITE: FRAME=4              ' set the parms
     CALL DWindowManager(DSEG,DOFS,ULR,ULC,LRR,LRC,FRAME,FORE,_
                         BACK,GROW,SHADOW,LABEL,LABEL$)          ' draw window to virtual screen
     CALL CALCATTR(LCYAN,BLACK,ATTR)                             ' set the current color
     HMATTR=ATTR                                                 ' set the main text color
     CALL CALCATTR(BLUE,GREY,HIATTR)                             ' set the highlight color
     RETURN

ClearCommand:
     COLOR GREY,BLACK                                            ' default color
     X=23 : Y=1                                                  ' row 23, column 1
        FOR X=25 TO 23 STEP-1                                    ' do it backwards from row 25...
           LOCATE X,Y,0                                          ' locate the cursor pos with it off
           CALL CLREOL                                           ' clear the line
        NEXT X                                                   ' and end on row 23, column 1, ready to display a prompt
     RETURN

     '------------------- clean up and return to main menu ------------------

Quit:
     GOSUB RestoreScreen                                         ' restore the main menu screen
     RESTART=-1                                                  ' set restart flag
     CHAIN "DEMO"                                                ' do the chain

     '------------------------ standard subroutines -------------------------

SaveScreen:
     XSEG=VARSEG(SCR1(1))
     XOFS=VARPTR(SCR1(1))
     CALL DSCRSAVE(XSEG,XOFS,PAGE,SCRMODE)
     RETURN

RestoreScreen:
     XSEG=VARSEG(SCR1(1))
     XOFS=VARPTR(SCR1(1))
     CALL DSCRREST(XSEG,XOFS,PAGE,SCRMODE)
     RETURN

SaveScreen2:
     XSEG=VARSEG(SCR2(1))
     XOFS=VARPTR(SCR2(1))
     CALL DSCRSAVE(XSEG,XOFS,PAGE,SCRMODE)
     RETURN

RestoreScreen2:
     XSEG=VARSEG(SCR2(1))
     XOFS=VARPTR(SCR2(1))
     CALL DSCRREST(XSEG,XOFS,PAGE,SCRMODE)
     RETURN

SaveScreen3:
     XSEG=VARSEG(SCR3(1))
     XOFS=VARPTR(SCR3(1))
     CALL DSCRSAVE(XSEG,XOFS,PAGE,SCRMODE)
     RETURN

RestoreScreen3:
     XSEG=VARSEG(SCR3(1))
     XOFS=VARPTR(SCR3(1))
     CALL DSCRREST(XSEG,XOFS,PAGE,SCRMODE)
     RETURN

SaveScreen4:
     XSEG=VARSEG(SCR4(1))
     XOFS=VARPTR(SCR4(1))
     CALL DSCRSAVE(XSEG,XOFS,PAGE,SCRMODE)
     RETURN

RestoreScreen4:
     XSEG=VARSEG(SCR4(1))
     XOFS=VARPTR(SCR4(1))
     CALL DSCRREST(XSEG,XOFS,PAGE,SCRMODE)
     RETURN

SaveScreen5:
     XSEG=VARSEG(SCR5(1))
     XOFS=VARPTR(SCR5(1))
     CALL DSCRSAVE(XSEG,XOFS,PAGE,SCRMODE)
     RETURN

RestoreScreen5:
     XSEG=VARSEG(SCR5(1))
     XOFS=VARPTR(SCR5(1))
     CALL DSCRREST(XSEG,XOFS,PAGE,SCRMODE)
     RETURN

Xq:  CALL XQPRINT(A$,X,Y,ATTR,PAGE,SCRMODE)
     RETURN

DXq: CALL DXQPRINT(DSEG,DOFS,A$,X,Y,ATTR)
     RETURN

KeyClick:
        DO                                                       ' loop
              IF NOT CLOCKOFF THEN GOSUB Clock                   ' update time display
           CALL CHECKKEY(MOUSE,CMD,CMD1,LFT,RGT)                 ' check for a keypress or mouse click
           CLICK=(CMD OR CMD1 OR LFT OR MID OR RGT)              ' did we get one? if so, set exit flag
        LOOP UNTIL CLICK                                         ' loop until we get one
     RETURN

Clock:
     ' actually, this routine is a hold-over from
     ' earlier versions of ProBas.  We left it in
     ' just to show one possible way to do your own
     ' "event trapping" without the overhead of
     ' BASIC's trapping.  You could use the ProBas
     ' CLOCK routine to do about the same thing as
     ' this little routine, but without the date
     ' display...
     '
     XX=X : YY=Y : X=25 : Y=72                                   ' save current x/y value and set to new loc
     CALL XQPRINT(TIME$,X,Y,TIMATTR,PAGE,SCRMODE)                ' update the time every loop
     X=XX : Y=YY                                                 ' restore the x/y values
     RETURN                                                      ' tick tock.
