     DEFINT A-Z
     rem $STATIC:
     DIM SCR1(2000),SCR2(2000),SCR3(2000),SCR4(2000)             ' screen arrays
     DIM A$(20)                                                  ' set up an array for text descriptions

     rem $INCLUDE: 'COMDEF.BAS'

     LOCATE 23,1,0                                               ' locate and turn off the cursor
     CALL CALCATTR(MAG,BLACK,TIMATTR)                            ' set the color for the on-screen clock

     '------------------------ input & mouse routines -----------------------

     ' We start this section by saving the current screen
     ' and setting up a full-sized scratch screen.


     GOSUB SaveScreen                                            ' save the main screen for return

     ' When we created our quasi-QuickBASIC screen,
     ' in DEMO2.BAS,  we took a snapshot of it and stored
     ' it in the file SCRTEXT.DAT, with the other text
     ' screens.  Rather than draw the entire screen as we
     ' did in DEMO2.BAS, let's just read the finished screen
     ' in from the file.  This gives you a good idea on how
     ' to store a number of complex screens, such as a
     ' help system with full examples, in a file and
     ' read them in very fast.  On a hard disk system,
     ' the time it takes to read in a screen at ProBas's
     ' assembly language i/o speeds is not noticable.

     DSEG=VARSEG(SCR2(1))                                        ' get segment
     DOFS=VARPTR(SCR2(1))                                        ' get offset
     FIL$="SCRTEXT.DAT"                                          ' file name
     FACCESS=0                                                   ' open for read. 1= write, 2=read/write
     FMODE=0                                                     ' no locking or network
     CALL FOPEN(FIL$,FACCESS,FMODE,HANDLE,ECODE)                 ' open the file and return the file handle
        IF ECODE THEN GOTO FileNoGood                            ' we had an error!
     RECSIZE=4000                                                ' 4000 byte records
     RECNUMBER=9                                                 ' specify record 2
     BYTES=4000                                                  ' 2000 elements = 4000 bytes
     CALL FSETREC(HANDLE,RECSIZE,RECNUMBER)                      ' set the record pointer
     CALL DFREAD(HANDLE,DSEG,DOFS,BYTES,BYTESREAD,ECODE)         ' read the second record
        IF ECODE THEN GOTO FileNoGood                            ' we had an error!
        IF BYTESREAD<>BYTES THEN GOTO FileNoGood                 ' we had an error!

     ' The screen snapshot does not have a bar menu,
     ' so let's add one now...

     rem $DYNAMIC
     REDIM MENU$(4),LMPOS(4),RMPOS(4)                            ' set arrays
     CALL CALCATTR(BLACK,CYAN,ATTR)                              ' set color
        IF MONO THEN CALL CALCATTR(BLACK,GREY,ATTR)              ' if mono then black on white
     RESTORE BarMenuData                                         ' restore data
        FOR I=1 TO 4                                             ' read for 4 choices
           READ MENU$(I)                                         ' menu choice text
           READ LMPOS(I),RMPOS(I)                                ' left col and right col
        NEXT I                                                   ' loop
     MAXMENU=4                                                   ' number of menu choices on bar
     BAR.ROW=1 : X=1                                             ' remember the row the bar menu is on
        FOR I=1 TO 4                                             ' loop thru the choices
           Y=LMPOS(I)+1                                          ' set the location
           A$=MENU$(I) : GOSUB DXq                               ' read and write the choice
        NEXT I                                                   ' keep on truckin'
     Y=6 : CALL CALCATTR(GREY,BLUE,ATTR)                         ' set color and y pos
     RESTORE HelpData                                            ' restore the data
        FOR X=4 TO 16                                            ' loop thru rows
           READ A$ : GOSUB DXq                                    ' reading and writing...
        NEXT X                                                   ' the first section
        IF NOT MOUSE THEN RESTORE HelpData2                      ' if no mouse the get that text
        FOR X=18 TO 20                                           ' loop thru the rest
           READ A$ : GOSUB DXq                                    ' reading and writing more
        NEXT X                                                   ' til done.

     GOSUB RestoreScreen2                                        ' show the screen
        IF MOUSE THEN GOSUB SetUpMouse

     ' The QB screen is now displayed, along with the
     ' intro and help information.  While they're reading
     ' the first word (and we'll be done before they get
     ' to the second),  let's set up the full-sized
     ' scratch screen, and the three virtual screens we'll
     ' need...

     REDIM ULR(4),ULC(4),LRC(4),LRR(4),DSEG(4),DOFS(4)
     REDIM OKR(4),OKL1(4),OKR1(4),OKL2(4),OKR2(4)
     REDIM TOPROW(3),LASTROW(3)

     ULR(1)=4 : ULC(1)=4 : LRR(1)=23 : LRC(1)=36                 ' size window 1
     CALL CALCSIZE(ULR(1),ULC(1),LRR(1),LRC(1),E)                ' set size to dim
     REDIM WIND1(E)
     ULR(2)=4 : ULC(2)=24 : LRR(2)=23 : LRC(2)=56                ' size window 2
     CALL CALCSIZE(ULR(2),ULC(2),LRR(2),LRC(2),E)                ' set size to dim
     REDIM WIND2(E)
     ULR(3)=4 : ULC(3)=45 : LRR(3)=23 : LRC(3)=77                ' size window 3
     CALL CALCSIZE(ULR(3),ULC(3),LRR(3),LRC(3),E)                ' set size to dim
     REDIM WIND3(E)
     ULR(4)=7 : ULC(4)=20 : LRR(4)=15 : LRC(4)=61                ' size window 4
     CALL CALCSIZE(ULR(4),ULC(4),LRR(4),LRC(4),E)                ' set size to dim
     REDIM WIND4(E)

     ' in newer versions of QB, it is important
     ' to get all of the DIMs out of the way before
     ' using the technique of putting the segment
     ' and offsets in an array.  DIMs and REDIMs
     ' cause arrays to move in memory, and the
     ' DSEG(x) and DOFS(x) will no longer point to
     ' the proper area -- a nasty business indeed!

     DSEG=VARSEG(SCR3(1))                                        ' get segment
     DOFS=VARPTR(SCR3(1))                                        ' get offset
     DSEG(1)=VARSEG(WIND1(1))                                    ' get segment of virtual screen 1
     DOFS(1)=VARPTR(WIND1(1))                                    ' get offset
     DSEG(2)=VARSEG(WIND2(1))                                    ' get segment of virtual screen 2
     DOFS(2)=VARPTR(WIND2(1))                                    ' get offset
     DSEG(3)=VARSEG(WIND3(1))                                    ' get segment of virtual screen 3
     DOFS(3)=VARPTR(WIND3(1))                                    ' get offset
     DSEG(4)=VARSEG(WIND4(1))                                    ' get segment of virtual screen 4
     DOFS(4)=VARPTR(WIND4(1))                                    ' get offset

     ' Instead of using pull-down menus (i'm getting bored
     ' with them) we'll draw some windows instead.  We'll
     ' put them into a GOSUB to make the code easier to
     ' follow.

     GOSUB MakeWindows

     ' We're now ready to get the input and continue...

     '------------------------------ main command ---------------------------

MainCom:                                                         ' the main keyboard/mouse input routine
     CLICK=0                                                     ' clear the flag
        WHILE NOT CLICK                                          ' wait for a keypress or a mouse click
           CALL CHECKKEY(MOUSE,CMD,CMD1,LFT,RGT)                 ' check for keypress or mouse click
           IF MOUSE THEN GOSUB Mouse                             ' check to see if the mouse has been moved
           IF CMD<>0 OR CMD1<>0 OR LFT<>0 OR RGT<>0 THEN CLICK=-1' if a keypress or mouse click then exit the while/wend loop
        WEND                                                     ' keep on truckin'
        IF CMD1=37 THEN BARPOS=1:GOSUB DisplayMenu:GOTO MainCom  ' Alt-K menu
        IF CMD1=50 THEN BARPOS=2:GOSUB DisplayMenu:GOTO MainCom  ' Alt-M menu
        IF CMD1=48 THEN BARPOS=3:GOSUB DisplayMenu:GOTO MainCom  ' Alt-B menu
        IF CMD1=16 THEN GOTO Quit                                ' Alt-Q (quit)
        IF LFT<>0 AND MENU<>0 THEN GOTO CheckClick               ' left click
        IF CMD=13 AND MENU<>0 THEN GOTO CheckClick               ' enter key
        IF CMD=68 OR CMD=100  THEN GOSUB MenuDemo:GOTO MainCom   ' letter D
        IF CMD=67 OR CMD=99 THEN IF MENU<>0 THEN GOTO CloseMenuWindow ' letter C
        IF CMD1=80 AND DEMO THEN GOSUB MoveHiDown: GOTO MainCom  ' down arrow  - move highlight down in menu
        IF CMD1=72 AND DEMO THEN GOSUB MoveHiUp  : GOTO MainCom  ' up arrow    - move highlight up in menu
        IF CMD=27  AND MENU<>0 THEN GOTO CloseMenuWindow         ' exit menu window
        IF CMD=27 THEN GOTO Quit                                 ' if ESC then end
     GOTO MainCom                                                ' keep checking for input

Mouse:
     CALL GETMOUSELOC(MROW,MCOL)                                 ' get the current mouse location
        IF MROW=SROW AND MCOL=SCOL THEN RETURN                   ' the mouse has not moved since we last checked
        IF MENU<>0 THEN GOTO MenuMouse                           ' we have a menu active so we're not on the bar
        IF MROW=BAR.ROW THEN GOTO BarMouse                       ' remember that NOT MENU only works if MENU=-1
     RETURN

BarMouse:
     CALL MMBUTTON(LBUT,RBUT)
     BARPOS=0 : MENU=0
        WHILE LBUT<>0 AND MROW=BAR.ROW
           CALL GETMOUSELOC(MROW,MCOL)                           ' get the current mouse location
           FOR I=1 TO MAXMENU
              IF MCOL=>LMPOS(I) AND MCOL<=RMPOS(I) THEN BARPOS=I
           NEXT I
           IF BARPOS<>MENU THEN GOSUB DisplayMenu
        WEND
     RETURN

MenuMouse:
        IF NOT DEMO THEN RETURN
        IF MROW<TOPROW(MENU) OR MROW>LASTROW(MENU) THEN RETURN
        IF MROW>MENPOS+OFFSET THEN GOSUB MoveHiDown: RETURN      ' mouse moved down 1 row or more
        IF MROW<MENPOS+OFFSET THEN GOSUB MoveHiUp  : RETURN      ' mouse moved up 1 row or more
     RETURN

CheckClick:
        IF MROW=OKR(MENU) THEN IF MCOL=>OKL2(MENU) AND MCOL<=OKR2(MENU)_
           THEN GOTO CloseMenuWindow
        IF DEMO=0 AND MROW=OKR(MENU) THEN IF MCOL=>OKL1(MENU)_
            AND MCOL<=OKR2(MENU) THEN GOSUB MenuDemo : GOTO MainCom
        IF DEMO THEN GOTO DoTheDemo
     GOTO MainCom

DisplayMenu:
     MENU=BARPOS
        IF MENU=4 THEN GOTO Quit
        IF MENU<>MENUSAVE THEN GOSUB RestoreScreen2
     DSEG=DSEG(MENU)                                             ' pull the data seg...
     DOFS=DOFS(MENU)                                             ' and offset from storage array
     CALL CALCATTR(CYAN,BLACK,HIATTR)                            ' set bar highlight  color
     A=ULR(MENU) : B=ULC(MENU) : C=LRR(MENU) : D=LRC(MENU)       ' position of the virtual window on screen
        IF MOUSE THEN CALL MMCURSOROFF                           ' turn mouse cursor off for screen draw
     CALL DPUTSCREEN(DSEG(MENU),DOFS(MENU),A,B,C,D,PAGE,SCRMODE) ' ship menu from virtual to active screen
     CALL RECOLORAREA(BAR.ROW,LMPOS(MENU),BAR.ROW,RMPOS(MENU),HIATTR,PAGE,SCRMODE)   ' highlight choice
        IF MOUSE THEN CALL MMCURSORON                            ' turn mouse cursor back on
     MENUSAVE=MENU
        IF MOUSE THEN RETURN
     X=25 : CALL CALCATTR(BLACK,GREEN,ATTR)
     A$=" Press D for a demo or C to exit the window "
     Y=40-LEN(A$)\2 : GOSUB Xq
     RETURN

MenuDemo:
     GOSUB SaveScreen4
     CALL CALCATTR(LCYAN,BLACK,HIATTR)
     CALL CALCATTR(BLUE,GREY,HMATTR)
     Y=LRC(MENU)+3
        IF MENU=3 THEN Y=ULC(MENU)-20
     A=10 : B=Y-1 : C=15 : D=B+19
     FORE=BLACK : BACK=GREEN : FRAME=2
     LABEL=YELLOW : LABEL$="Help"
     CALL WindowManager(A,B,C,D,FRAME,FORE,BACK,_
                        GROW,SHADOW,LABEL,LABEL$,PAGE,SCRMODE)
     CALL CALCATTR(WHITE,GREEN,ATTR)
     X=10 : A$="Use the arrow keys" : GOSUB Xq
     X=11 : A$="or  the  mouse  to" : GOSUB Xq
     X=12 : A$="highlight  one  of" : GOSUB Xq
     X=13 : A$="the  routines  and" : GOSUB Xq
     X=14 : A$="click or press any" : GOSUB Xq
     X=15 : A$="key." : GOSUB Xq
     OFFSET=TOPROW(MENU)-1
     MENPOS=1 : MENPOSAVE=1
     OROW=MENPOSAVE+OFFSET
     NROW=MENPOS+OFFSET
     OLPOS=ULC(MENU)+2 : ORPOS=LRC(MENU)-2                       ' set the old left and right columns
     NLPOS=ULC(MENU)+2 : NRPOS=LRC(MENU)-2                       ' set the new left and right columns
     GOSUB ReColorHighlight                                      ' move the highlight
     MROW=NROW : MCOL=NLPOS+1 : SROW=MROW : SCOL=MCOL            ' set the mouse loc
        IF MOUSE THEN CALL SETMOUSELOC(MROW,MCOL)
     MENPOSAVE=MENPOS                                            ' reset the pointer
     DEMO=-1                                                     ' set flag
     RETURN

MoveHiDown:
        IF MENPOS+OFFSET = LASTROW(MENU) THEN RETURN             ' we are at the bottom menu choice
     MENPOS=MENPOS+1                                             ' increment the pointer
     OROW=MENPOSAVE+OFFSET                                       ' set the old position
     NROW=MENPOS+OFFSET                                          ' set the new position
     OLPOS=ULC(MENU)+2 : ORPOS=LRC(MENU)-2                       ' set the left and right columns
     NLPOS=ULC(MENU)+2 : NRPOS=LRC(MENU)-2                       ' old and new...
     GOSUB ReColorHighlight                                      ' move the highlight
     MENPOSAVE=MENPOS                                            ' reset the pointer to the current position
        IF MOUSE THEN                                            ' set mouse
           MROW=NROW : MCOL=NLPOS
           SROW=MROW : SCOL=MCOL
           CALL SETMOUSELOC(MROW,MCOL)
        END IF
     RETURN                                                      ' done

MoveHiUp:
        IF MENPOS=1 THEN RETURN
     MENPOS=MENPOS-1                                             ' decrement the pointer
     OROW=MENPOSAVE+OFFSET                                       ' set the old position
     NROW=MENPOS+OFFSET                                          ' set the new position
     OLPOS=ULC(MENU)+2 : ORPOS=LRC(MENU)-2                       ' set the old left and right columns
     NLPOS=ULC(MENU)+2 : NRPOS=LRC(MENU)-2                       ' set the new left and right columns
     GOSUB ReColorHighlight                                      ' move the highlight
     MENPOSAVE=MENPOS                                            ' reset the pointer
        IF MOUSE THEN                                            ' set mouse
           MROW=NROW : MCOL=NLPOS
           SROW=MROW : SCOL=MCOL
           CALL SETMOUSELOC(MROW,MCOL)
        END IF
     RETURN                                                      ' done

CloseMenuWindow:
     MENU=0 : DEMO=0
     GOSUB RestoreScreen2
     GOTO MainCom

DoTheDemo:
    ON MENU GOTO Menu1,Menu2,Menu3,Quit

Menu1:
     GOSUB SaveScreen4
     RESTORE Menu1Descriptions
     GOSUB GetAndDisplayText
     GOTO MainCom

Menu2:
     GOSUB SaveScreen4
     RESTORE Menu2Descriptions
     GOSUB GetAndDisplayText
     GOTO MainCom

Menu3:
     GOSUB SaveScreen4
     RESTORE Menu3Descriptions
     GOSUB GetAndDisplayText
     GOTO MainCom

     '---------------- get and display menu choice descriptions -------------

GetAndDisplayText:
     TABLE$=""                                                   ' clear the string
        FOR I=0 TO 255                                           ' loop thru the full ASCII set
           TABLE$=TABLE$+CHR$(I)                                 ' assigning a character to string in
        NEXT I                                                   ' the proper position
     MID$(TABLE$,95,1)=CHR$(34)                                  ' now set the " character to a ^
     MORE=0 : HI=0                                               ' clear flags
        FOR J=1 TO MENPOS                                        ' read thru the data statements...
           READ A$,A1$                                           ' til we reach the one we want...
        NEXT J                                                   ' now we have it!
        IF LEN(A$)=0 OR LEN(A1$)=0 THEN GOTO Gad                 ' error - nothing there!
     CALL XLATE(A$,TABLE$)                                       ' translate a$
     CALL XLATE(A1$,TABLE$)                                      ' translate a1$

     ' at the top of the program we set up a 20 element
     ' array in A$(20).  We'll use it here...

     SLEN=1 : INDEX=0                                            ' set/clear pointers
     DELIM$="|"                                                  ' specify the delimiter
        WHILE SLEN>0                                             ' loop
           INDEX=INDEX+1                                         ' increment the pointer
           CALL EXTRACT(A$,DELIM$,INDEX,ST,SLEN)                 ' do the call
           A$(INDEX)=MID$(A$,ST,SLEN)                            ' load the delimited string into array
        WEND                                                     ' loop til done
     COUNT=INDEX-1 : HI=COUNT+1                                  ' save count and where to start highlight color
     SLEN=1 : INDEX=0                                            ' clear the flags and pointers
        WHILE SLEN>0                                             ' loop
           INDEX=INDEX+1                                         ' increment the pointer
           COUNT=COUNT+1                                         ' increment the total index pointer
           CALL EXTRACT(A1$,DELIM$,INDEX,ST,SLEN)                ' do the call
           A$(COUNT)=MID$(A1$,ST,SLEN)                           ' load the delimited string into array
        WEND                                                     ' loop til done
     INDEX=COUNT
        IF MOUSE THEN CALL MMCURSOROFF
     UR=15 : UC=4 : LR=UR+INDEX-2 : LC=76                        ' use different variables so we don't mess up the menu vars!
        IF LR>24 THEN UR=25-INDEX : LR=UR+INDEX-2 : X=UR         ' make sure the window stays on the screen
     F=YELLOW : B=RED : FR=2 :                                   ' set the colors and frame
     CALL WindowManager(UR,UC,LR,LC,FR,F,B,_
                        GROW,SHADOW,LABEL,LABEL$,PAGE,SCRMODE)   ' draw the window
     SCRMODE=SS : SS=0                                           ' reset the screen mode (fast/slow)
     CALL CALCATTR(WHITE,RED,ATTR)                               ' set the color for the text in the window
     X=UR : Y=UC+1
        FOR J=1 TO INDEX                                         ' loop thru the array
           IF J=HI THEN CALL CALCATTR(GREY,RED,ATTR)                               ' set the color for the text in the window
           A$=A$(J) : GOSUB Xq                                   ' write the text
           X=X+1                                                 ' increment the row pointer for text
        NEXT J                                                   ' loop til done
     CLICK=0                                                     ' clear the flag
        WHILE NOT CLICK                                          ' wait for a key or click...
        CALL CHECKKEY(MOUSE,CMD,CMD1,LFT,RGT)                    ' in a little loop...
           IF CMD<>0 OR CMD1<>0 OR LFT<>0 OR RGT<>0 THEN CLICK=-1' and the time won't droop.
        WEND                                                     ' poetic, ain't I? (gag!)
     GOSUB RestoreScreen4                                        ' restore the screen snapshot
GaD: ERASE A$:A$="":A1$="":DELIM$="":INDEX=0:ST=0:SLEN=0:J=0     ' clear all these garbage variables
     L=0:R=0:UR=0:UC=0:LR=0:LC=0:F=0:B=0:FR=0:COUNT=0:HI=0       ' clear these too, they're disposable
        IF MOUSE THEN CALL MMCURSORON
     RETURN                                                      ' we're all done here

     '--------------------------- data statements ---------------------------

BarMenuData:
     DATA "Keyboard",2,11
     DATA "Mouse",12,18
     DATA "Both",19,24
     DATA "Quit",25,30

HelpData:
     DATA "BASIC's INPUT and INKEY statements have some major drawbacks that you"
     DATA "are probably well aware of such as the  infamous Ctrl-Break, allowing"
     DATA "the user to edit input when you don't want them to, and of course, no"
     DATA "way to get input from a mouse.
     DATA ""
     DATA "ProBas solves these problems with a number of low-level routines that"
     DATA "allow you to get input via DOS,  directly from the keyboard's buffer,"
     DATA "from the mouse, or from the keyboard and the mouse together."
     DATA ""
     DATA "Some routines will wait for input, much like doing a WHILE/WEND loop,"
     DATA "and others check without waiting so that you can build your own loop."
     DATA "With a little thought, you can use the  ProBas routines to  eliminate"
     DATA "high overhead input routines like Basic's KEY and ON KEY commands."
     DATA "Use the mouse to select a choice on a menu or sub-menu.","",""

HelpData2:
     DATA "Since there is no mouse installed, press Alt-K, Alt-M, Alt-B or Alt-Q"
     DATA "to select a choice on the menu.  Use the arrow keys  in the sub-menu."
     DATA "Press the letter D or C for DEMO or CANCEL."

Menu1Data:
     DATA 6
     DATA "CLRKBD"
     DATA "DOSINKEY"
     DATA "GETKBD"
     DATA "SETKBD"
     DATA "KEYPRESS"
     DATA "GETVALIDKEY"

Menu2Data:
      DATA 10
      DATA "MMCURSORON"
      DATA "MMCURSOROFF"
      DATA "MMSETRANGE"
      DATA "MMSETLOC"
      DATA "MMGETLOC"
      DATA "MMCLICK"
      DATA "MMBUTTON"
      DATA "SETMOUSERANGE"
      DATA "SETMOUSELOC"
      DATA "GETMOUSELOC"

Menu3Data:
     DATA 2
     DATA "GETKEY"
     DATA "CHECKKEY"

     '------------------------------ descriptions ---------------------------

Menu1Descriptions:
     DATA "Clears the keyboard buffer of any pending keystrokes. Useful for error|trapping or command confirmations."
     DATA " |Example:|CALL CLRKBD"
     DATA "Returns a key  from the  standard input device.   This is normally the|keyboard, but redirection is allowed, such as to a file or port."
     DATA " |Example:|CHRTYPE = 0|WHILE CHRTYPE=0|   CALL DOSINKEY(CHRCODE,CHRTYPE)|WEND|KY$=CHR$(CHRCODE)|IF CHRTYPE=2 THEN EXTCODE=-1"
     DATA "Returns the status of the keyboard toggles.  The variable will  be set|if the toggle is on, and reset if it is off."
     DATA " |Example:|CALL GETKBD(INSERT,CAPSLOCK,NUMLOCK,SCROLLLOCK)"
     DATA "Sets the keyboard  toggles.  The toggle is set on if  the the value is|non-zero."
     DATA " |Example:|CALL SETKBD(INSERT,CAPSLOCK,NUMLOCK,SCROLLLOCK)"
     DATA "Tells you if a key is waiting in the keyboard buffer.  Variable is set|to non-zero if a key is waiting or cleared otherwise."
     DATA " |Example:|100 CALL KEYPRESS(KYHIT)|    IF KYHIT THEN KY$=INKEY$ ELSE 100"
     DATA "Waits until one of a list of valid keys is pressed, and returns it. If|the keylist is null, the first key pressed will be returned."
     DATA " |Example:|PRINT ^Try again? (Y/N)^;|GOODKEY$=^YN^:KY$=^ ^|CALL GETVALIDKEY(GOODKEY$,KY$)|rem - KY$ will contain either a Y or an N."

Menu2Descriptions:
     DATA "Turns the mouse cursor on.  While this does not return any user input,|it is associated with input routines, hence its inclusion here."
     DATA " |Example:|CALL MMCURSORON"
     DATA "Turns the mouse cursor off."
     DATA " |Example:|CALL MMCURSOROFF"
     DATA "Sets the area of the screen the  mouse may enter.   Use this  to limit|the area to a pull-down menu for example.   This routine  requires you|to compute the  locations  using  a formula based on the  screen mode.|Example is 25x80 text mode."
     DATA " |Example:|ULCOL=TOPCOL*8-8 : ULROW=TOPROW*8-8|LRCOL=BOTCOL*8-8 : LRROW=BOTROW*8-8|CALL MMSETRANGE(ULCOL,ULROW,LRCOL,LRROW)|rem -- See SETMOUSERANGE"
     DATA "Sets the location of the mouse cursor.  Use this to move the  mouse to|a specified location on the screen.   You must compute  the row/column|locations using a formula based on the screen mode. The example is for|25x80 text mode."
     DATA " |Example:|ULCOL=TOPCOL*8-8 : ULROW=TOPROW*8-8|CALL MMSETLOC(ULCOL,ULROW)|rem -- See SETMOUSELOC"
     DATA "Returns the current location of the mouse cursor. The routine requires|you to compute the locations using a formula based on screen mode. The|example is for low-res graphics mode."
     DATA " |Example:|ULCOL=TOPCOL*2-2 : ULROW=TOPROW*2-2|CALL MMGETLOC(ULCOL,ULROW)|rem -- See GETMOUSELOC"
     DATA "Returns which mouse buttons have been clicked  and the number of times|each was clicked since the routine was last run.  The  MMCLICK routine|is incorporated into the GETKEY and CHECKKEY routines."
     DATA " |Example:|CALL MMCLICK(LBUTTON,RBUTTON)"
     DATA "Returns which mouse button,  if any, is currently being depressed. The|Value is set to non-zero if depressed or cleared if not depressed."
     DATA " |Example:|CALL MMBUTTON(LBUTTON,RBUTTON)"
     DATA "A text-mode only  version of MMSETRANGE that  computes the  offset for|you automatically. Easier to use since the computation is already done|and the arguments are in row/column rather than column/row format."
     DATA " |Example:|TOPROW=5 : TOPCOL=10 : BOTROW=15 : BOTCOL=40|CALL SETMOUSERANGE(TOPROW,TOPCOL,BOTROW,BOTCOL)"
     DATA "A text-mode only version of MMSETLOC that computes the offsets for you|automatically.  Easier to use than MMSETLOC in text mode."
     DATA " |Example:|ROW=5 : COL=10|CALL SETMOUSELOC(ROW,COL)"
     DATA "A text-mode only version of MMGETLOC that computes the offsets for you|automatically.  Easier to use than MMGETLOC in text mode."
     DATA " |Example:|CALL GETMOUSELOC(ROW,COL)"

Menu3Descriptions:
     DATA "A handy all-purpose routine to  check both the keyboard buffer and the|mouse.  Waits until a key is pressed or a mouse button is clicked. The|keyboard input is taken from the keyboard buffer, the mouse click from|an internal MMCLICK."
     DATA " |Example:|rem - set MOUSE to non-zero to check for mouse clicks|CALL GETKEY(MOUSE,CHAR,SCAN,LBUT,RBUT)|rem - returns both character and extended codes"
     DATA "A version of GETKEY that does  not wait until a key or mouse button is|pressed or clicked to return.  Use this  when you want to  create your|own input loops."
     DATA " |Example:|WHILE CHAR=0 AND SCAN=0 AND LBUT=0 AND RBUT=0|   CALL CHECKKEY(MOUSE,CHAR,SCAN,LBUT,RBUT)|   CALL GETMOUSELOC(ROW,COL)|   GOSUB Clock|WEND"

     '--------------------------- draw the windows --------------------------

MakeWindows:
     ULR=ULR(1)+1:ULC=ULC(1)+1:LRR=LRR(1)-1:LRC=LRC(1)-1         ' allow for the frame!
     FRAME=2 : FORE=RED : BACK=GREY : LABEL=BLUE
     LABEL$="Keyboard Input"
     GOSUB DWindowManager
     Y=ULC+1: CALL CALCATTR(BLUE,GREY,ATTR)
     X=ULR+1: A$="ProBas contains a  number of" : GOSUB DXq
     X=X+1  : A$="keyboard routines.   Some of" : GOSUB DXq
     X=X+1  : A$="these deal with the mouse as" : GOSUB DXq
     X=X+1  : A$="well.  These ProBas routines" : GOSUB DXq
     X=X+1  : A$="deal with the keyboard only:" : GOSUB DXq
     Y=Y+9  : X=X+2
     RESTORE Menu1Data
     READ CHOICES
     TOPROW(1)=X : LASTROW(1)=X+CHOICES-1
        FOR I=1 TO CHOICES
           READ A$ : GOSUB DXq
           X=X+1
        NEXT I

     ULR=21 : ULC=ULC+3 : LRR=21 : LRC=ULC+7
     FRAME=1: FORE=BLUE : BACK=GREY
     GOSUB DWindowManager
     OKR(1)=ULR : OKL1(1)=ULC : OKR1(1)=LRC
     X=ULR : Y=ULC+2 : A$="DEMO" : GOSUB DXq

     ULR=21 : ULC=ULC+17 : LRR=21 : LRC=ULC+7
     FRAME=2: FORE=RED : BACK=GREY
     GOSUB DWindowManager
     OKL2(1)=ULC : OKR2(1)=LRC
     CALL CALCATTR(RED,GREY,ATTR)
     X=ULR : Y=ULC+1 : A$="CANCEL" : GOSUB DXq
     CALL VGETSCREEN(DSEG,DOFS,ULR(1),ULC(1),LRR(1),LRC(1),DSEG(1),DOFS(1))

MakeWindow2:
     ULR=ULR(2)+1:ULC=ULC(2)+1:LRR=LRR(2)-1:LRC=LRC(2)-1         ' allow for the frame!
     FRAME=2 : FORE=RED : BACK=GREY : LABEL=BLUE
     LABEL$="Mouse Input"
     GOSUB DWindowManager
     Y=ULC+1: CALL CALCATTR(BLUE,GREY,ATTR)
     X=ULR  : A$="ProBas contains a  number of" : GOSUB DXq
     X=X+1  : A$="mouse routines  that control" : GOSUB DXq
     X=X+1  : A$="the mouse cursor,  position," : GOSUB DXq
     X=X+1  : A$="and input (buttons).        " : GOSUB DXq
     Y=Y+8  : X=X+2
     RESTORE Menu2Data
     READ CHOICES
     TOPROW(2)=X : LASTROW(2)=X+CHOICES-1
        FOR I=1 TO CHOICES
           READ A$ : GOSUB DXq
           X=X+1
        NEXT I

     ULR=21 : ULC=ULC+3 : LRR=21 : LRC=ULC+7
     FRAME=1: FORE=BLUE : BACK=GREY
     GOSUB DWindowManager
     OKR(2)=ULR : OKL1(2)=ULC : OKR1(2)=LRC
     X=ULR : Y=ULC+2 : A$="DEMO" : GOSUB DXq

     ULR=21 : ULC=ULC+17 : LRR=21 : LRC=ULC+7
     FRAME=2: FORE=RED : BACK=GREY
     GOSUB DWindowManager
     OKL2(2)=ULC : OKR2(2)=LRC
     CALL CALCATTR(RED,GREY,ATTR)
     X=ULR : Y=ULC+1 : A$="CANCEL" : GOSUB DXq
     CALL VGETSCREEN(DSEG,DOFS,ULR(2),ULC(2),LRR(2),LRC(2),DSEG(2),DOFS(2))

MakeWindow3:
     ULR=ULR(3)+1:ULC=ULC(3)+1:LRR=LRR(3)-1:LRC=LRC(3)-1         ' allow for the frame!
     FRAME=2 : FORE=RED : BACK=GREY : LABEL=BLUE
     LABEL$="Keyboard & Mouse"
     GOSUB DWindowManager
     Y=ULC+1: CALL CALCATTR(BLUE,GREY,ATTR)
     X=ULR+1: A$="There are two input routines" : GOSUB DXq
     X=X+1  : A$="that deal  with the keyboard" : GOSUB DXq
     X=X+1  : A$="and/or the mouse.  They will" : GOSUB DXq
     X=X+1  : A$="return which key was pressed" : GOSUB DXq
     X=X+1  : A$="or  which mouse  button  was" : GOSUB DXq
     X=X+1  : A$="clicked." : GOSUB DXq
     Y=Y+9  : X=X+2
     RESTORE Menu3Data
     READ CHOICES
     TOPROW(3)=X : LASTROW(3)=X+CHOICES-1
        FOR I=1 TO CHOICES
           READ A$ : GOSUB DXq
           X=X+1
        NEXT I
     Y=Y-9
     X=X+2  : A$="The  routines  can  be  used" : GOSUB DXq
     X=X+1  : A$="when no mouse is installed. " : GOSUB DXq

     ULR=21 : ULC=ULC+3 : LRR=21 : LRC=ULC+7
     FRAME=1: FORE=BLUE : BACK=GREY
     GOSUB DWindowManager
     OKR(3)=ULR : OKL1(3)=ULC : OKR1(3)=LRC
     X=ULR : Y=ULC+2 : A$="DEMO" : GOSUB DXq

     ULR=21 : ULC=ULC+17 : LRR=21 : LRC=ULC+7
     FRAME=2: FORE=RED : BACK=GREY
     GOSUB DWindowManager
     OKL2(3)=ULC : OKR2(3)=LRC
     CALL CALCATTR(RED,GREY,ATTR)
     X=ULR : Y=ULC+1 : A$="CANCEL" : GOSUB DXq
     CALL VGETSCREEN(DSEG,DOFS,ULR(3),ULC(3),LRR(3),LRC(3),DSEG(3),DOFS(3))

MakeWindow4:
     ULR=ULR(4)+1:ULC=ULC(4)+1:LRR=LRR(4)-1:LRC=LRC(4)-1         ' allow for the frame!
     FRAME=2 : FORE=RED : BACK=GREY : LABEL=BLUE
     LABEL$="Quit"
     GOSUB DWindowManager
     Y=ULC+1: CALL CALCATTR(BLUE,GREY,ATTR)
     X=ULR+1: A$="Please confirm exiting this module and" : GOSUB DXq
     X=X+1  : A$="returning to the main menu:" : GOSUB DXq

     ULR=ULR(4)+6 : ULC=ULC+6 : LRR=ULR : LRC=ULC+7
     FRAME=1: FORE=BLUE : BACK=GREY
     GOSUB DWindowManager
     OKR(4)=ULR : OKL1(4)=ULC : OKR1(4)=LRC
     X=ULR : Y=ULC+3 : A$="Ok" : GOSUB DXq

     ULR=ULR(4)+6 : ULC=ULC+20 : LRR=ULR : LRC=ULC+7
     FRAME=2: FORE=RED : BACK=GREY
     GOSUB DWindowManager
     OKL2(4)=ULC : OKR2(4)=LRC
     CALL CALCATTR(RED,GREY,ATTR)
     X=ULR : Y=ULC+1 : A$="CANCEL" : GOSUB DXq
     CALL VGETSCREEN(DSEG,DOFS,ULR(4),ULC(4),LRR(4),LRC(4),DSEG(4),DOFS(4))
     RETURN

     '--------------------------- misc gosub routines -----------------------

DWindowManager:
     CALL DWindowManager(DSEG,DOFS,ULR,ULC,LRR,LRC,FRAME,FORE,_
                         BACK,GROW,SHADOW,LABEL,LABEL$)
     RETURN

WindowManager:
     CALL WindowManager(ULR,ULC,LRR,LRC,FRAME,FORE,BACK,_
                        GROW,SHADOW,LABEL,LABEL$,PAGE,SCRMODE)
     RETURN

ReColorHighlight:
        IF MOUSE THEN CALL MMCURSOROFF
     CALL RECOLORAREA(OROW,OLPOS,OROW,ORPOS,HMATTR,PAGE,SCRMODE) ' reset the previous highlighted choice back to normal
     CALL RECOLORAREA(NROW,NLPOS,NROW,NRPOS,HIATTR,PAGE,SCRMODE) ' set the new highlighted choice
        IF MOUSE THEN CALL MMCURSORON
     HIGHLIGHT=NROW
     RETURN

SetUpMouse:
     CALL SETMOUSERANGE(1,1,25,80)
     MROW=4 : MCOL=4
     CALL SETMOUSELOC(MROW,MCOL)
     SROW=MROW : SCOL=MCOL
     CALL MMCURSORON
     RETURN

     '------------------- clean up and return to main menu ------------------

Quit:
     GOSUB RestoreScreen2
     Z=4 : A=ULR(Z) : B=ULC(Z) : C=LRR(Z) : D=LRC(Z)
     CALL DPUTSCREEN(DSEG(Z),DOFS(Z),A,B,C,D,PAGE,SCRMODE)       ' ship menu from virtual to active screen
     CALL CLRKBD                                                 ' clear the keyboard buffer
Q1:  CALL GETKEY(MOUSE,CMD,CMD1,LFT,RGT)                         ' get key or click
        IF MOUSE THEN CALL GETMOUSELOC(MROW,MCOL)                ' get loc
        IF CMD=27 OR CMD=13  THEN GOTO Quit1                     ' esc - exit
        IF CMD=79 OR CMD=111 THEN GOTO Quit1                     ' O for Ok - exit
        IF MOUSE AND MROW=OKR(Z) THEN_
           IF MCOL=>OKL1(Z) AND MCOL<=OKR1(Z)_
           THEN GOTO Quit1                                       ' mouse in ok box - exit
        IF CMD=67 OR CMD=99 THEN GOTO NoQuit                     ' C for Cancel - no exit
        IF MOUSE AND MROW=OKR(Z) THEN_
           IF MCOL=>OKL2(Z) AND MCOL<=OKR2(Z) THEN GOTO NoQuit   ' mouse in cancel box - no exit
     GOTO Q1

Quit1:
        IF MOUSE THEN CALL MMCURSOROFF
     GOSUB RestoreScreen                                         ' restore the main menu screen
     RESTART=-1                                                  ' set restart flag
     CHAIN "DEMO"                                                ' do the chain

NoQuit:
     GOSUB RestoreScreen2
     MENU=0 : DEMO=0
     GOTO MainCom

     '------------------------ standard sub-routines ------------------------

SaveScreen:
     CALL DSCRSAVE(VARSEG(SCR1(1)),VARPTR(SCR1(1)),PAGE,SCRMODE)
     RETURN

RestoreScreen:
     CALL DSCRREST(VARSEG(SCR1(1)),VARPTR(SCR1(1)),PAGE,SCRMODE)
     RETURN

SaveScreen2:
        IF MOUSE THEN CALL MMCURSOROFF
     CALL DSCRSAVE(VARSEG(SCR2(1)),VARPTR(SCR2(1)),PAGE,SCRMODE)
        IF MOUSE THEN CALL MMCURSORON
     RETURN

RestoreScreen2:
        IF MOUSE THEN CALL MMCURSOROFF
     CALL DSCRREST(VARSEG(SCR2(1)),VARPTR(SCR2(1)),PAGE,SCRMODE)
        IF MOUSE THEN CALL MMCURSORON
     RETURN

SaveScreen3:
     CALL DSCRSAVE(VARSEG(SCR3(1)),VARPTR(SCR3(1)),PAGE,SCRMODE)
     RETURN

RestoreScreen3:
     CALL DSCRREST(VARSEG(SCR3(1)),VARPTR(SCR3(1)),PAGE,SCRMODE)
     RETURN

SaveScreen4:
        IF MOUSE THEN CALL MMCURSOROFF
     CALL DSCRSAVE(VARSEG(SCR4(1)),VARPTR(SCR4(1)),PAGE,SCRMODE)
        IF MOUSE THEN CALL MMCURSORON
     RETURN

RestoreScreen4:
        IF MOUSE THEN CALL MMCURSOROFF
     CALL DSCRREST(VARSEG(SCR4(1)),VARPTR(SCR4(1)),PAGE,SCRMODE)
        IF MOUSE THEN CALL MMCURSORON
     RETURN

Xq:  CALL XQPRINT(A$,X,Y,ATTR,PAGE,SCRMODE)
     RETURN

DXq: CALL DXQPRINT(DSEG,DOFS,A$,X,Y,ATTR)
     RETURN

FileNoGood:
     LOCATE 23,1,0
     COLOR GREY,BLACK
     PRINT "   Error!  Unable to open the data file.  Press any key:";
     CALL GETKEY(MOUSE,CMD,CMD1,LFT,RGT)
     GOTO Quit
